(get-info :version)
; (:version "4.5.1 - build hashcode f3a0b7e0cd89")
; Started: 2017-06-05 14:59:35
; Silicon.buildVersion: 1.1-SNAPSHOT d08e1b0df844 default 2017/06/05 12:23:42
; Input file: null
; Verifier id: 00
; ------------------------------------------------------------
; Begin preamble
; ////////// Static preamble
; 
; ; /z3config.smt2
(set-option :print-success true) ; Boogie: false
(set-option :global-decls true) ; Boogie: default
(set-option :auto_config false) ; Usually a good idea
(set-option :smt.mbqi false)
(set-option :model.v2 true)
(set-option :smt.phase_selection 0)
(set-option :smt.restart_strategy 0)
(set-option :smt.restart_factor |1.5|)
(set-option :smt.arith.random_initial_value true)
(set-option :smt.case_split 3)
(set-option :smt.delay_units true)
(set-option :smt.delay_units_threshold 16)
(set-option :nnf.sk_hack true)
(set-option :smt.qi.eager_threshold 100)
(set-option :smt.qi.cost "(+ weight generation)")
(set-option :type_check true)
(set-option :smt.bv.reflect true)
; 
; ; /preamble.smt2
(declare-datatypes () ((
    $Snap ($Snap.unit)
    ($Snap.combine ($Snap.first $Snap) ($Snap.second $Snap)))))
(declare-sort $Ref 0)
(declare-const $Ref.null $Ref)
(define-sort $Perm () Real)
(define-const $Perm.Write $Perm 1.0)
(define-const $Perm.No $Perm 0.0)
(define-fun $Perm.isValidVar ((p $Perm)) Bool
	(<= $Perm.No p))
(define-fun $Perm.isReadVar ((p $Perm) (ub $Perm)) Bool
    (and ($Perm.isValidVar p)
         (not (= p $Perm.No))
         (< p $Perm.Write)))
(define-fun $Perm.min ((p1 $Perm) (p2 $Perm)) Real
    (ite (<= p1 p2) p1 p2))
(define-fun $Math.min ((a Int) (b Int)) Int
    (ite (<= a b) a b))
(define-fun $Math.clip ((a Int)) Int
    (ite (< a 0) 0 a))
; ////////// Sorts
(declare-sort Matrix)
(declare-sort $FVF<$Ref>)
(declare-sort Set<$Snap>)
(declare-sort $PSF<$Snap>)
; ////////// Sort wrappers
; Declaring additional sort wrappers
(declare-fun $SortWrappers.IntTo$Snap (Int) $Snap)
(declare-fun $SortWrappers.$SnapToInt ($Snap) Int)
(assert (forall ((x Int)) (!
    (= x ($SortWrappers.$SnapToInt($SortWrappers.IntTo$Snap x)))
    :pattern (($SortWrappers.IntTo$Snap x))
    :qid |$Snap.Int|
    )))
(declare-fun $SortWrappers.BoolTo$Snap (Bool) $Snap)
(declare-fun $SortWrappers.$SnapToBool ($Snap) Bool)
(assert (forall ((x Bool)) (!
    (= x ($SortWrappers.$SnapToBool($SortWrappers.BoolTo$Snap x)))
    :pattern (($SortWrappers.BoolTo$Snap x))
    :qid |$Snap.Bool|
    )))
(declare-fun $SortWrappers.$RefTo$Snap ($Ref) $Snap)
(declare-fun $SortWrappers.$SnapTo$Ref ($Snap) $Ref)
(assert (forall ((x $Ref)) (!
    (= x ($SortWrappers.$SnapTo$Ref($SortWrappers.$RefTo$Snap x)))
    :pattern (($SortWrappers.$RefTo$Snap x))
    :qid |$Snap.$Ref|
    )))
(declare-fun $SortWrappers.$PermTo$Snap ($Perm) $Snap)
(declare-fun $SortWrappers.$SnapTo$Perm ($Snap) $Perm)
(assert (forall ((x $Perm)) (!
    (= x ($SortWrappers.$SnapTo$Perm($SortWrappers.$PermTo$Snap x)))
    :pattern (($SortWrappers.$PermTo$Snap x))
    :qid |$Snap.$Perm|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.MatrixTo$Snap (Matrix) $Snap)
(declare-fun $SortWrappers.$SnapToMatrix ($Snap) Matrix)
(assert (forall ((x Matrix)) (!
    (= x ($SortWrappers.$SnapToMatrix($SortWrappers.MatrixTo$Snap x)))
    :pattern (($SortWrappers.MatrixTo$Snap x))
    :qid |$Snap.Matrix|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.$FVF<$Ref>To$Snap ($FVF<$Ref>) $Snap)
(declare-fun $SortWrappers.$SnapTo$FVF<$Ref> ($Snap) $FVF<$Ref>)
(assert (forall ((x $FVF<$Ref>)) (!
    (= x ($SortWrappers.$SnapTo$FVF<$Ref>($SortWrappers.$FVF<$Ref>To$Snap x)))
    :pattern (($SortWrappers.$FVF<$Ref>To$Snap x))
    :qid |$Snap.$FVF<$Ref>|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.Set<$Snap>To$Snap (Set<$Snap>) $Snap)
(declare-fun $SortWrappers.$SnapToSet<$Snap> ($Snap) Set<$Snap>)
(assert (forall ((x Set<$Snap>)) (!
    (= x ($SortWrappers.$SnapToSet<$Snap>($SortWrappers.Set<$Snap>To$Snap x)))
    :pattern (($SortWrappers.Set<$Snap>To$Snap x))
    :qid |$Snap.Set<$Snap>|
    )))
(declare-fun $SortWrappers.$PSF<$Snap>To$Snap ($PSF<$Snap>) $Snap)
(declare-fun $SortWrappers.$SnapTo$PSF<$Snap> ($Snap) $PSF<$Snap>)
(assert (forall ((x $PSF<$Snap>)) (!
    (= x ($SortWrappers.$SnapTo$PSF<$Snap>($SortWrappers.$PSF<$Snap>To$Snap x)))
    :pattern (($SortWrappers.$PSF<$Snap>To$Snap x))
    :qid |$Snap.$PSF<$Snap>|
    )))
; ////////// Symbols
(declare-fun size (Matrix) Int)
(declare-fun store_ (Matrix Int Int Int) Matrix)
(declare-fun select_ (Matrix Int Int) Int)
; /dafny_axioms/qpp_sets_declarations_dafny.smt2 [Snap]
(declare-fun Set_equal (Set<$Snap> Set<$Snap>) Bool)
(declare-fun Set_in ($Snap Set<$Snap>) Bool)
(declare-fun Set_singleton ($Snap) Set<$Snap>)
; Declaring symbols related to program functions (from program analysis)
; Snapshot variable to be used during function verification
(declare-fun s@$ () $Snap)
; Declaring predicate trigger functions
; ////////// Uniqueness assumptions from domains
; ////////// Axioms
(assert (forall ((m Matrix) (i Int) (j Int) (v Int)) (!
  (implies
    (and (<= 0 i) (and (<= 0 j) (and (< i (size m)) (< j (size m)))))
    (= (size (store_ m i j v)) (size m)))
  :pattern ((store_ m i j v))
  :qid |prog.size_store_same|)))
(assert (forall ((m Matrix)) (!
  (>= (size m) 0)
  :pattern ((size m))
  :qid |prog.size_pos|)))
(assert (and
  (forall ((m Matrix) (i1 Int) (j1 Int) (i2 Int) (j2 Int) (v Int)) (!
    (implies
      (and
        (and (<= 0 i1) (and (<= 0 j1) (and (< i1 (size m)) (< j1 (size m)))))
        (and
          (and (<= 0 i2) (and (<= 0 j2) (and (< i2 (size m)) (< j2 (size m)))))
          (or (not (= i1 i2)) (not (= j1 j2)))))
      (= (select_ (store_ m i1 j1 v) i2 j2) (select_ m i2 j2)))
    :pattern ((select_ (store_ m i1 j1 v) i2 j2))
    :qid |prog.select_store_diff|))
  (forall ((m Matrix) (i1 Int) (j1 Int) (i2 Int) (j2 Int) (v Int)) (!
    (implies
      (and
        (and (<= 0 i1) (and (<= 0 j1) (and (< i1 (size m)) (< j1 (size m)))))
        (and
          (and (<= 0 i2) (and (<= 0 j2) (and (< i2 (size m)) (< j2 (size m)))))
          (or (not (= i1 i2)) (not (= j1 j2)))))
      (= (select_ (store_ m i1 j1 v) i2 j2) (select_ m i2 j2)))
    :pattern ((select_ m i2 j2) (store_ m i1 j1 v))
    :qid |prog.select_store_diff|))))
(assert (forall ((m Matrix) (i Int) (j Int) (v Int)) (!
  (implies
    (and (<= 0 i) (and (<= 0 j) (and (< i (size m)) (< j (size m)))))
    (= (select_ (store_ m i j v) i j) v))
  :pattern ((select_ (store_ m i j v) i j))
  :qid |prog.select_store_same|)))
; End preamble
; ------------------------------------------------------------
; ------------------------------------------------------------
; Begin function- and predicate-related preamble
; Declaring symbols related to program functions (from verification)
; End function- and predicate-related preamble
; ------------------------------------------------------------
; ---------- add ----------
(declare-const m1@0@01 Matrix)
(declare-const m2@1@01 Matrix)
(declare-const m3@2@01 Matrix)
(declare-const i@3@01 Int)
(declare-const j@4@01 Int)
(push) ; 1
(declare-const $t@5@01 $Snap)
(assert (= $t@5@01 $Snap.unit))
; [eval] size(m1) == size(m2)
; [eval] size(m1)
; [eval] size(m2)
(assert (= (size m1@0@01) (size m2@1@01)))
(push) ; 2
(pop) ; 2
(push) ; 2
; [exec]
; inhale size(m3) == size(m1)
(declare-const $t@6@01 $Snap)
(assert (= $t@6@01 $Snap.unit))
; [eval] size(m3) == size(m1)
; [eval] size(m3)
; [eval] size(m1)
(assert (= (size m3@2@01) (size m1@0@01)))
; [exec]
; i := 0
(declare-const j@7@01 Int)
(declare-const m3@8@01 Matrix)
(declare-const i@9@01 Int)
(push) ; 3
; Loop head block: Check well-definedness of invariant
(declare-const $t@10@01 $Snap)
(assert (= $t@10@01 ($Snap.combine $Snap.unit $Snap.unit)))
; [eval] (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
(declare-const x@11@01 Int)
(declare-const y@12@01 Int)
(push) ; 4
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1)))
; [eval] 0 <= x
; [eval] v@13@01 ==> 0 <= y && (x < i && y < size(m1))
(push) ; 5
(set-option :timeout 250)
(push) ; 6
(assert (not (not (<= 0 x@11@01))))
(check-sat)
; unknown
(pop) ; 6
; 0.00s
; (get-info :all-statistics)
(push) ; 6
(assert (not (<= 0 x@11@01)))
(check-sat)
; unknown
(pop) ; 6
; 0.00s
; (get-info :all-statistics)
; [then-branch: 0 | 0 <= x@11@01 | live]
; [else-branch: 0 | !0 <= x@11@01 | live]
(push) ; 6
; [then-branch: 0 | 0 <= x@11@01]
(assert (<= 0 x@11@01))
; [eval] 0 <= y && (x < i && y < size(m1))
; [eval] 0 <= y
; [eval] v@14@01 ==> x < i && y < size(m1)
(push) ; 7
(push) ; 8
(assert (not (not (<= 0 y@12@01))))
(check-sat)
; unknown
(pop) ; 8
; 0.00s
; (get-info :all-statistics)
(push) ; 8
(assert (not (<= 0 y@12@01)))
(check-sat)
; unknown
(pop) ; 8
; 0.00s
; (get-info :all-statistics)
; [then-branch: 1 | 0 <= y@12@01 | live]
; [else-branch: 1 | !0 <= y@12@01 | live]
(push) ; 8
; [then-branch: 1 | 0 <= y@12@01]
(assert (<= 0 y@12@01))
; [eval] x < i && y < size(m1)
; [eval] x < i
; [eval] v@15@01 ==> y < size(m1)
(push) ; 9
(push) ; 10
(assert (not (not (< x@11@01 i@9@01))))
(check-sat)
; unknown
(pop) ; 10
; 0.00s
; (get-info :all-statistics)
(push) ; 10
(assert (not (< x@11@01 i@9@01)))
(check-sat)
; unknown
(pop) ; 10
; 0.00s
; (get-info :all-statistics)
; [then-branch: 2 | x@11@01 < i@9@01 | live]
; [else-branch: 2 | !x@11@01 < i@9@01 | live]
(push) ; 10
; [then-branch: 2 | x@11@01 < i@9@01]
(assert (< x@11@01 i@9@01))
; [eval] y < size(m1)
; [eval] size(m1)
(pop) ; 10
(push) ; 10
; [else-branch: 2 | !x@11@01 < i@9@01]
(assert (not (< x@11@01 i@9@01)))
(pop) ; 10
(pop) ; 9
; Joined path conditions
; Joined path conditions
(pop) ; 8
(push) ; 8
; [else-branch: 1 | !0 <= y@12@01]
(assert (not (<= 0 y@12@01)))
(pop) ; 8
(pop) ; 7
; Joined path conditions
; Joined path conditions
(pop) ; 6
(push) ; 6
; [else-branch: 0 | !0 <= x@11@01]
(assert (not (<= 0 x@11@01)))
(pop) ; 6
(pop) ; 5
; Joined path conditions
; Joined path conditions
(push) ; 5
(push) ; 6
(assert (not (not
  (and
    (<= 0 x@11@01)
    (implies
      (<= 0 x@11@01)
      (and
        (<= 0 y@12@01)
        (implies
          (<= 0 y@12@01)
          (and
            (< x@11@01 i@9@01)
            (implies (< x@11@01 i@9@01) (< y@12@01 (size m1@0@01)))))))))))
(check-sat)
; unknown
(pop) ; 6
; 0.00s
; (get-info :all-statistics)
(push) ; 6
(assert (not (and
  (<= 0 x@11@01)
  (implies
    (<= 0 x@11@01)
    (and
      (<= 0 y@12@01)
      (implies
        (<= 0 y@12@01)
        (and
          (< x@11@01 i@9@01)
          (implies (< x@11@01 i@9@01) (< y@12@01 (size m1@0@01))))))))))
(check-sat)
; unknown
(pop) ; 6
; 0.00s
; (get-info :all-statistics)
; [then-branch: 3 | 0 <= x@11@01 && 0 <= x@11@01 ==> 0 <= y@12@01 && 0 <= y@12@01 ==> x@11@01 < i@9@01 && x@11@01 < i@9@01 ==> y@12@01 < size(m1@0@01) | live]
; [else-branch: 3 | !0 <= x@11@01 && 0 <= x@11@01 ==> 0 <= y@12@01 && 0 <= y@12@01 ==> x@11@01 < i@9@01 && x@11@01 < i@9@01 ==> y@12@01 < size(m1@0@01) | live]
(push) ; 6
; [then-branch: 3 | 0 <= x@11@01 && 0 <= x@11@01 ==> 0 <= y@12@01 && 0 <= y@12@01 ==> x@11@01 < i@9@01 && x@11@01 < i@9@01 ==> y@12@01 < size(m1@0@01)]
(assert (and
  (<= 0 x@11@01)
  (implies
    (<= 0 x@11@01)
    (and
      (<= 0 y@12@01)
      (implies
        (<= 0 y@12@01)
        (and
          (< x@11@01 i@9@01)
          (implies (< x@11@01 i@9@01) (< y@12@01 (size m1@0@01)))))))))
; [eval] select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] select(m3, x, y)
; [eval] select(m1, x, y) + select(m2, x, y)
; [eval] select(m1, x, y)
; [eval] select(m2, x, y)
(pop) ; 6
(push) ; 6
; [else-branch: 3 | !0 <= x@11@01 && 0 <= x@11@01 ==> 0 <= y@12@01 && 0 <= y@12@01 ==> x@11@01 < i@9@01 && x@11@01 < i@9@01 ==> y@12@01 < size(m1@0@01)]
(assert (not
  (and
    (<= 0 x@11@01)
    (implies
      (<= 0 x@11@01)
      (and
        (<= 0 y@12@01)
        (implies
          (<= 0 y@12@01)
          (and
            (< x@11@01 i@9@01)
            (implies (< x@11@01 i@9@01) (< y@12@01 (size m1@0@01))))))))))
(pop) ; 6
(pop) ; 5
; Joined path conditions
; Joined path conditions
(pop) ; 4
; Nested auxiliary terms
(assert (forall ((x@11@01 Int) (y@12@01 Int)) (!
  (implies
    (and
      (<= 0 x@11@01)
      (implies
        (<= 0 x@11@01)
        (and
          (<= 0 y@12@01)
          (implies
            (<= 0 y@12@01)
            (and
              (< x@11@01 i@9@01)
              (implies (< x@11@01 i@9@01) (< y@12@01 (size m1@0@01))))))))
    (=
      (select_ m3@8@01 x@11@01 y@12@01)
      (+ (select_ m1@0@01 x@11@01 y@12@01) (select_ m2@1@01 x@11@01 y@12@01))))
  :pattern ((select_ m3@8@01 x@11@01 y@12@01))
  :qid |prog.l33|)))
; [eval] i <= size(m1)
; [eval] size(m1)
(assert (<= i@9@01 (size m1@0@01)))
; [eval] i >= 0
(assert (>= i@9@01 0))
; [eval] size(m3) == size(m1)
; [eval] size(m3)
; [eval] size(m1)
(assert (= (size m3@8@01) (size m1@0@01)))
; Loop head block: Check well-definedness of edge conditions
(push) ; 4
; [eval] i < size(m1)
; [eval] size(m1)
(pop) ; 4
(push) ; 4
; [eval] !(i < size(m1))
; [eval] i < size(m1)
; [eval] size(m1)
(pop) ; 4
(pop) ; 3
(push) ; 3
; Loop head block: Establish invariant
; [eval] (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
(declare-const x@16@01 Int)
(declare-const y@17@01 Int)
(push) ; 4
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1)))
; [eval] 0 <= x
; [eval] v@18@01 ==> 0 <= y && (x < i && y < size(m1))
(push) ; 5
(push) ; 6
(assert (not (not (<= 0 x@16@01))))
(check-sat)
; unknown
(pop) ; 6
; 0.00s
; (get-info :all-statistics)
(push) ; 6
(assert (not (<= 0 x@16@01)))
(check-sat)
; unknown
(pop) ; 6
; 0.00s
; (get-info :all-statistics)
; [then-branch: 4 | 0 <= x@16@01 | live]
; [else-branch: 4 | !0 <= x@16@01 | live]
(push) ; 6
; [then-branch: 4 | 0 <= x@16@01]
(assert (<= 0 x@16@01))
; [eval] 0 <= y && (x < i && y < size(m1))
; [eval] 0 <= y
; [eval] v@19@01 ==> x < i && y < size(m1)
(push) ; 7
(push) ; 8
(assert (not (not (<= 0 y@17@01))))
(check-sat)
; unknown
(pop) ; 8
; 0.00s
; (get-info :all-statistics)
(push) ; 8
(assert (not (<= 0 y@17@01)))
(check-sat)
; unknown
(pop) ; 8
; 0.00s
; (get-info :all-statistics)
; [then-branch: 5 | 0 <= y@17@01 | live]
; [else-branch: 5 | !0 <= y@17@01 | live]
(push) ; 8
; [then-branch: 5 | 0 <= y@17@01]
(assert (<= 0 y@17@01))
; [eval] x < i && y < size(m1)
; [eval] x < i
; [eval] v@20@01 ==> y < size(m1)
(push) ; 9
(push) ; 10
(assert (not (not (< x@16@01 0))))
(check-sat)
; unsat
(pop) ; 10
; 0.00s
; (get-info :all-statistics)
; [then-branch: 6 | x@16@01 < 0 | dead]
; [else-branch: 6 | !x@16@01 < 0 | live]
(push) ; 10
; [else-branch: 6 | !x@16@01 < 0]
(assert (not (< x@16@01 0)))
(pop) ; 10
(pop) ; 9
; Joined path conditions
(pop) ; 8
(push) ; 8
; [else-branch: 5 | !0 <= y@17@01]
(assert (not (<= 0 y@17@01)))
(pop) ; 8
(pop) ; 7
; Joined path conditions
; Joined path conditions
(pop) ; 6
(push) ; 6
; [else-branch: 4 | !0 <= x@16@01]
(assert (not (<= 0 x@16@01)))
(pop) ; 6
(pop) ; 5
; Joined path conditions
; Joined path conditions
(push) ; 5
(push) ; 6
(assert (not (not
  (and
    (<= 0 x@16@01)
    (implies
      (<= 0 x@16@01)
      (and (<= 0 y@17@01) (implies (<= 0 y@17@01) (< x@16@01 0))))))))
(check-sat)
; unsat
(pop) ; 6
; 0.00s
; (get-info :all-statistics)
; [then-branch: 7 | 0 <= x@16@01 && 0 <= x@16@01 ==> 0 <= y@17@01 && 0 <= y@17@01 ==> x@16@01 < 0 | dead]
; [else-branch: 7 | !0 <= x@16@01 && 0 <= x@16@01 ==> 0 <= y@17@01 && 0 <= y@17@01 ==> x@16@01 < 0 | live]
(push) ; 6
; [else-branch: 7 | !0 <= x@16@01 && 0 <= x@16@01 ==> 0 <= y@17@01 && 0 <= y@17@01 ==> x@16@01 < 0]
(assert (not
  (and
    (<= 0 x@16@01)
    (implies
      (<= 0 x@16@01)
      (and (<= 0 y@17@01) (implies (<= 0 y@17@01) (< x@16@01 0)))))))
(pop) ; 6
(pop) ; 5
; Joined path conditions
; [eval] select(m3, x, y)
(pop) ; 4
; Nested auxiliary terms
; [eval] i <= size(m1)
; [eval] size(m1)
(set-option :timeout 0)
(push) ; 4
(assert (not (<= 0 (size m1@0@01))))
(check-sat)
; unsat
(pop) ; 4
; 0.00s
; (get-info :all-statistics)
(assert (<= 0 (size m1@0@01)))
; [eval] i >= 0
; [eval] size(m3) == size(m1)
; [eval] size(m3)
; [eval] size(m1)
; Loop head block: Execute statements of loop head block (in invariant state)
(push) ; 4
(assert (= $t@10@01 ($Snap.combine $Snap.unit $Snap.unit)))
(assert (forall ((x@11@01 Int) (y@12@01 Int)) (!
  (implies
    (and
      (<= 0 x@11@01)
      (implies
        (<= 0 x@11@01)
        (and
          (<= 0 y@12@01)
          (implies
            (<= 0 y@12@01)
            (and
              (< x@11@01 i@9@01)
              (implies (< x@11@01 i@9@01) (< y@12@01 (size m1@0@01))))))))
    (=
      (select_ m3@8@01 x@11@01 y@12@01)
      (+ (select_ m1@0@01 x@11@01 y@12@01) (select_ m2@1@01 x@11@01 y@12@01))))
  :pattern ((select_ m3@8@01 x@11@01 y@12@01))
  :qid |prog.l33|)))
(assert (<= i@9@01 (size m1@0@01)))
(assert (>= i@9@01 0))
(assert (= (size m3@8@01) (size m1@0@01)))
(set-option :timeout 250)
(check-sat)
; unknown
; Loop head block: Follow loop-internal edges
; [eval] i < size(m1)
; [eval] size(m1)
(push) ; 5
(assert (not (not (< i@9@01 (size m1@0@01)))))
(check-sat)
; unknown
(pop) ; 5
; 0.00s
; (get-info :all-statistics)
(push) ; 5
(assert (not (< i@9@01 (size m1@0@01))))
(check-sat)
; unknown
(pop) ; 5
; 0.00s
; (get-info :all-statistics)
; [then-branch: 8 | i@9@01 < size(m1@0@01) | live]
; [else-branch: 8 | !i@9@01 < size(m1@0@01) | live]
(push) ; 5
; [then-branch: 8 | i@9@01 < size(m1@0@01)]
(assert (< i@9@01 (size m1@0@01)))
; [exec]
; j := 0
(declare-const m3@21@01 Matrix)
(declare-const j@22@01 Int)
(push) ; 6
; Loop head block: Check well-definedness of invariant
(declare-const $t@23@01 $Snap)
(assert (= $t@23@01 ($Snap.combine $Snap.unit $Snap.unit)))
; [eval] (forall y: Int :: { select(m3, i, y) } 0 <= y && y < j ==> select(m3, i, y) == select(m1, i, y) + select(m2, i, y))
(declare-const y@24@01 Int)
(push) ; 7
; [eval] 0 <= y && y < j ==> select(m3, i, y) == select(m1, i, y) + select(m2, i, y)
; [eval] 0 <= y && y < j
; [eval] 0 <= y
; [eval] v@25@01 ==> y < j
(push) ; 8
(push) ; 9
(assert (not (not (<= 0 y@24@01))))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(push) ; 9
(assert (not (<= 0 y@24@01)))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
; [then-branch: 9 | 0 <= y@24@01 | live]
; [else-branch: 9 | !0 <= y@24@01 | live]
(push) ; 9
; [then-branch: 9 | 0 <= y@24@01]
(assert (<= 0 y@24@01))
; [eval] y < j
(pop) ; 9
(push) ; 9
; [else-branch: 9 | !0 <= y@24@01]
(assert (not (<= 0 y@24@01)))
(pop) ; 9
(pop) ; 8
; Joined path conditions
; Joined path conditions
(push) ; 8
(push) ; 9
(assert (not (not (and (<= 0 y@24@01) (implies (<= 0 y@24@01) (< y@24@01 j@22@01))))))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(push) ; 9
(assert (not (and (<= 0 y@24@01) (implies (<= 0 y@24@01) (< y@24@01 j@22@01)))))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
; [then-branch: 10 | 0 <= y@24@01 && 0 <= y@24@01 ==> y@24@01 < j@22@01 | live]
; [else-branch: 10 | !0 <= y@24@01 && 0 <= y@24@01 ==> y@24@01 < j@22@01 | live]
(push) ; 9
; [then-branch: 10 | 0 <= y@24@01 && 0 <= y@24@01 ==> y@24@01 < j@22@01]
(assert (and (<= 0 y@24@01) (implies (<= 0 y@24@01) (< y@24@01 j@22@01))))
; [eval] select(m3, i, y) == select(m1, i, y) + select(m2, i, y)
; [eval] select(m3, i, y)
; [eval] select(m1, i, y) + select(m2, i, y)
; [eval] select(m1, i, y)
; [eval] select(m2, i, y)
(pop) ; 9
(push) ; 9
; [else-branch: 10 | !0 <= y@24@01 && 0 <= y@24@01 ==> y@24@01 < j@22@01]
(assert (not (and (<= 0 y@24@01) (implies (<= 0 y@24@01) (< y@24@01 j@22@01)))))
(pop) ; 9
(pop) ; 8
; Joined path conditions
; Joined path conditions
(pop) ; 7
; Nested auxiliary terms
(assert (forall ((y@24@01 Int)) (!
  (implies
    (and (<= 0 y@24@01) (implies (<= 0 y@24@01) (< y@24@01 j@22@01)))
    (=
      (select_ m3@21@01 i@9@01 y@24@01)
      (+ (select_ m1@0@01 i@9@01 y@24@01) (select_ m2@1@01 i@9@01 y@24@01))))
  :pattern ((select_ m3@21@01 i@9@01 y@24@01))
  :qid |prog.l40|)))
; [eval] (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
(declare-const x@26@01 Int)
(declare-const y@27@01 Int)
(push) ; 7
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1)))
; [eval] 0 <= x
; [eval] v@28@01 ==> 0 <= y && (x < i && y < size(m1))
(push) ; 8
(push) ; 9
(assert (not (not (<= 0 x@26@01))))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(push) ; 9
(assert (not (<= 0 x@26@01)))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
; [then-branch: 11 | 0 <= x@26@01 | live]
; [else-branch: 11 | !0 <= x@26@01 | live]
(push) ; 9
; [then-branch: 11 | 0 <= x@26@01]
(assert (<= 0 x@26@01))
; [eval] 0 <= y && (x < i && y < size(m1))
; [eval] 0 <= y
; [eval] v@29@01 ==> x < i && y < size(m1)
(push) ; 10
(push) ; 11
(assert (not (not (<= 0 y@27@01))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
(push) ; 11
(assert (not (<= 0 y@27@01)))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
; [then-branch: 12 | 0 <= y@27@01 | live]
; [else-branch: 12 | !0 <= y@27@01 | live]
(push) ; 11
; [then-branch: 12 | 0 <= y@27@01]
(assert (<= 0 y@27@01))
; [eval] x < i && y < size(m1)
; [eval] x < i
; [eval] v@30@01 ==> y < size(m1)
(push) ; 12
(push) ; 13
(assert (not (not (< x@26@01 i@9@01))))
(check-sat)
; unknown
(pop) ; 13
; 0.00s
; (get-info :all-statistics)
(push) ; 13
(assert (not (< x@26@01 i@9@01)))
(check-sat)
; unknown
(pop) ; 13
; 0.00s
; (get-info :all-statistics)
; [then-branch: 13 | x@26@01 < i@9@01 | live]
; [else-branch: 13 | !x@26@01 < i@9@01 | live]
(push) ; 13
; [then-branch: 13 | x@26@01 < i@9@01]
(assert (< x@26@01 i@9@01))
; [eval] y < size(m1)
; [eval] size(m1)
(pop) ; 13
(push) ; 13
; [else-branch: 13 | !x@26@01 < i@9@01]
(assert (not (< x@26@01 i@9@01)))
(pop) ; 13
(pop) ; 12
; Joined path conditions
; Joined path conditions
(pop) ; 11
(push) ; 11
; [else-branch: 12 | !0 <= y@27@01]
(assert (not (<= 0 y@27@01)))
(pop) ; 11
(pop) ; 10
; Joined path conditions
; Joined path conditions
(pop) ; 9
(push) ; 9
; [else-branch: 11 | !0 <= x@26@01]
(assert (not (<= 0 x@26@01)))
(pop) ; 9
(pop) ; 8
; Joined path conditions
; Joined path conditions
(push) ; 8
(push) ; 9
(assert (not (not
  (and
    (<= 0 x@26@01)
    (implies
      (<= 0 x@26@01)
      (and
        (<= 0 y@27@01)
        (implies
          (<= 0 y@27@01)
          (and
            (< x@26@01 i@9@01)
            (implies (< x@26@01 i@9@01) (< y@27@01 (size m1@0@01)))))))))))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(push) ; 9
(assert (not (and
  (<= 0 x@26@01)
  (implies
    (<= 0 x@26@01)
    (and
      (<= 0 y@27@01)
      (implies
        (<= 0 y@27@01)
        (and
          (< x@26@01 i@9@01)
          (implies (< x@26@01 i@9@01) (< y@27@01 (size m1@0@01))))))))))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
; [then-branch: 14 | 0 <= x@26@01 && 0 <= x@26@01 ==> 0 <= y@27@01 && 0 <= y@27@01 ==> x@26@01 < i@9@01 && x@26@01 < i@9@01 ==> y@27@01 < size(m1@0@01) | live]
; [else-branch: 14 | !0 <= x@26@01 && 0 <= x@26@01 ==> 0 <= y@27@01 && 0 <= y@27@01 ==> x@26@01 < i@9@01 && x@26@01 < i@9@01 ==> y@27@01 < size(m1@0@01) | live]
(push) ; 9
; [then-branch: 14 | 0 <= x@26@01 && 0 <= x@26@01 ==> 0 <= y@27@01 && 0 <= y@27@01 ==> x@26@01 < i@9@01 && x@26@01 < i@9@01 ==> y@27@01 < size(m1@0@01)]
(assert (and
  (<= 0 x@26@01)
  (implies
    (<= 0 x@26@01)
    (and
      (<= 0 y@27@01)
      (implies
        (<= 0 y@27@01)
        (and
          (< x@26@01 i@9@01)
          (implies (< x@26@01 i@9@01) (< y@27@01 (size m1@0@01)))))))))
; [eval] select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] select(m3, x, y)
; [eval] select(m1, x, y) + select(m2, x, y)
; [eval] select(m1, x, y)
; [eval] select(m2, x, y)
(pop) ; 9
(push) ; 9
; [else-branch: 14 | !0 <= x@26@01 && 0 <= x@26@01 ==> 0 <= y@27@01 && 0 <= y@27@01 ==> x@26@01 < i@9@01 && x@26@01 < i@9@01 ==> y@27@01 < size(m1@0@01)]
(assert (not
  (and
    (<= 0 x@26@01)
    (implies
      (<= 0 x@26@01)
      (and
        (<= 0 y@27@01)
        (implies
          (<= 0 y@27@01)
          (and
            (< x@26@01 i@9@01)
            (implies (< x@26@01 i@9@01) (< y@27@01 (size m1@0@01))))))))))
(pop) ; 9
(pop) ; 8
; Joined path conditions
; Joined path conditions
(pop) ; 7
; Nested auxiliary terms
(assert (forall ((x@26@01 Int) (y@27@01 Int)) (!
  (implies
    (and
      (<= 0 x@26@01)
      (implies
        (<= 0 x@26@01)
        (and
          (<= 0 y@27@01)
          (implies
            (<= 0 y@27@01)
            (and
              (< x@26@01 i@9@01)
              (implies (< x@26@01 i@9@01) (< y@27@01 (size m1@0@01))))))))
    (=
      (select_ m3@21@01 x@26@01 y@27@01)
      (+ (select_ m1@0@01 x@26@01 y@27@01) (select_ m2@1@01 x@26@01 y@27@01))))
  :pattern ((select_ m3@21@01 x@26@01 y@27@01))
  :qid |prog.l41|)))
; [eval] j <= size(m1)
; [eval] size(m1)
(assert (<= j@22@01 (size m1@0@01)))
; [eval] j >= 0
(assert (>= j@22@01 0))
; [eval] size(m3) == size(m1)
; [eval] size(m3)
; [eval] size(m1)
(assert (= (size m3@21@01) (size m1@0@01)))
; Loop head block: Check well-definedness of edge conditions
(push) ; 7
; [eval] j < size(m1)
; [eval] size(m1)
(pop) ; 7
(push) ; 7
; [eval] !(j < size(m1))
; [eval] j < size(m1)
; [eval] size(m1)
(pop) ; 7
(pop) ; 6
(push) ; 6
; Loop head block: Establish invariant
; [eval] (forall y: Int :: { select(m3, i, y) } 0 <= y && y < j ==> select(m3, i, y) == select(m1, i, y) + select(m2, i, y))
(declare-const y@31@01 Int)
(push) ; 7
; [eval] 0 <= y && y < j ==> select(m3, i, y) == select(m1, i, y) + select(m2, i, y)
; [eval] 0 <= y && y < j
; [eval] 0 <= y
; [eval] v@32@01 ==> y < j
(push) ; 8
(push) ; 9
(assert (not (not (<= 0 y@31@01))))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(push) ; 9
(assert (not (<= 0 y@31@01)))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
; [then-branch: 15 | 0 <= y@31@01 | live]
; [else-branch: 15 | !0 <= y@31@01 | live]
(push) ; 9
; [then-branch: 15 | 0 <= y@31@01]
(assert (<= 0 y@31@01))
; [eval] y < j
(pop) ; 9
(push) ; 9
; [else-branch: 15 | !0 <= y@31@01]
(assert (not (<= 0 y@31@01)))
(pop) ; 9
(pop) ; 8
; Joined path conditions
; Joined path conditions
(push) ; 8
(push) ; 9
(assert (not (not (and (<= 0 y@31@01) (implies (<= 0 y@31@01) (< y@31@01 0))))))
(check-sat)
; unsat
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
; [then-branch: 16 | 0 <= y@31@01 && 0 <= y@31@01 ==> y@31@01 < 0 | dead]
; [else-branch: 16 | !0 <= y@31@01 && 0 <= y@31@01 ==> y@31@01 < 0 | live]
(push) ; 9
; [else-branch: 16 | !0 <= y@31@01 && 0 <= y@31@01 ==> y@31@01 < 0]
(assert (not (and (<= 0 y@31@01) (implies (<= 0 y@31@01) (< y@31@01 0)))))
(pop) ; 9
(pop) ; 8
; Joined path conditions
; [eval] select(m3, i, y)
(pop) ; 7
; Nested auxiliary terms
; [eval] (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
(declare-const x@33@01 Int)
(declare-const y@34@01 Int)
(push) ; 7
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1)))
; [eval] 0 <= x
; [eval] v@35@01 ==> 0 <= y && (x < i && y < size(m1))
(push) ; 8
(push) ; 9
(assert (not (not (<= 0 x@33@01))))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(push) ; 9
(assert (not (<= 0 x@33@01)))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
; [then-branch: 17 | 0 <= x@33@01 | live]
; [else-branch: 17 | !0 <= x@33@01 | live]
(push) ; 9
; [then-branch: 17 | 0 <= x@33@01]
(assert (<= 0 x@33@01))
; [eval] 0 <= y && (x < i && y < size(m1))
; [eval] 0 <= y
; [eval] v@36@01 ==> x < i && y < size(m1)
(push) ; 10
(push) ; 11
(assert (not (not (<= 0 y@34@01))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
(push) ; 11
(assert (not (<= 0 y@34@01)))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
; [then-branch: 18 | 0 <= y@34@01 | live]
; [else-branch: 18 | !0 <= y@34@01 | live]
(push) ; 11
; [then-branch: 18 | 0 <= y@34@01]
(assert (<= 0 y@34@01))
; [eval] x < i && y < size(m1)
; [eval] x < i
; [eval] v@37@01 ==> y < size(m1)
(push) ; 12
(push) ; 13
(assert (not (not (< x@33@01 i@9@01))))
(check-sat)
; unknown
(pop) ; 13
; 0.00s
; (get-info :all-statistics)
(push) ; 13
(assert (not (< x@33@01 i@9@01)))
(check-sat)
; unknown
(pop) ; 13
; 0.00s
; (get-info :all-statistics)
; [then-branch: 19 | x@33@01 < i@9@01 | live]
; [else-branch: 19 | !x@33@01 < i@9@01 | live]
(push) ; 13
; [then-branch: 19 | x@33@01 < i@9@01]
(assert (< x@33@01 i@9@01))
; [eval] y < size(m1)
; [eval] size(m1)
(pop) ; 13
(push) ; 13
; [else-branch: 19 | !x@33@01 < i@9@01]
(assert (not (< x@33@01 i@9@01)))
(pop) ; 13
(pop) ; 12
; Joined path conditions
; Joined path conditions
(pop) ; 11
(push) ; 11
; [else-branch: 18 | !0 <= y@34@01]
(assert (not (<= 0 y@34@01)))
(pop) ; 11
(pop) ; 10
; Joined path conditions
; Joined path conditions
(pop) ; 9
(push) ; 9
; [else-branch: 17 | !0 <= x@33@01]
(assert (not (<= 0 x@33@01)))
(pop) ; 9
(pop) ; 8
; Joined path conditions
; Joined path conditions
(push) ; 8
(push) ; 9
(assert (not (not
  (and
    (<= 0 x@33@01)
    (implies
      (<= 0 x@33@01)
      (and
        (<= 0 y@34@01)
        (implies
          (<= 0 y@34@01)
          (and
            (< x@33@01 i@9@01)
            (implies (< x@33@01 i@9@01) (< y@34@01 (size m1@0@01)))))))))))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(push) ; 9
(assert (not (and
  (<= 0 x@33@01)
  (implies
    (<= 0 x@33@01)
    (and
      (<= 0 y@34@01)
      (implies
        (<= 0 y@34@01)
        (and
          (< x@33@01 i@9@01)
          (implies (< x@33@01 i@9@01) (< y@34@01 (size m1@0@01))))))))))
(check-sat)
; unknown
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
; [then-branch: 20 | 0 <= x@33@01 && 0 <= x@33@01 ==> 0 <= y@34@01 && 0 <= y@34@01 ==> x@33@01 < i@9@01 && x@33@01 < i@9@01 ==> y@34@01 < size(m1@0@01) | live]
; [else-branch: 20 | !0 <= x@33@01 && 0 <= x@33@01 ==> 0 <= y@34@01 && 0 <= y@34@01 ==> x@33@01 < i@9@01 && x@33@01 < i@9@01 ==> y@34@01 < size(m1@0@01) | live]
(push) ; 9
; [then-branch: 20 | 0 <= x@33@01 && 0 <= x@33@01 ==> 0 <= y@34@01 && 0 <= y@34@01 ==> x@33@01 < i@9@01 && x@33@01 < i@9@01 ==> y@34@01 < size(m1@0@01)]
(assert (and
  (<= 0 x@33@01)
  (implies
    (<= 0 x@33@01)
    (and
      (<= 0 y@34@01)
      (implies
        (<= 0 y@34@01)
        (and
          (< x@33@01 i@9@01)
          (implies (< x@33@01 i@9@01) (< y@34@01 (size m1@0@01)))))))))
; [eval] select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] select(m3, x, y)
; [eval] select(m1, x, y) + select(m2, x, y)
; [eval] select(m1, x, y)
; [eval] select(m2, x, y)
(pop) ; 9
(push) ; 9
; [else-branch: 20 | !0 <= x@33@01 && 0 <= x@33@01 ==> 0 <= y@34@01 && 0 <= y@34@01 ==> x@33@01 < i@9@01 && x@33@01 < i@9@01 ==> y@34@01 < size(m1@0@01)]
(assert (not
  (and
    (<= 0 x@33@01)
    (implies
      (<= 0 x@33@01)
      (and
        (<= 0 y@34@01)
        (implies
          (<= 0 y@34@01)
          (and
            (< x@33@01 i@9@01)
            (implies (< x@33@01 i@9@01) (< y@34@01 (size m1@0@01))))))))))
(pop) ; 9
(pop) ; 8
; Joined path conditions
; Joined path conditions
(pop) ; 7
; Nested auxiliary terms
(set-option :timeout 0)
(push) ; 7
(assert (not (forall ((x@33@01 Int) (y@34@01 Int)) (!
  (implies
    (and
      (<= 0 x@33@01)
      (implies
        (<= 0 x@33@01)
        (and
          (<= 0 y@34@01)
          (implies
            (<= 0 y@34@01)
            (and
              (< x@33@01 i@9@01)
              (implies (< x@33@01 i@9@01) (< y@34@01 (size m1@0@01))))))))
    (=
      (select_ m3@8@01 x@33@01 y@34@01)
      (+ (select_ m1@0@01 x@33@01 y@34@01) (select_ m2@1@01 x@33@01 y@34@01))))
  :pattern ((select_ m3@8@01 x@33@01 y@34@01))
  :qid |prog.l41|))))
(check-sat)
; unsat
(pop) ; 7
; 0.00s
; (get-info :all-statistics)
(assert (forall ((x@33@01 Int) (y@34@01 Int)) (!
  (implies
    (and
      (<= 0 x@33@01)
      (implies
        (<= 0 x@33@01)
        (and
          (<= 0 y@34@01)
          (implies
            (<= 0 y@34@01)
            (and
              (< x@33@01 i@9@01)
              (implies (< x@33@01 i@9@01) (< y@34@01 (size m1@0@01))))))))
    (=
      (select_ m3@8@01 x@33@01 y@34@01)
      (+ (select_ m1@0@01 x@33@01 y@34@01) (select_ m2@1@01 x@33@01 y@34@01))))
  :pattern ((select_ m3@8@01 x@33@01 y@34@01))
  :qid |prog.l41|)))
; [eval] j <= size(m1)
; [eval] size(m1)
; [eval] j >= 0
; [eval] size(m3) == size(m1)
; [eval] size(m3)
; [eval] size(m1)
; Loop head block: Execute statements of loop head block (in invariant state)
(push) ; 7
(assert (= $t@23@01 ($Snap.combine $Snap.unit $Snap.unit)))
(assert (forall ((y@24@01 Int)) (!
  (implies
    (and (<= 0 y@24@01) (implies (<= 0 y@24@01) (< y@24@01 j@22@01)))
    (=
      (select_ m3@21@01 i@9@01 y@24@01)
      (+ (select_ m1@0@01 i@9@01 y@24@01) (select_ m2@1@01 i@9@01 y@24@01))))
  :pattern ((select_ m3@21@01 i@9@01 y@24@01))
  :qid |prog.l40|)))
(assert (forall ((x@26@01 Int) (y@27@01 Int)) (!
  (implies
    (and
      (<= 0 x@26@01)
      (implies
        (<= 0 x@26@01)
        (and
          (<= 0 y@27@01)
          (implies
            (<= 0 y@27@01)
            (and
              (< x@26@01 i@9@01)
              (implies (< x@26@01 i@9@01) (< y@27@01 (size m1@0@01))))))))
    (=
      (select_ m3@21@01 x@26@01 y@27@01)
      (+ (select_ m1@0@01 x@26@01 y@27@01) (select_ m2@1@01 x@26@01 y@27@01))))
  :pattern ((select_ m3@21@01 x@26@01 y@27@01))
  :qid |prog.l41|)))
(assert (<= j@22@01 (size m1@0@01)))
(assert (>= j@22@01 0))
(assert (= (size m3@21@01) (size m1@0@01)))
(set-option :timeout 250)
(check-sat)
; unknown
; Loop head block: Follow loop-internal edges
; [eval] j < size(m1)
; [eval] size(m1)
(push) ; 8
(assert (not (not (< j@22@01 (size m1@0@01)))))
(check-sat)
; unknown
(pop) ; 8
; 0.00s
; (get-info :all-statistics)
(push) ; 8
(assert (not (< j@22@01 (size m1@0@01))))
(check-sat)
; unknown
(pop) ; 8
; 0.00s
; (get-info :all-statistics)
; [then-branch: 21 | j@22@01 < size(m1@0@01) | live]
; [else-branch: 21 | !j@22@01 < size(m1@0@01) | live]
(push) ; 8
; [then-branch: 21 | j@22@01 < size(m1@0@01)]
(assert (< j@22@01 (size m1@0@01)))
; [exec]
; m3 := store(m3, i, j, select(m1, i, j) + select(m2, i, j))
; [eval] store(m3, i, j, select(m1, i, j) + select(m2, i, j))
; [eval] select(m1, i, j) + select(m2, i, j)
; [eval] select(m1, i, j)
; [eval] select(m2, i, j)
(declare-const m3@38@01 Matrix)
(assert (=
  m3@38@01
  (store_ m3@21@01 i@9@01 j@22@01 (+
    (select_ m1@0@01 i@9@01 j@22@01)
    (select_ m2@1@01 i@9@01 j@22@01)))))
; [exec]
; assert select(m3, i, j) == select(m1, i, j) + select(m2, i, j)
; [eval] select(m3, i, j) == select(m1, i, j) + select(m2, i, j)
; [eval] select(m3, i, j)
; [eval] select(m1, i, j) + select(m2, i, j)
; [eval] select(m1, i, j)
; [eval] select(m2, i, j)
(set-option :timeout 0)
(push) ; 9
(assert (not (=
  (select_ m3@38@01 i@9@01 j@22@01)
  (+ (select_ m1@0@01 i@9@01 j@22@01) (select_ m2@1@01 i@9@01 j@22@01)))))
(check-sat)
; unsat
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(assert (=
  (select_ m3@38@01 i@9@01 j@22@01)
  (+ (select_ m1@0@01 i@9@01 j@22@01) (select_ m2@1@01 i@9@01 j@22@01))))
; [exec]
; j := j + 1
; [eval] j + 1
(declare-const j@39@01 Int)
(assert (= j@39@01 (+ j@22@01 1)))
; Loop head block: Re-establish invariant
; [eval] (forall y: Int :: { select(m3, i, y) } 0 <= y && y < j ==> select(m3, i, y) == select(m1, i, y) + select(m2, i, y))
(declare-const y@40@01 Int)
(push) ; 9
; [eval] 0 <= y && y < j ==> select(m3, i, y) == select(m1, i, y) + select(m2, i, y)
; [eval] 0 <= y && y < j
; [eval] 0 <= y
; [eval] v@41@01 ==> y < j
(push) ; 10
(set-option :timeout 250)
(push) ; 11
(assert (not (not (<= 0 y@40@01))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
(push) ; 11
(assert (not (<= 0 y@40@01)))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
; [then-branch: 22 | 0 <= y@40@01 | live]
; [else-branch: 22 | !0 <= y@40@01 | live]
(push) ; 11
; [then-branch: 22 | 0 <= y@40@01]
(assert (<= 0 y@40@01))
; [eval] y < j
(pop) ; 11
(push) ; 11
; [else-branch: 22 | !0 <= y@40@01]
(assert (not (<= 0 y@40@01)))
(pop) ; 11
(pop) ; 10
; Joined path conditions
; Joined path conditions
(push) ; 10
(push) ; 11
(assert (not (not (and (<= 0 y@40@01) (implies (<= 0 y@40@01) (< y@40@01 j@39@01))))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
(push) ; 11
(assert (not (and (<= 0 y@40@01) (implies (<= 0 y@40@01) (< y@40@01 j@39@01)))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
; [then-branch: 23 | 0 <= y@40@01 && 0 <= y@40@01 ==> y@40@01 < j@39@01 | live]
; [else-branch: 23 | !0 <= y@40@01 && 0 <= y@40@01 ==> y@40@01 < j@39@01 | live]
(push) ; 11
; [then-branch: 23 | 0 <= y@40@01 && 0 <= y@40@01 ==> y@40@01 < j@39@01]
(assert (and (<= 0 y@40@01) (implies (<= 0 y@40@01) (< y@40@01 j@39@01))))
; [eval] select(m3, i, y) == select(m1, i, y) + select(m2, i, y)
; [eval] select(m3, i, y)
; [eval] select(m1, i, y) + select(m2, i, y)
; [eval] select(m1, i, y)
; [eval] select(m2, i, y)
(pop) ; 11
(push) ; 11
; [else-branch: 23 | !0 <= y@40@01 && 0 <= y@40@01 ==> y@40@01 < j@39@01]
(assert (not (and (<= 0 y@40@01) (implies (<= 0 y@40@01) (< y@40@01 j@39@01)))))
(pop) ; 11
(pop) ; 10
; Joined path conditions
; Joined path conditions
(pop) ; 9
; Nested auxiliary terms
(set-option :timeout 0)
(push) ; 9
(assert (not (forall ((y@40@01 Int)) (!
  (implies
    (and (<= 0 y@40@01) (implies (<= 0 y@40@01) (< y@40@01 j@39@01)))
    (=
      (select_ m3@38@01 i@9@01 y@40@01)
      (+ (select_ m1@0@01 i@9@01 y@40@01) (select_ m2@1@01 i@9@01 y@40@01))))
  :pattern ((select_ m3@38@01 i@9@01 y@40@01))
  :qid |prog.l40|))))
(check-sat)
; unsat
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(assert (forall ((y@40@01 Int)) (!
  (implies
    (and (<= 0 y@40@01) (implies (<= 0 y@40@01) (< y@40@01 j@39@01)))
    (=
      (select_ m3@38@01 i@9@01 y@40@01)
      (+ (select_ m1@0@01 i@9@01 y@40@01) (select_ m2@1@01 i@9@01 y@40@01))))
  :pattern ((select_ m3@38@01 i@9@01 y@40@01))
  :qid |prog.l40|)))
; [eval] (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
(declare-const x@42@01 Int)
(declare-const y@43@01 Int)
(push) ; 9
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1)))
; [eval] 0 <= x
; [eval] v@44@01 ==> 0 <= y && (x < i && y < size(m1))
(push) ; 10
(set-option :timeout 250)
(push) ; 11
(assert (not (not (<= 0 x@42@01))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
(push) ; 11
(assert (not (<= 0 x@42@01)))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
; [then-branch: 24 | 0 <= x@42@01 | live]
; [else-branch: 24 | !0 <= x@42@01 | live]
(push) ; 11
; [then-branch: 24 | 0 <= x@42@01]
(assert (<= 0 x@42@01))
; [eval] 0 <= y && (x < i && y < size(m1))
; [eval] 0 <= y
; [eval] v@45@01 ==> x < i && y < size(m1)
(push) ; 12
(push) ; 13
(assert (not (not (<= 0 y@43@01))))
(check-sat)
; unknown
(pop) ; 13
; 0.00s
; (get-info :all-statistics)
(push) ; 13
(assert (not (<= 0 y@43@01)))
(check-sat)
; unknown
(pop) ; 13
; 0.00s
; (get-info :all-statistics)
; [then-branch: 25 | 0 <= y@43@01 | live]
; [else-branch: 25 | !0 <= y@43@01 | live]
(push) ; 13
; [then-branch: 25 | 0 <= y@43@01]
(assert (<= 0 y@43@01))
; [eval] x < i && y < size(m1)
; [eval] x < i
; [eval] v@46@01 ==> y < size(m1)
(push) ; 14
(push) ; 15
(assert (not (not (< x@42@01 i@9@01))))
(check-sat)
; unknown
(pop) ; 15
; 0.00s
; (get-info :all-statistics)
(push) ; 15
(assert (not (< x@42@01 i@9@01)))
(check-sat)
; unknown
(pop) ; 15
; 0.00s
; (get-info :all-statistics)
; [then-branch: 26 | x@42@01 < i@9@01 | live]
; [else-branch: 26 | !x@42@01 < i@9@01 | live]
(push) ; 15
; [then-branch: 26 | x@42@01 < i@9@01]
(assert (< x@42@01 i@9@01))
; [eval] y < size(m1)
; [eval] size(m1)
(pop) ; 15
(push) ; 15
; [else-branch: 26 | !x@42@01 < i@9@01]
(assert (not (< x@42@01 i@9@01)))
(pop) ; 15
(pop) ; 14
; Joined path conditions
; Joined path conditions
(pop) ; 13
(push) ; 13
; [else-branch: 25 | !0 <= y@43@01]
(assert (not (<= 0 y@43@01)))
(pop) ; 13
(pop) ; 12
; Joined path conditions
; Joined path conditions
(pop) ; 11
(push) ; 11
; [else-branch: 24 | !0 <= x@42@01]
(assert (not (<= 0 x@42@01)))
(pop) ; 11
(pop) ; 10
; Joined path conditions
; Joined path conditions
(push) ; 10
(push) ; 11
(assert (not (not
  (and
    (<= 0 x@42@01)
    (implies
      (<= 0 x@42@01)
      (and
        (<= 0 y@43@01)
        (implies
          (<= 0 y@43@01)
          (and
            (< x@42@01 i@9@01)
            (implies (< x@42@01 i@9@01) (< y@43@01 (size m1@0@01)))))))))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
(push) ; 11
(assert (not (and
  (<= 0 x@42@01)
  (implies
    (<= 0 x@42@01)
    (and
      (<= 0 y@43@01)
      (implies
        (<= 0 y@43@01)
        (and
          (< x@42@01 i@9@01)
          (implies (< x@42@01 i@9@01) (< y@43@01 (size m1@0@01))))))))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
; [then-branch: 27 | 0 <= x@42@01 && 0 <= x@42@01 ==> 0 <= y@43@01 && 0 <= y@43@01 ==> x@42@01 < i@9@01 && x@42@01 < i@9@01 ==> y@43@01 < size(m1@0@01) | live]
; [else-branch: 27 | !0 <= x@42@01 && 0 <= x@42@01 ==> 0 <= y@43@01 && 0 <= y@43@01 ==> x@42@01 < i@9@01 && x@42@01 < i@9@01 ==> y@43@01 < size(m1@0@01) | live]
(push) ; 11
; [then-branch: 27 | 0 <= x@42@01 && 0 <= x@42@01 ==> 0 <= y@43@01 && 0 <= y@43@01 ==> x@42@01 < i@9@01 && x@42@01 < i@9@01 ==> y@43@01 < size(m1@0@01)]
(assert (and
  (<= 0 x@42@01)
  (implies
    (<= 0 x@42@01)
    (and
      (<= 0 y@43@01)
      (implies
        (<= 0 y@43@01)
        (and
          (< x@42@01 i@9@01)
          (implies (< x@42@01 i@9@01) (< y@43@01 (size m1@0@01)))))))))
; [eval] select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] select(m3, x, y)
; [eval] select(m1, x, y) + select(m2, x, y)
; [eval] select(m1, x, y)
; [eval] select(m2, x, y)
(pop) ; 11
(push) ; 11
; [else-branch: 27 | !0 <= x@42@01 && 0 <= x@42@01 ==> 0 <= y@43@01 && 0 <= y@43@01 ==> x@42@01 < i@9@01 && x@42@01 < i@9@01 ==> y@43@01 < size(m1@0@01)]
(assert (not
  (and
    (<= 0 x@42@01)
    (implies
      (<= 0 x@42@01)
      (and
        (<= 0 y@43@01)
        (implies
          (<= 0 y@43@01)
          (and
            (< x@42@01 i@9@01)
            (implies (< x@42@01 i@9@01) (< y@43@01 (size m1@0@01))))))))))
(pop) ; 11
(pop) ; 10
; Joined path conditions
; Joined path conditions
(pop) ; 9
; Nested auxiliary terms
(set-option :timeout 0)
(push) ; 9
(assert (not (forall ((x@42@01 Int) (y@43@01 Int)) (!
  (implies
    (and
      (<= 0 x@42@01)
      (implies
        (<= 0 x@42@01)
        (and
          (<= 0 y@43@01)
          (implies
            (<= 0 y@43@01)
            (and
              (< x@42@01 i@9@01)
              (implies (< x@42@01 i@9@01) (< y@43@01 (size m1@0@01))))))))
    (=
      (select_ m3@38@01 x@42@01 y@43@01)
      (+ (select_ m1@0@01 x@42@01 y@43@01) (select_ m2@1@01 x@42@01 y@43@01))))
  :pattern ((select_ m3@38@01 x@42@01 y@43@01))
  :qid |prog.l41|))))
(check-sat)
; unsat
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(assert (forall ((x@42@01 Int) (y@43@01 Int)) (!
  (implies
    (and
      (<= 0 x@42@01)
      (implies
        (<= 0 x@42@01)
        (and
          (<= 0 y@43@01)
          (implies
            (<= 0 y@43@01)
            (and
              (< x@42@01 i@9@01)
              (implies (< x@42@01 i@9@01) (< y@43@01 (size m1@0@01))))))))
    (=
      (select_ m3@38@01 x@42@01 y@43@01)
      (+ (select_ m1@0@01 x@42@01 y@43@01) (select_ m2@1@01 x@42@01 y@43@01))))
  :pattern ((select_ m3@38@01 x@42@01 y@43@01))
  :qid |prog.l41|)))
; [eval] j <= size(m1)
; [eval] size(m1)
(push) ; 9
(assert (not (<= j@39@01 (size m1@0@01))))
(check-sat)
; unsat
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(assert (<= j@39@01 (size m1@0@01)))
; [eval] j >= 0
(push) ; 9
(assert (not (>= j@39@01 0)))
(check-sat)
; unsat
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(assert (>= j@39@01 0))
; [eval] size(m3) == size(m1)
; [eval] size(m3)
; [eval] size(m1)
(push) ; 9
(assert (not (= (size m3@38@01) (size m1@0@01))))
(check-sat)
; unsat
(pop) ; 9
; 0.00s
; (get-info :all-statistics)
(assert (= (size m3@38@01) (size m1@0@01)))
(pop) ; 8
(push) ; 8
; [else-branch: 21 | !j@22@01 < size(m1@0@01)]
(assert (not (< j@22@01 (size m1@0@01))))
(pop) ; 8
; [eval] !(j < size(m1))
; [eval] j < size(m1)
; [eval] size(m1)
(set-option :timeout 250)
(push) ; 8
(assert (not (< j@22@01 (size m1@0@01))))
(check-sat)
; unknown
(pop) ; 8
; 0.00s
; (get-info :all-statistics)
(push) ; 8
(assert (not (not (< j@22@01 (size m1@0@01)))))
(check-sat)
; unknown
(pop) ; 8
; 0.00s
; (get-info :all-statistics)
; [then-branch: 28 | !j@22@01 < size(m1@0@01) | live]
; [else-branch: 28 | j@22@01 < size(m1@0@01) | live]
(push) ; 8
; [then-branch: 28 | !j@22@01 < size(m1@0@01)]
(assert (not (< j@22@01 (size m1@0@01))))
; [exec]
; i := i + 1
; [eval] i + 1
(declare-const i@47@01 Int)
(assert (= i@47@01 (+ i@9@01 1)))
; [exec]
; assert (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
; [eval] (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
(declare-const x@48@01 Int)
(declare-const y@49@01 Int)
(push) ; 9
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] 0 <= x && (0 <= y && (x < i && y < size(m1)))
; [eval] 0 <= x
; [eval] v@50@01 ==> 0 <= y && (x < i && y < size(m1))
(push) ; 10
(push) ; 11
(assert (not (not (<= 0 x@48@01))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
(push) ; 11
(assert (not (<= 0 x@48@01)))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
; [then-branch: 29 | 0 <= x@48@01 | live]
; [else-branch: 29 | !0 <= x@48@01 | live]
(push) ; 11
; [then-branch: 29 | 0 <= x@48@01]
(assert (<= 0 x@48@01))
; [eval] 0 <= y && (x < i && y < size(m1))
; [eval] 0 <= y
; [eval] v@51@01 ==> x < i && y < size(m1)
(push) ; 12
(push) ; 13
(assert (not (not (<= 0 y@49@01))))
(check-sat)
; unknown
(pop) ; 13
; 0.00s
; (get-info :all-statistics)
(push) ; 13
(assert (not (<= 0 y@49@01)))
(check-sat)
; unknown
(pop) ; 13
; 0.00s
; (get-info :all-statistics)
; [then-branch: 30 | 0 <= y@49@01 | live]
; [else-branch: 30 | !0 <= y@49@01 | live]
(push) ; 13
; [then-branch: 30 | 0 <= y@49@01]
(assert (<= 0 y@49@01))
; [eval] x < i && y < size(m1)
; [eval] x < i
; [eval] v@52@01 ==> y < size(m1)
(push) ; 14
(push) ; 15
(assert (not (not (< x@48@01 i@47@01))))
(check-sat)
; unknown
(pop) ; 15
; 0.00s
; (get-info :all-statistics)
(push) ; 15
(assert (not (< x@48@01 i@47@01)))
(check-sat)
; unknown
(pop) ; 15
; 0.00s
; (get-info :all-statistics)
; [then-branch: 31 | x@48@01 < i@47@01 | live]
; [else-branch: 31 | !x@48@01 < i@47@01 | live]
(push) ; 15
; [then-branch: 31 | x@48@01 < i@47@01]
(assert (< x@48@01 i@47@01))
; [eval] y < size(m1)
; [eval] size(m1)
(pop) ; 15
(push) ; 15
; [else-branch: 31 | !x@48@01 < i@47@01]
(assert (not (< x@48@01 i@47@01)))
(pop) ; 15
(pop) ; 14
; Joined path conditions
; Joined path conditions
(pop) ; 13
(push) ; 13
; [else-branch: 30 | !0 <= y@49@01]
(assert (not (<= 0 y@49@01)))
(pop) ; 13
(pop) ; 12
; Joined path conditions
; Joined path conditions
(pop) ; 11
(push) ; 11
; [else-branch: 29 | !0 <= x@48@01]
(assert (not (<= 0 x@48@01)))
(pop) ; 11
(pop) ; 10
; Joined path conditions
; Joined path conditions
(push) ; 10
(push) ; 11
(assert (not (not
  (and
    (<= 0 x@48@01)
    (implies
      (<= 0 x@48@01)
      (and
        (<= 0 y@49@01)
        (implies
          (<= 0 y@49@01)
          (and
            (< x@48@01 i@47@01)
            (implies (< x@48@01 i@47@01) (< y@49@01 (size m1@0@01)))))))))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
(push) ; 11
(assert (not (and
  (<= 0 x@48@01)
  (implies
    (<= 0 x@48@01)
    (and
      (<= 0 y@49@01)
      (implies
        (<= 0 y@49@01)
        (and
          (< x@48@01 i@47@01)
          (implies (< x@48@01 i@47@01) (< y@49@01 (size m1@0@01))))))))))
(check-sat)
; unknown
(pop) ; 11
; 0.00s
; (get-info :all-statistics)
; [then-branch: 32 | 0 <= x@48@01 && 0 <= x@48@01 ==> 0 <= y@49@01 && 0 <= y@49@01 ==> x@48@01 < i@47@01 && x@48@01 < i@47@01 ==> y@49@01 < size(m1@0@01) | live]
; [else-branch: 32 | !0 <= x@48@01 && 0 <= x@48@01 ==> 0 <= y@49@01 && 0 <= y@49@01 ==> x@48@01 < i@47@01 && x@48@01 < i@47@01 ==> y@49@01 < size(m1@0@01) | live]
(push) ; 11
; [then-branch: 32 | 0 <= x@48@01 && 0 <= x@48@01 ==> 0 <= y@49@01 && 0 <= y@49@01 ==> x@48@01 < i@47@01 && x@48@01 < i@47@01 ==> y@49@01 < size(m1@0@01)]
(assert (and
  (<= 0 x@48@01)
  (implies
    (<= 0 x@48@01)
    (and
      (<= 0 y@49@01)
      (implies
        (<= 0 y@49@01)
        (and
          (< x@48@01 i@47@01)
          (implies (< x@48@01 i@47@01) (< y@49@01 (size m1@0@01)))))))))
; [eval] select(m3, x, y) == select(m1, x, y) + select(m2, x, y)
; [eval] select(m3, x, y)
; [eval] select(m1, x, y) + select(m2, x, y)
; [eval] select(m1, x, y)
; [eval] select(m2, x, y)
(pop) ; 11
(push) ; 11
; [else-branch: 32 | !0 <= x@48@01 && 0 <= x@48@01 ==> 0 <= y@49@01 && 0 <= y@49@01 ==> x@48@01 < i@47@01 && x@48@01 < i@47@01 ==> y@49@01 < size(m1@0@01)]
(assert (not
  (and
    (<= 0 x@48@01)
    (implies
      (<= 0 x@48@01)
      (and
        (<= 0 y@49@01)
        (implies
          (<= 0 y@49@01)
          (and
            (< x@48@01 i@47@01)
            (implies (< x@48@01 i@47@01) (< y@49@01 (size m1@0@01))))))))))
(pop) ; 11
(pop) ; 10
; Joined path conditions
; Joined path conditions
(pop) ; 9
; Nested auxiliary terms
(set-option :timeout 0)
(push) ; 9
(assert (not (forall ((x@48@01 Int) (y@49@01 Int)) (!
  (implies
    (and
      (<= 0 x@48@01)
      (implies
        (<= 0 x@48@01)
        (and
          (<= 0 y@49@01)
          (implies
            (<= 0 y@49@01)
            (and
              (< x@48@01 i@47@01)
              (implies (< x@48@01 i@47@01) (< y@49@01 (size m1@0@01))))))))
    (=
      (select_ m3@21@01 x@48@01 y@49@01)
      (+ (select_ m1@0@01 x@48@01 y@49@01) (select_ m2@1@01 x@48@01 y@49@01))))
  :pattern ((select_ m3@21@01 x@48@01 y@49@01))
  :qid |prog.l70|))))
(check-sat)
(get-info :reason-unknown)
(pop) ; 9