(get-info :version)
; (:version "4.5.1 - build hashcode f3a0b7e0cd89")
; Started: 2017-06-05 14:59:35
; Silicon.buildVersion: 1.1-SNAPSHOT d08e1b0df844 default 2017/06/05 12:23:42
; Input file: null
; Verifier id: 00
; ------------------------------------------------------------
; Begin preamble
; ////////// Static preamble
; 
; ; /z3config.smt2
(set-option :print-success true) ; Boogie: false
(set-option :global-decls true) ; Boogie: default
(set-option :auto_config false) ; Usually a good idea
(set-option :smt.mbqi false)
(set-option :model.v2 true)
(set-option :smt.phase_selection 0)
(set-option :smt.restart_strategy 0)
(set-option :smt.restart_factor |1.5|)
(set-option :smt.arith.random_initial_value true)
(set-option :smt.case_split 3)
(set-option :smt.delay_units true)
(set-option :smt.delay_units_threshold 16)
(set-option :nnf.sk_hack true)
(set-option :smt.qi.eager_threshold 100)
(set-option :smt.qi.cost "(+ weight generation)")
(set-option :type_check true)
(set-option :smt.bv.reflect true)
; 
; ; /preamble.smt2
(declare-datatypes () ((
    $Snap ($Snap.unit)
    ($Snap.combine ($Snap.first $Snap) ($Snap.second $Snap)))))
(declare-sort $Ref 0)
(declare-const $Ref.null $Ref)
(define-sort $Perm () Real)
(define-const $Perm.Write $Perm 1.0)
(define-const $Perm.No $Perm 0.0)
(define-fun $Perm.isValidVar ((p $Perm)) Bool
	(<= $Perm.No p))
(define-fun $Perm.isReadVar ((p $Perm) (ub $Perm)) Bool
    (and ($Perm.isValidVar p)
         (not (= p $Perm.No))
         (< p $Perm.Write)))
(define-fun $Perm.min ((p1 $Perm) (p2 $Perm)) Real
    (ite (<= p1 p2) p1 p2))
(define-fun $Math.min ((a Int) (b Int)) Int
    (ite (<= a b) a b))
(define-fun $Math.clip ((a Int)) Int
    (ite (< a 0) 0 a))
; ////////// Sorts
(declare-sort Matrix)
(declare-sort $FVF<$Ref>)
(declare-sort Set<$Snap>)
(declare-sort $PSF<$Snap>)
; ////////// Sort wrappers
; Declaring additional sort wrappers
(declare-fun $SortWrappers.IntTo$Snap (Int) $Snap)
(declare-fun $SortWrappers.$SnapToInt ($Snap) Int)
(assert (forall ((x Int)) (!
    (= x ($SortWrappers.$SnapToInt($SortWrappers.IntTo$Snap x)))
    :pattern (($SortWrappers.IntTo$Snap x))
    :qid |$Snap.Int|
    )))
(declare-fun $SortWrappers.BoolTo$Snap (Bool) $Snap)
(declare-fun $SortWrappers.$SnapToBool ($Snap) Bool)
(assert (forall ((x Bool)) (!
    (= x ($SortWrappers.$SnapToBool($SortWrappers.BoolTo$Snap x)))
    :pattern (($SortWrappers.BoolTo$Snap x))
    :qid |$Snap.Bool|
    )))
(declare-fun $SortWrappers.$RefTo$Snap ($Ref) $Snap)
(declare-fun $SortWrappers.$SnapTo$Ref ($Snap) $Ref)
(assert (forall ((x $Ref)) (!
    (= x ($SortWrappers.$SnapTo$Ref($SortWrappers.$RefTo$Snap x)))
    :pattern (($SortWrappers.$RefTo$Snap x))
    :qid |$Snap.$Ref|
    )))
(declare-fun $SortWrappers.$PermTo$Snap ($Perm) $Snap)
(declare-fun $SortWrappers.$SnapTo$Perm ($Snap) $Perm)
(assert (forall ((x $Perm)) (!
    (= x ($SortWrappers.$SnapTo$Perm($SortWrappers.$PermTo$Snap x)))
    :pattern (($SortWrappers.$PermTo$Snap x))
    :qid |$Snap.$Perm|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.MatrixTo$Snap (Matrix) $Snap)
(declare-fun $SortWrappers.$SnapToMatrix ($Snap) Matrix)
(assert (forall ((x Matrix)) (!
    (= x ($SortWrappers.$SnapToMatrix($SortWrappers.MatrixTo$Snap x)))
    :pattern (($SortWrappers.MatrixTo$Snap x))
    :qid |$Snap.Matrix|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.$FVF<$Ref>To$Snap ($FVF<$Ref>) $Snap)
(declare-fun $SortWrappers.$SnapTo$FVF<$Ref> ($Snap) $FVF<$Ref>)
(assert (forall ((x $FVF<$Ref>)) (!
    (= x ($SortWrappers.$SnapTo$FVF<$Ref>($SortWrappers.$FVF<$Ref>To$Snap x)))
    :pattern (($SortWrappers.$FVF<$Ref>To$Snap x))
    :qid |$Snap.$FVF<$Ref>|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.Set<$Snap>To$Snap (Set<$Snap>) $Snap)
(declare-fun $SortWrappers.$SnapToSet<$Snap> ($Snap) Set<$Snap>)
(assert (forall ((x Set<$Snap>)) (!
    (= x ($SortWrappers.$SnapToSet<$Snap>($SortWrappers.Set<$Snap>To$Snap x)))
    :pattern (($SortWrappers.Set<$Snap>To$Snap x))
    :qid |$Snap.Set<$Snap>|
    )))
(declare-fun $SortWrappers.$PSF<$Snap>To$Snap ($PSF<$Snap>) $Snap)
(declare-fun $SortWrappers.$SnapTo$PSF<$Snap> ($Snap) $PSF<$Snap>)
(assert (forall ((x $PSF<$Snap>)) (!
    (= x ($SortWrappers.$SnapTo$PSF<$Snap>($SortWrappers.$PSF<$Snap>To$Snap x)))
    :pattern (($SortWrappers.$PSF<$Snap>To$Snap x))
    :qid |$Snap.$PSF<$Snap>|
    )))
; ////////// Symbols
(declare-fun size (Matrix) Int)
(declare-fun store_ (Matrix Int Int Int) Matrix)
(declare-fun select_ (Matrix Int Int) Int)
; /dafny_axioms/qpp_sets_declarations_dafny.smt2 [Snap]
(declare-fun Set_equal (Set<$Snap> Set<$Snap>) Bool)
(declare-fun Set_in ($Snap Set<$Snap>) Bool)
(declare-fun Set_singleton ($Snap) Set<$Snap>)
; Declaring symbols related to program functions (from program analysis)
; Snapshot variable to be used during function verification
(declare-fun s@$ () $Snap)
; Declaring predicate trigger functions
; ////////// Uniqueness assumptions from domains
; ////////// Axioms
(assert (forall ((m Matrix) (i Int) (j Int) (v Int)) (!
  (implies
    (and (<= 0 i) (and (<= 0 j) (and (< i (size m)) (< j (size m)))))
    (= (size (store_ m i j v)) (size m)))
  :pattern ((store_ m i j v))
  :qid |prog.size_store_same|)))
(assert (forall ((m Matrix)) (!
  (>= (size m) 0)
  :pattern ((size m))
  :qid |prog.size_pos|)))
(assert (and
  (forall ((m Matrix) (i1 Int) (j1 Int) (i2 Int) (j2 Int) (v Int)) (!
    (implies
      (and
        (and (<= 0 i1) (and (<= 0 j1) (and (< i1 (size m)) (< j1 (size m)))))
        (and
          (and (<= 0 i2) (and (<= 0 j2) (and (< i2 (size m)) (< j2 (size m)))))
          (or (not (= i1 i2)) (not (= j1 j2)))))
      (= (select_ (store_ m i1 j1 v) i2 j2) (select_ m i2 j2)))
    :pattern ((select_ (store_ m i1 j1 v) i2 j2))
    :qid |prog.select_store_diff|))
  (forall ((m Matrix) (i1 Int) (j1 Int) (i2 Int) (j2 Int) (v Int)) (!
    (implies
      (and
        (and (<= 0 i1) (and (<= 0 j1) (and (< i1 (size m)) (< j1 (size m)))))
        (and
          (and (<= 0 i2) (and (<= 0 j2) (and (< i2 (size m)) (< j2 (size m)))))
          (or (not (= i1 i2)) (not (= j1 j2)))))
      (= (select_ (store_ m i1 j1 v) i2 j2) (select_ m i2 j2)))
    :pattern ((select_ m i2 j2) (store_ m i1 j1 v))
    :qid |prog.select_store_diff|))))
(assert (forall ((m Matrix) (i Int) (j Int) (v Int)) (!
  (implies
    (and (<= 0 i) (and (<= 0 j) (and (< i (size m)) (< j (size m)))))
    (= (select_ (store_ m i j v) i j) v))
  :pattern ((select_ (store_ m i j v) i j))
  :qid |prog.select_store_same|)))
; End preamble
; ------------------------------------------------------------
; ------------------------------------------------------------
; Begin function- and predicate-related preamble
; Declaring symbols related to program functions (from verification)
; End function- and predicate-related preamble
; ------------------------------------------------------------
; ---------- add ----------
(declare-const m1@0@01 Matrix)
(declare-const m2@1@01 Matrix)
(declare-const m3@2@01 Matrix)
(declare-const i@3@01 Int)
(declare-const j@4@01 Int)
(declare-const $t@5@01 $Snap)
(assert (= $t@5@01 $Snap.unit))
; [eval] size(m1) == size(m2)
; [eval] size(m1)
; [eval] size(m2)
(assert (= (size m1@0@01) (size m2@1@01)))
; [exec]
; inhale size(m3) == size(m1)
(declare-const $t@6@01 $Snap)
(assert (= $t@6@01 $Snap.unit))
; [eval] size(m3) == size(m1)
; [eval] size(m3)
; [eval] size(m1)
(assert (= (size m3@2@01) (size m1@0@01)))
; [exec]
; i := 0
(declare-const j@7@01 Int)
(declare-const m3@8@01 Matrix)
(declare-const i@9@01 Int)
(declare-const $t@10@01 $Snap)
(declare-const x@11@01 Int)
(declare-const y@12@01 Int)
; Loop head block: Establish invariant
; [eval] (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
(declare-const x@16@01 Int)
(declare-const y@17@01 Int)
; Nested auxiliary terms
; [eval] i <= size(m1)
; [eval] size(m1)
(set-option :timeout 0)
; 0.00s
; (get-info :all-statistics)
(assert (<= 0 (size m1@0@01)))
; [eval] i >= 0
; [eval] size(m3) == size(m1)
; [eval] size(m3)
; [eval] size(m1)
; Loop head block: Execute statements of loop head block (in invariant state)
(assert (= $t@10@01 ($Snap.combine $Snap.unit $Snap.unit)))
(assert (forall ((x@11@01 Int) (y@12@01 Int)) (!
  (implies
    (and
      (<= 0 x@11@01)
      (implies
        (<= 0 x@11@01)
        (and
          (<= 0 y@12@01)
          (implies
            (<= 0 y@12@01)
            (and
              (< x@11@01 i@9@01)
              (implies (< x@11@01 i@9@01) (< y@12@01 (size m1@0@01))))))))
    (=
      (select_ m3@8@01 x@11@01 y@12@01)
      (+ (select_ m1@0@01 x@11@01 y@12@01) (select_ m2@1@01 x@11@01 y@12@01))))
  :pattern ((select_ m3@8@01 x@11@01 y@12@01))
  :qid |prog.l33|)))
(assert (<= i@9@01 (size m1@0@01)))
(assert (>= i@9@01 0))
(assert (= (size m3@8@01) (size m1@0@01)))
(set-option :timeout 250)
(check-sat)
; unknown
; Loop head block: Follow loop-internal edges
; [eval] i < size(m1)
; [eval] size(m1)
; 0.00s
; (get-info :all-statistics)
; 0.00s
; (get-info :all-statistics)
; [then-branch: 8 | i@9@01 < size(m1@0@01) | live]
; [else-branch: 8 | !i@9@01 < size(m1@0@01) | live]
; [then-branch: 8 | i@9@01 < size(m1@0@01)]
(assert (< i@9@01 (size m1@0@01)))
; [exec]
; j := 0
(declare-const m3@21@01 Matrix)
(declare-const j@22@01 Int)
(declare-const $t@23@01 $Snap)
(declare-const y@24@01 Int)
(declare-const x@26@01 Int)
(declare-const y@27@01 Int)
; Loop head block: Establish invariant
; [eval] (forall y: Int :: { select(m3, i, y) } 0 <= y && y < j ==> select(m3, i, y) == select(m1, i, y) + select(m2, i, y))
(declare-const y@31@01 Int)
; Nested auxiliary terms
; [eval] (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
(declare-const x@33@01 Int)
(declare-const y@34@01 Int)
; Nested auxiliary terms
(set-option :timeout 0)
; 0.00s
; (get-info :all-statistics)
(assert (forall ((x@33@01 Int) (y@34@01 Int)) (!
  (implies
    (and
      (<= 0 x@33@01)
      (implies
        (<= 0 x@33@01)
        (and
          (<= 0 y@34@01)
          (implies
            (<= 0 y@34@01)
            (and
              (< x@33@01 i@9@01)
              (implies (< x@33@01 i@9@01) (< y@34@01 (size m1@0@01))))))))
    (=
      (select_ m3@8@01 x@33@01 y@34@01)
      (+ (select_ m1@0@01 x@33@01 y@34@01) (select_ m2@1@01 x@33@01 y@34@01))))
  :pattern ((select_ m3@8@01 x@33@01 y@34@01))
  :qid |prog.l41|)))
; [eval] j <= size(m1)
; [eval] size(m1)
; [eval] j >= 0
; [eval] size(m3) == size(m1)
; [eval] size(m3)
; [eval] size(m1)
; Loop head block: Execute statements of loop head block (in invariant state)
(assert (= $t@23@01 ($Snap.combine $Snap.unit $Snap.unit)))
(assert (forall ((y@24@01 Int)) (!
  (implies
    (and (<= 0 y@24@01) (implies (<= 0 y@24@01) (< y@24@01 j@22@01)))
    (=
      (select_ m3@21@01 i@9@01 y@24@01)
      (+ (select_ m1@0@01 i@9@01 y@24@01) (select_ m2@1@01 i@9@01 y@24@01))))
  :pattern ((select_ m3@21@01 i@9@01 y@24@01))
  :qid |prog.l40|)))
(assert (forall ((x@26@01 Int) (y@27@01 Int)) (!
  (implies
    (and
      (<= 0 x@26@01)
      (implies
        (<= 0 x@26@01)
        (and
          (<= 0 y@27@01)
          (implies
            (<= 0 y@27@01)
            (and
              (< x@26@01 i@9@01)
              (implies (< x@26@01 i@9@01) (< y@27@01 (size m1@0@01))))))))
    (=
      (select_ m3@21@01 x@26@01 y@27@01)
      (+ (select_ m1@0@01 x@26@01 y@27@01) (select_ m2@1@01 x@26@01 y@27@01))))
  :pattern ((select_ m3@21@01 x@26@01 y@27@01))
  :qid |prog.l41|)))
(assert (<= j@22@01 (size m1@0@01)))
(assert (>= j@22@01 0))
(assert (= (size m3@21@01) (size m1@0@01)))
(set-option :timeout 250)
(check-sat)
; unknown
; Loop head block: Follow loop-internal edges
; [eval] j < size(m1)
; [eval] size(m1)
; 0.00s
; (get-info :all-statistics)
; 0.00s
; (get-info :all-statistics)
; [then-branch: 21 | j@22@01 < size(m1@0@01) | live]
; [else-branch: 21 | !j@22@01 < size(m1@0@01) | live]
(declare-const m3@38@01 Matrix)
(declare-const j@39@01 Int)
(declare-const y@40@01 Int)
(declare-const x@42@01 Int)
(declare-const y@43@01 Int)
; [eval] !(j < size(m1))
; [eval] j < size(m1)
; [eval] size(m1)
(set-option :timeout 250)
; 0.00s
; (get-info :all-statistics)
; 0.00s
; (get-info :all-statistics)
; [then-branch: 28 | !j@22@01 < size(m1@0@01) | live]
; [else-branch: 28 | j@22@01 < size(m1@0@01) | live]
; [then-branch: 28 | !j@22@01 < size(m1@0@01)]
(assert (not (< j@22@01 (size m1@0@01))))
; [exec]
; i := i + 1
; [eval] i + 1
(declare-const i@47@01 Int)
(assert (= i@47@01 (+ i@9@01 1)))
; [exec]
; assert (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
; [eval] (forall x: Int, y: Int :: { select(m3, x, y) } 0 <= x && (0 <= y && (x < i && y < size(m1))) ==> select(m3, x, y) == select(m1, x, y) + select(m2, x, y))
(declare-const x@48@01 Int)
(declare-const y@49@01 Int)
; Nested auxiliary terms
(set-option :timeout 0)
(push) ; 9
(assert (not (forall ((x@48@01 Int) (y@49@01 Int)) (!
  (implies
    (and
      (<= 0 x@48@01)
      (implies
        (<= 0 x@48@01)
        (and
          (<= 0 y@49@01)
          (implies
            (<= 0 y@49@01)
            (and
              (< x@48@01 i@47@01)
              (implies (< x@48@01 i@47@01) (< y@49@01 (size m1@0@01))))))))
    (=
      (select_ m3@21@01 x@48@01 y@49@01)
      (+ (select_ m1@0@01 x@48@01 y@49@01) (select_ m2@1@01 x@48@01 y@49@01))))
  :pattern ((select_ m3@21@01 x@48@01 y@49@01))
  :qid |prog.l70|))))
(check-sat)
(pop) ; 9