(get-info :version)
; (:version "4.4.0")
; Input file is C:\Users\scmalte.D\AppData\Local\Temp\arraylist-quantified-permissions_LOOP.sil
; Started: 2016-09-26 12:25:17
; Silicon.buildVersion: 1.1-SNAPSHOT bffd9d1be2dd+ default 2016/09/21 11:07:16
; ------------------------------------------------------------
; Preamble start
; 
; ; /z3config.smt2
(set-option :print-success true) ; Boogie: false
(set-option :global-decls true) ; Boogie: default
(set-option :auto_config false) ; Usually a good idea
(set-option :smt.mbqi false)
(set-option :model.v2 true)
(set-option :smt.phase_selection 0)
(set-option :smt.restart_strategy 0)
(set-option :smt.restart_factor |1.5|)
(set-option :smt.arith.random_initial_value true)
(set-option :smt.case_split 3)
(set-option :smt.delay_units true)
(set-option :smt.delay_units_threshold 16)
(set-option :nnf.sk_hack true)
(set-option :smt.qi.eager_threshold 100)
(set-option :smt.qi.cost "(+ weight generation)")
(set-option :type_check true)
(set-option :smt.bv.reflect true)
; 
; ; /preamble.smt2
(declare-datatypes () ((
    $Snap ($Snap.unit)
    ($Snap.combine ($Snap.first $Snap) ($Snap.second $Snap)))))
(declare-sort $Ref 0)
(declare-const $Ref.null $Ref)
(define-sort $Perm () Real)
(define-const $Perm.Write $Perm 1.0)
(define-const $Perm.No $Perm 0.0)
(define-fun $Perm.isValidVar ((p $Perm)) Bool
	(<= $Perm.No p))
(define-fun $Perm.isReadVar ((p $Perm) (ub $Perm)) Bool
    (and ($Perm.isValidVar p)
         (not (= p $Perm.No))
         (< p $Perm.Write)))
(define-fun $Perm.min ((p1 $Perm) (p2 $Perm)) Real
    (ite (<= p1 p2) p1 p2))
(define-fun $Math.min ((a Int) (b Int)) Int
    (ite (<= a b) a b))
(define-fun $Math.clip ((a Int)) Int
    (ite (< a 0) 0 a))
(declare-sort $Seq<Int>)
(declare-sort $Set<Int>)
(declare-sort $Set<Array_>)
(declare-sort $Set<$Ref>)
(declare-sort Array_)
(declare-sort Pair<Array~_Int>)
(declare-sort $FVF<$Ref>)
(declare-sort $FVF<Int>)
; /dafny_axioms/sets_declarations_dafny.smt2 [Int]
(declare-fun $Set.in (Int $Set<Int>) Bool)
(declare-fun $Set.card ($Set<Int>) Int)
(declare-fun $Set.empty<Int> () $Set<Int>)
(declare-fun $Set.singleton (Int) $Set<Int>)
(declare-fun $Set.unionone ($Set<Int> Int) $Set<Int>)
(declare-fun $Set.union ($Set<Int> $Set<Int>) $Set<Int>)
(declare-fun $Set.disjoint ($Set<Int> $Set<Int>) Bool)
(declare-fun $Set.difference ($Set<Int> $Set<Int>) $Set<Int>)
(declare-fun $Set.intersection ($Set<Int> $Set<Int>) $Set<Int>)
(declare-fun $Set.subset ($Set<Int> $Set<Int>) Bool)
(declare-fun $Set.equal ($Set<Int> $Set<Int>) Bool)
; /dafny_axioms/sets_declarations_dafny.smt2 [Array]
(declare-fun $Set.in (Array_ $Set<Array_>) Bool)
(declare-fun $Set.card ($Set<Array_>) Int)
(declare-fun $Set.empty<Array_> () $Set<Array_>)
(declare-fun $Set.singleton (Array_) $Set<Array_>)
(declare-fun $Set.unionone ($Set<Array_> Array_) $Set<Array_>)
(declare-fun $Set.union ($Set<Array_> $Set<Array_>) $Set<Array_>)
(declare-fun $Set.disjoint ($Set<Array_> $Set<Array_>) Bool)
(declare-fun $Set.difference ($Set<Array_> $Set<Array_>) $Set<Array_>)
(declare-fun $Set.intersection ($Set<Array_> $Set<Array_>) $Set<Array_>)
(declare-fun $Set.subset ($Set<Array_> $Set<Array_>) Bool)
(declare-fun $Set.equal ($Set<Array_> $Set<Array_>) Bool)
; /dafny_axioms/sets_declarations_dafny.smt2 [Ref]
(declare-fun $Set.in ($Ref $Set<$Ref>) Bool)
(declare-fun $Set.card ($Set<$Ref>) Int)
(declare-fun $Set.empty<$Ref> () $Set<$Ref>)
(declare-fun $Set.singleton ($Ref) $Set<$Ref>)
(declare-fun $Set.unionone ($Set<$Ref> $Ref) $Set<$Ref>)
(declare-fun $Set.union ($Set<$Ref> $Set<$Ref>) $Set<$Ref>)
(declare-fun $Set.disjoint ($Set<$Ref> $Set<$Ref>) Bool)
(declare-fun $Set.difference ($Set<$Ref> $Set<$Ref>) $Set<$Ref>)
(declare-fun $Set.intersection ($Set<$Ref> $Set<$Ref>) $Set<$Ref>)
(declare-fun $Set.subset ($Set<$Ref> $Set<$Ref>) Bool)
(declare-fun $Set.equal ($Set<$Ref> $Set<$Ref>) Bool)
; /dafny_axioms/sequences_declarations_dafny.smt2 [Int]
(declare-fun $Seq.length ($Seq<Int>) Int)
(declare-fun $Seq.empty<Int> () $Seq<Int>)
(declare-fun $Seq.singleton (Int) $Seq<Int>)
(declare-fun $Seq.build ($Seq<Int> Int) $Seq<Int>)
(declare-fun $Seq.index ($Seq<Int> Int) Int)
(declare-fun $Seq.append ($Seq<Int> $Seq<Int>) $Seq<Int>)
(declare-fun $Seq.update ($Seq<Int> Int Int) $Seq<Int>)
(declare-fun $Seq.contains ($Seq<Int> Int) Bool)
(declare-fun $Seq.take ($Seq<Int> Int) $Seq<Int>)
(declare-fun $Seq.drop ($Seq<Int> Int) $Seq<Int>)
(declare-fun $Seq.equal ($Seq<Int> $Seq<Int>) Bool)
(declare-fun $Seq.sameuntil ($Seq<Int> $Seq<Int> Int) Bool)
; /dafny_axioms/sequences_int_declarations_dafny.smt2
(declare-fun $Seq.range (Int Int) $Seq<Int>)
(declare-fun second<Pair<Array~_Int>~Int> (Pair<Array~_Int>) Int)
(declare-fun first<Pair<Array~_Int>~Array> (Pair<Array~_Int>) Array_)
(declare-fun inv_loc<Ref~Pair<Array~_Int>> ($Ref) Pair<Array~_Int>)
(declare-fun len<Array~Int> (Array_) Int)
(declare-fun loc<Array~Int~Ref> (Array_ Int) $Ref)
; /field_value_functions_declarations.smt2 [val: Int]
(declare-fun $FVF.domain_val ($FVF<Int>) $Set<$Ref>)
(declare-fun $FVF.lookup_val ($FVF<Int> $Ref) Int)
(declare-fun $FVF.after_val ($FVF<Int> $FVF<Int>) Bool)
(declare-const $fvfTOP_val $FVF<Int>)
; Declaring program functions
(declare-fun length ($Snap $Ref) Int)
(declare-fun length%limited ($Snap $Ref) Int)
(declare-fun length%stateless ($Ref) Bool)
(declare-fun length_fvfgen_val ($Snap $Ref) $FVF<Int>)
(declare-fun itemAt ($Snap $Ref Int) Int)
(declare-fun itemAt%limited ($Snap $Ref Int) Int)
(declare-fun itemAt%stateless ($Ref Int) Bool)
(declare-fun itemAt_fvfgen_val ($Snap $Ref Int) $FVF<Int>)
(declare-fun content ($Snap $Ref) $Seq<Int>)
(declare-fun content%limited ($Snap $Ref) $Seq<Int>)
(declare-fun content%stateless ($Ref) Bool)
(declare-fun content_fvfgen_val ($Snap $Ref) $FVF<Int>)
; Snapshot variable to be used during function verification
(declare-fun s@$ () $Snap)
; Declaring predicate trigger functions
(declare-fun AList%trigger ($Snap $Ref) Bool)
; /dafny_axioms/sequences_axioms_dafny.smt2 [Int]
(assert (forall ((s $Seq<Int>) ) (! (<= 0 ($Seq.length s))
  :pattern ( ($Seq.length s))
  )))
(assert (= ($Seq.length $Seq.empty<Int>) 0))
(assert (forall ((s $Seq<Int>) ) (! (=> (= ($Seq.length s) 0) (= s $Seq.empty<Int>))
  :pattern ( ($Seq.length s))
  )))
(assert (forall ((t Int) ) (! (= ($Seq.length ($Seq.singleton t)) 1)
  :pattern ( ($Seq.length ($Seq.singleton t)))
  )))
(assert (forall ((s $Seq<Int>) (v Int) ) (! (= ($Seq.length ($Seq.build s v)) (+ 1 ($Seq.length s)))
  :pattern ( ($Seq.length ($Seq.build s v)))
  )))
(assert (forall ((s $Seq<Int>) (i Int) (v Int) ) (! (and
  (=> (= i ($Seq.length s)) (= ($Seq.index ($Seq.build s v) i) v))
  (=> (not (= i ($Seq.length s))) (= ($Seq.index ($Seq.build s v) i) ($Seq.index s i))))
  :pattern ( ($Seq.index ($Seq.build s v) i))
  )))
(assert (forall ((s0 $Seq<Int>) (s1 $Seq<Int>) ) (!
  (implies ; The implication was not in the Dafny version
    (and
      (not (= s0 $Seq.empty<Int>))
      (not (= s1 $Seq.empty<Int>)))
    (=
      ($Seq.length ($Seq.append s0 s1))
      (+ ($Seq.length s0) ($Seq.length s1))))
  :pattern ( ($Seq.length ($Seq.append s0 s1)))
  )))
(assert (forall ((t Int) ) (! (= ($Seq.index ($Seq.singleton t) 0) t)
  :pattern ( ($Seq.index ($Seq.singleton t) 0))
  )))
(assert (forall ((s $Seq<Int>)) (! ; The axiom was not in the Dafny version
  (= ($Seq.append s $Seq.empty<Int>) s)
  :pattern (($Seq.append s $Seq.empty<Int>))
  )))
(assert (forall ((s $Seq<Int>)) (! ; The axiom was not in the Dafny version
  (= ($Seq.append $Seq.empty<Int> s) s)
  :pattern (($Seq.append $Seq.empty<Int> s))
  )))
(assert (forall ((s0 $Seq<Int>) (s1 $Seq<Int>) (n Int) ) (!
  (implies ; The implication was not in the Dafny version
    (and
      (not (= s0 $Seq.empty<Int>))
      (not (= s1 $Seq.empty<Int>)))
    (and
      (=> (< n ($Seq.length s0)) (= ($Seq.index ($Seq.append s0 s1) n) ($Seq.index s0 n)))
      (=> (<= ($Seq.length s0) n) (= ($Seq.index ($Seq.append s0 s1) n) ($Seq.index s1 (- n ($Seq.length s0)))))))
  :pattern ( ($Seq.index ($Seq.append s0 s1) n))
  )))
(assert (forall ((s $Seq<Int>) (i Int) (v Int) ) (! (=> (and
  (<= 0 i)
  (< i ($Seq.length s))) (= ($Seq.length ($Seq.update s i v)) ($Seq.length s)))
  :pattern ( ($Seq.length ($Seq.update s i v)))
  )))
(assert (forall ((s $Seq<Int>) (i Int) (v Int) (n Int) ) (! (=> (and
  (<= 0 n)
  (< n ($Seq.length s))) (and
  (=> (= i n) (= ($Seq.index ($Seq.update s i v) n) v))
  (=> (not (= i n)) (= ($Seq.index ($Seq.update s i v) n) ($Seq.index s n)))))
  :pattern ( ($Seq.index ($Seq.update s i v) n))
  )))
(assert (forall ((s $Seq<Int>) (x Int) ) (!
  (and
    (=>
      ($Seq.contains s x)
      (exists ((i Int) ) (!
        (and
  (<= 0 i)
  (< i ($Seq.length s))
  (= ($Seq.index s i) x))
  :pattern ( ($Seq.index s i))
  )))
    (=>
      (exists ((i Int) ) (!
        (and
  (<= 0 i)
  (< i ($Seq.length s))
  (= ($Seq.index s i) x))
  :pattern ( ($Seq.index s i))
      ))
      ($Seq.contains s x)))
  :pattern ( ($Seq.contains s x))
  )))
(assert (forall ((x Int) ) (! (not ($Seq.contains $Seq.empty<Int> x))
  :pattern ( ($Seq.contains $Seq.empty<Int> x))
  )))
(assert (forall ((s0 $Seq<Int>) (s1 $Seq<Int>) (x Int) ) (! (and
  (=> ($Seq.contains ($Seq.append s0 s1) x) (or
  ($Seq.contains s0 x)
  ($Seq.contains s1 x)))
  (=> (or
  ($Seq.contains s0 x)
  ($Seq.contains s1 x)) ($Seq.contains ($Seq.append s0 s1) x)))
  :pattern ( ($Seq.contains ($Seq.append s0 s1) x))
  )))
(assert (forall ((s $Seq<Int>) (v Int) (x Int) ) (! (and
  (=> ($Seq.contains ($Seq.build s v) x) (or
  (= v x)
  ($Seq.contains s x)))
  (=> (or
  (= v x)
  ($Seq.contains s x)) ($Seq.contains ($Seq.build s v) x)))
  :pattern ( ($Seq.contains ($Seq.build s v) x))
  )))
(assert (forall ((s $Seq<Int>) (n Int) (x Int) ) (!
  (and
    (=>
      ($Seq.contains ($Seq.take s n) x)
      (exists ((i Int) ) (!
        (and
  (<= 0 i)
  (< i n)
  (< i ($Seq.length s))
  (= ($Seq.index s i) x))
  :pattern ( ($Seq.index s i))
  )))
    (=>
      (exists ((i Int) ) (!
        (and
  (<= 0 i)
  (< i n)
  (< i ($Seq.length s))
  (= ($Seq.index s i) x))
  :pattern ( ($Seq.index s i))
      ))
      ($Seq.contains ($Seq.take s n) x)))
  :pattern ( ($Seq.contains ($Seq.take s n) x))
  )))
(assert (forall ((s $Seq<Int>) (n Int) (x Int) ) (!
  (and
    (=>
      ($Seq.contains ($Seq.drop s n) x)
      (exists ((i Int) ) (!
        (and
  (<= 0 n)
  (<= n i)
  (< i ($Seq.length s))
  (= ($Seq.index s i) x))
  :pattern ( ($Seq.index s i))
  )))
    (=>
      (exists ((i Int) ) (!
        (and
  (<= 0 n)
  (<= n i)
  (< i ($Seq.length s))
  (= ($Seq.index s i) x))
  :pattern ( ($Seq.index s i))
      ))
      ($Seq.contains ($Seq.drop s n) x)))
  :pattern ( ($Seq.contains ($Seq.drop s n) x))
  )))
(assert (forall ((s0 $Seq<Int>) (s1 $Seq<Int>) ) (! (and
  (=> ($Seq.equal s0 s1) (and
  (= ($Seq.length s0) ($Seq.length s1))
  (forall ((j Int) ) (! (=> (and
  (<= 0 j)
  (< j ($Seq.length s0))) (= ($Seq.index s0 j) ($Seq.index s1 j)))
  :pattern ( ($Seq.index s0 j))
  :pattern ( ($Seq.index s1 j))
  ))))
  (=> (and
  (= ($Seq.length s0) ($Seq.length s1))
  (forall ((j Int) ) (! (=> (and
  (<= 0 j)
  (< j ($Seq.length s0))) (= ($Seq.index s0 j) ($Seq.index s1 j)))
  :pattern ( ($Seq.index s0 j))
  :pattern ( ($Seq.index s1 j))
  ))) ($Seq.equal s0 s1)))
  :pattern ( ($Seq.equal s0 s1))
  )))
(assert (forall ((a $Seq<Int>) (b $Seq<Int>) ) (! (=> ($Seq.equal a b) (= a b))
  :pattern ( ($Seq.equal a b))
  )))
(assert (forall ((s0 $Seq<Int>) (s1 $Seq<Int>) (n Int) ) (! (and
  (=> ($Seq.sameuntil s0 s1 n) (forall ((j Int) ) (! (=> (and
  (<= 0 j)
  (< j n)) (= ($Seq.index s0 j) ($Seq.index s1 j)))
  :pattern ( ($Seq.index s0 j))
  :pattern ( ($Seq.index s1 j))
  )))
  (=> (forall ((j Int) ) (! (=> (and
  (<= 0 j)
  (< j n)) (= ($Seq.index s0 j) ($Seq.index s1 j)))
  :pattern ( ($Seq.index s0 j))
  :pattern ( ($Seq.index s1 j))
  )) ($Seq.sameuntil s0 s1 n)))
  :pattern ( ($Seq.sameuntil s0 s1 n))
  )))
(assert (forall ((s $Seq<Int>) (n Int) ) (! (=> (<= 0 n) (and
  (=> (<= n ($Seq.length s)) (= ($Seq.length ($Seq.take s n)) n))
  (=> (< ($Seq.length s) n) (= ($Seq.length ($Seq.take s n)) ($Seq.length s)))))
  :pattern ( ($Seq.length ($Seq.take s n)))
  )))
(assert (forall ((s $Seq<Int>) (n Int) (j Int) ) (! (=> (and
  (<= 0 j)
  (< j n)
  (< j ($Seq.length s))) (= ($Seq.index ($Seq.take s n) j) ($Seq.index s j)))
  :pattern ( ($Seq.index ($Seq.take s n) j))
  :pattern (($Seq.index s j) ($Seq.take s n)) ; [XXX] Added 29-10-2015
  )))
(assert (forall ((s $Seq<Int>) (n Int) ) (! (=> (<= 0 n) (and
  (=> (<= n ($Seq.length s)) (= ($Seq.length ($Seq.drop s n)) (- ($Seq.length s) n)))
  (=> (< ($Seq.length s) n) (= ($Seq.length ($Seq.drop s n)) 0))))
  :pattern ( ($Seq.length ($Seq.drop s n)))
  )))
(assert (forall ((s $Seq<Int>) (n Int) (j Int) ) (! (=> (and
  (<= 0 n)
  (<= 0 j)
  (< j (- ($Seq.length s) n))) (= ($Seq.index ($Seq.drop s n) j) ($Seq.index s (+ j n))))
  :pattern ( ($Seq.index ($Seq.drop s n) j))
  )))
(assert (forall ((s $Seq<Int>) (n Int) (k Int) ) (! ; [XXX] Added 29-10-2015
  (=>
    (and
      (<= 0 n)
      (<= n k)
      (< k ($Seq.length s)))
    (=
      ($Seq.index ($Seq.drop s n) (- k n))
      ($Seq.index s k)))
  :pattern (($Seq.index s k) ($Seq.drop s n))
  )))
(assert (forall ((s $Seq<Int>) (i Int) (v Int) (n Int) ) (! (=> (and
  (<= 0 i)
  (< i n)
  (<= n ($Seq.length s))) (= ($Seq.take ($Seq.update s i v) n) ($Seq.update ($Seq.take s n) i v)))
  :pattern ( ($Seq.take ($Seq.update s i v) n))
  )))
(assert (forall ((s $Seq<Int>) (i Int) (v Int) (n Int) ) (! (=> (and
  (<= n i)
  (< i ($Seq.length s))) (= ($Seq.take ($Seq.update s i v) n) ($Seq.take s n)))
  :pattern ( ($Seq.take ($Seq.update s i v) n))
  )))
(assert (forall ((s $Seq<Int>) (i Int) (v Int) (n Int) ) (! (=> (and
  (<= 0 n)
  (<= n i)
  (< i ($Seq.length s))) (= ($Seq.drop ($Seq.update s i v) n) ($Seq.update ($Seq.drop s n) (- i n) v)))
  :pattern ( ($Seq.drop ($Seq.update s i v) n))
  )))
(assert (forall ((s $Seq<Int>) (i Int) (v Int) (n Int) ) (! (=> (and
  (<= 0 i)
  (< i n)
  (< n ($Seq.length s))) (= ($Seq.drop ($Seq.update s i v) n) ($Seq.drop s n)))
  :pattern ( ($Seq.drop ($Seq.update s i v) n))
  )))
(assert (forall ((s $Seq<Int>) (v Int) (n Int) ) (! (=> (and
  (<= 0 n)
  (<= n ($Seq.length s))) (= ($Seq.drop ($Seq.build s v) n) ($Seq.build ($Seq.drop s n) v)))
  :pattern ( ($Seq.drop ($Seq.build s v) n))
  )))
(assert (forall ((x Int) (y Int)) (!
  (iff
    ($Seq.contains ($Seq.singleton x) y)
    (= x y))
  :pattern (($Seq.contains ($Seq.singleton x) y))
  )))
; /dafny_axioms/sequences_int_axioms_dafny.smt2
(assert (forall ((min Int) (max Int) ) (! (and
  (=> (< min max) (= ($Seq.length ($Seq.range min max)) (- max min)))
  (=> (<= max min) (= ($Seq.length ($Seq.range min max)) 0)))
   :pattern ( ($Seq.length ($Seq.range min max)))
  )))
(assert (forall ((min Int) (max Int) (j Int) ) (! (=> (and
  (<= 0 j)
  (< j (- max min))) (= ($Seq.index ($Seq.range min max) j) (+ min j)))
   :pattern ( ($Seq.index ($Seq.range min max) j))
  )))
(assert (forall ((min Int) (max Int) (v Int) ) (! (and
  (=> ($Seq.contains ($Seq.range min max) v) (and
  (<= min v)
  (< v max)))
  (=> (and
  (<= min v)
  (< v max)) ($Seq.contains ($Seq.range min max) v)))
   :pattern ( ($Seq.contains ($Seq.range min max) v))
  )))
; /dafny_axioms/sets_axioms_dafny.smt2 [Int]
(assert (forall ((s $Set<Int>)) (!
  (<= 0 ($Set.card s))
  :pattern (($Set.card s))
  )))
(assert (forall ((o Int)) (!
  (not ($Set.in o $Set.empty<Int>))
  :pattern (($Set.in o $Set.empty<Int>))
  )))
(assert (forall ((s $Set<Int>)) (!
  (and
    (iff
      (= ($Set.card s) 0)
      (= s $Set.empty<Int>))
    (implies
      (not (= ($Set.card s) 0))
      (exists ((x Int)) (!
        ($Set.in x s)
        :pattern (($Set.in x s))
      ))))
  :pattern (($Set.card s))
  )))
(assert (forall ((r Int)) (!
  ($Set.in r ($Set.singleton r))
  :pattern (($Set.singleton r)) ; Dafny
  )))
(assert (forall ((r Int) (o Int)) (!
  (iff
    ($Set.in o ($Set.singleton r))
    (= r o))
  :pattern (($Set.in o ($Set.singleton r)))
  )))
(assert (forall ((r Int)) (!
  (= ($Set.card ($Set.singleton r)) 1)
  :pattern (($Set.card ($Set.singleton r)))
  )))
(assert (forall ((a $Set<Int>) (x Int) (o Int)) (!
  (iff
    ($Set.in o ($Set.unionone a x))
    (or
      (= o x)
      ($Set.in o a)))
  :pattern (($Set.in o ($Set.unionone a x)))
  )))
(assert (forall ((a $Set<Int>) (x Int)) (!
  ($Set.in x ($Set.unionone a x))
  :pattern (($Set.unionone a x)) ; Dafny
  )))
(assert (forall ((a $Set<Int>) (x Int) (y Int)) (!
  (=>
    ($Set.in y a)
    ($Set.in y ($Set.unionone a x)))
  :pattern (($Set.in y a) ($Set.unionone a x)) ; Dafny
  )))
(assert (forall ((a $Set<Int>) (x Int)) (!
  (=>
    ($Set.in x a)
    (= ($Set.card ($Set.unionone a x)) ($Set.card a)))
  :pattern (($Set.card ($Set.unionone a x)))
  )))
(assert (forall ((a $Set<Int>) (x Int)) (!
  (=>
    (not ($Set.in x a))
    (= ($Set.card ($Set.unionone a x)) (+ ($Set.card a) 1)))
  :pattern (($Set.card ($Set.unionone a x)))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>) (o Int)) (!
  (iff
    ($Set.in o ($Set.union a b))
    (or
      ($Set.in o a)
      ($Set.in o b)))
  :pattern (($Set.in o ($Set.union a b)))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>) (y Int)) (!
  (=>
    ($Set.in y a)
    ($Set.in y ($Set.union a b)))
  :pattern (($Set.union a b) ($Set.in y a)) ; Dafny
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>) (y Int)) (!
  (=>
    ($Set.in y b)
    ($Set.in y ($Set.union a b)))
  :pattern (($Set.union a b) ($Set.in y b)) ; Dafny
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>) (o Int)) (!
  (iff
    ($Set.in o ($Set.intersection a b))
    (and
      ($Set.in o a)
      ($Set.in o b)))
  :pattern (($Set.in o ($Set.intersection a b)))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>)) (!
  (=
    ($Set.union ($Set.union a b) b)
    ($Set.union a b))
  :pattern (($Set.union ($Set.union a b) b))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>)) (!
  (=
    ($Set.union a ($Set.union a b))
    ($Set.union a b))
    :pattern (($Set.union a ($Set.union a b)))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>)) (!
  (=
    ($Set.intersection ($Set.intersection a b) b)
    ($Set.intersection a b))
  :pattern (($Set.intersection ($Set.intersection a b) b))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>)) (!
  (=
    ($Set.intersection a ($Set.intersection a b))
    ($Set.intersection a b))
  :pattern (($Set.intersection a ($Set.intersection a b)))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>)) (!
  (=
    (+
      ($Set.card ($Set.union a b))
      ($Set.card ($Set.intersection a b)))
    (+
      ($Set.card a)
      ($Set.card b)))
  :pattern (($Set.card ($Set.union a b)))
  :pattern (($Set.card ($Set.intersection a b)))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>) (o Int)) (!
  (iff
    ($Set.in o ($Set.difference a b))
    (and
      ($Set.in o a)
      (not ($Set.in o b))))
  :pattern (($Set.in o ($Set.difference a b)))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>) (y Int)) (!
  (=>
    ($Set.in y b)
    (not ($Set.in y ($Set.difference a b))))
  :pattern (($Set.difference a b) ($Set.in y b)) ; Dafny
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>)) (!
  (iff
    ($Set.subset a b)
    (forall ((o Int)) (!
      (=>
        ($Set.in o a)
        ($Set.in o b))
      :pattern (($Set.in o a))
      :pattern (($Set.in o b))
    )))
  :pattern (($Set.subset a b))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>)) (!
  (iff
    ($Set.equal a b)
    (forall ((o Int)) (!
      (iff
        ($Set.in o a)
        ($Set.in o b))
      :pattern (($Set.in o a))
      :pattern (($Set.in o b))
      :qid |$Set<Int>.ext-inner|
      )))
  :pattern (($Set.equal a b))
  :qid |$Set<Int>.ext-outer|
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>)) (!
  (=>
    ($Set.equal a b)
    (= a b))
  :pattern (($Set.equal a b))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>)) (!
  (iff
    ($Set.disjoint a b)
    (forall ((o Int)) (!
      (or
        (not ($Set.in o a))
        (not ($Set.in o b)))
      :pattern (($Set.in o a))
      :pattern (($Set.in o b))
      )))
  :pattern (($Set.disjoint a b))
  )))
(assert (forall ((a $Set<Int>) (b $Set<Int>)) (!
  (and
    (=
      (+
        (+
          ($Set.card ($Set.difference a b))
          ($Set.card ($Set.difference b a)))
        ($Set.card ($Set.intersection a b)))
      ($Set.card ($Set.union a b)))
    (=
      ($Set.card ($Set.difference a b))
      (-
        ($Set.card a)
        ($Set.card ($Set.intersection a b)))))
  :pattern (($Set.card ($Set.difference a b))) ; Dafny
  )))
; /dafny_axioms/sets_axioms_dafny.smt2 [Array]
(assert (forall ((s $Set<Array_>)) (!
  (<= 0 ($Set.card s))
  :pattern (($Set.card s))
  )))
(assert (forall ((o Array_)) (!
  (not ($Set.in o $Set.empty<Array_>))
  :pattern (($Set.in o $Set.empty<Array_>))
  )))
(assert (forall ((s $Set<Array_>)) (!
  (and
    (iff
      (= ($Set.card s) 0)
      (= s $Set.empty<Array_>))
    (implies
      (not (= ($Set.card s) 0))
      (exists ((x Array_)) (!
        ($Set.in x s)
        :pattern (($Set.in x s))
      ))))
  :pattern (($Set.card s))
  )))
(assert (forall ((r Array_)) (!
  ($Set.in r ($Set.singleton r))
  :pattern (($Set.singleton r)) ; Dafny
  )))
(assert (forall ((r Array_) (o Array_)) (!
  (iff
    ($Set.in o ($Set.singleton r))
    (= r o))
  :pattern (($Set.in o ($Set.singleton r)))
  )))
(assert (forall ((r Array_)) (!
  (= ($Set.card ($Set.singleton r)) 1)
  :pattern (($Set.card ($Set.singleton r)))
  )))
(assert (forall ((a $Set<Array_>) (x Array_) (o Array_)) (!
  (iff
    ($Set.in o ($Set.unionone a x))
    (or
      (= o x)
      ($Set.in o a)))
  :pattern (($Set.in o ($Set.unionone a x)))
  )))
(assert (forall ((a $Set<Array_>) (x Array_)) (!
  ($Set.in x ($Set.unionone a x))
  :pattern (($Set.unionone a x)) ; Dafny
  )))
(assert (forall ((a $Set<Array_>) (x Array_) (y Array_)) (!
  (=>
    ($Set.in y a)
    ($Set.in y ($Set.unionone a x)))
  :pattern (($Set.in y a) ($Set.unionone a x)) ; Dafny
  )))
(assert (forall ((a $Set<Array_>) (x Array_)) (!
  (=>
    ($Set.in x a)
    (= ($Set.card ($Set.unionone a x)) ($Set.card a)))
  :pattern (($Set.card ($Set.unionone a x)))
  )))
(assert (forall ((a $Set<Array_>) (x Array_)) (!
  (=>
    (not ($Set.in x a))
    (= ($Set.card ($Set.unionone a x)) (+ ($Set.card a) 1)))
  :pattern (($Set.card ($Set.unionone a x)))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>) (o Array_)) (!
  (iff
    ($Set.in o ($Set.union a b))
    (or
      ($Set.in o a)
      ($Set.in o b)))
  :pattern (($Set.in o ($Set.union a b)))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>) (y Array_)) (!
  (=>
    ($Set.in y a)
    ($Set.in y ($Set.union a b)))
  :pattern (($Set.union a b) ($Set.in y a)) ; Dafny
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>) (y Array_)) (!
  (=>
    ($Set.in y b)
    ($Set.in y ($Set.union a b)))
  :pattern (($Set.union a b) ($Set.in y b)) ; Dafny
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>) (o Array_)) (!
  (iff
    ($Set.in o ($Set.intersection a b))
    (and
      ($Set.in o a)
      ($Set.in o b)))
  :pattern (($Set.in o ($Set.intersection a b)))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>)) (!
  (=
    ($Set.union ($Set.union a b) b)
    ($Set.union a b))
  :pattern (($Set.union ($Set.union a b) b))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>)) (!
  (=
    ($Set.union a ($Set.union a b))
    ($Set.union a b))
    :pattern (($Set.union a ($Set.union a b)))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>)) (!
  (=
    ($Set.intersection ($Set.intersection a b) b)
    ($Set.intersection a b))
  :pattern (($Set.intersection ($Set.intersection a b) b))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>)) (!
  (=
    ($Set.intersection a ($Set.intersection a b))
    ($Set.intersection a b))
  :pattern (($Set.intersection a ($Set.intersection a b)))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>)) (!
  (=
    (+
      ($Set.card ($Set.union a b))
      ($Set.card ($Set.intersection a b)))
    (+
      ($Set.card a)
      ($Set.card b)))
  :pattern (($Set.card ($Set.union a b)))
  :pattern (($Set.card ($Set.intersection a b)))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>) (o Array_)) (!
  (iff
    ($Set.in o ($Set.difference a b))
    (and
      ($Set.in o a)
      (not ($Set.in o b))))
  :pattern (($Set.in o ($Set.difference a b)))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>) (y Array_)) (!
  (=>
    ($Set.in y b)
    (not ($Set.in y ($Set.difference a b))))
  :pattern (($Set.difference a b) ($Set.in y b)) ; Dafny
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>)) (!
  (iff
    ($Set.subset a b)
    (forall ((o Array_)) (!
      (=>
        ($Set.in o a)
        ($Set.in o b))
      :pattern (($Set.in o a))
      :pattern (($Set.in o b))
    )))
  :pattern (($Set.subset a b))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>)) (!
  (iff
    ($Set.equal a b)
    (forall ((o Array_)) (!
      (iff
        ($Set.in o a)
        ($Set.in o b))
      :pattern (($Set.in o a))
      :pattern (($Set.in o b))
      :qid |$Set<Array_>.ext-inner|
      )))
  :pattern (($Set.equal a b))
  :qid |$Set<Array_>.ext-outer|
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>)) (!
  (=>
    ($Set.equal a b)
    (= a b))
  :pattern (($Set.equal a b))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>)) (!
  (iff
    ($Set.disjoint a b)
    (forall ((o Array_)) (!
      (or
        (not ($Set.in o a))
        (not ($Set.in o b)))
      :pattern (($Set.in o a))
      :pattern (($Set.in o b))
      )))
  :pattern (($Set.disjoint a b))
  )))
(assert (forall ((a $Set<Array_>) (b $Set<Array_>)) (!
  (and
    (=
      (+
        (+
          ($Set.card ($Set.difference a b))
          ($Set.card ($Set.difference b a)))
        ($Set.card ($Set.intersection a b)))
      ($Set.card ($Set.union a b)))
    (=
      ($Set.card ($Set.difference a b))
      (-
        ($Set.card a)
        ($Set.card ($Set.intersection a b)))))
  :pattern (($Set.card ($Set.difference a b))) ; Dafny
  )))
; /dafny_axioms/sets_axioms_dafny.smt2 [Ref]
(assert (forall ((s $Set<$Ref>)) (!
  (<= 0 ($Set.card s))
  :pattern (($Set.card s))
  )))
(assert (forall ((o $Ref)) (!
  (not ($Set.in o $Set.empty<$Ref>))
  :pattern (($Set.in o $Set.empty<$Ref>))
  )))
(assert (forall ((s $Set<$Ref>)) (!
  (and
    (iff
      (= ($Set.card s) 0)
      (= s $Set.empty<$Ref>))
    (implies
      (not (= ($Set.card s) 0))
      (exists ((x $Ref)) (!
        ($Set.in x s)
        :pattern (($Set.in x s))
      ))))
  :pattern (($Set.card s))
  )))
(assert (forall ((r $Ref)) (!
  ($Set.in r ($Set.singleton r))
  :pattern (($Set.singleton r)) ; Dafny
  )))
(assert (forall ((r $Ref) (o $Ref)) (!
  (iff
    ($Set.in o ($Set.singleton r))
    (= r o))
  :pattern (($Set.in o ($Set.singleton r)))
  )))
(assert (forall ((r $Ref)) (!
  (= ($Set.card ($Set.singleton r)) 1)
  :pattern (($Set.card ($Set.singleton r)))
  )))
(assert (forall ((a $Set<$Ref>) (x $Ref) (o $Ref)) (!
  (iff
    ($Set.in o ($Set.unionone a x))
    (or
      (= o x)
      ($Set.in o a)))
  :pattern (($Set.in o ($Set.unionone a x)))
  )))
(assert (forall ((a $Set<$Ref>) (x $Ref)) (!
  ($Set.in x ($Set.unionone a x))
  :pattern (($Set.unionone a x)) ; Dafny
  )))
(assert (forall ((a $Set<$Ref>) (x $Ref) (y $Ref)) (!
  (=>
    ($Set.in y a)
    ($Set.in y ($Set.unionone a x)))
  :pattern (($Set.in y a) ($Set.unionone a x)) ; Dafny
  )))
(assert (forall ((a $Set<$Ref>) (x $Ref)) (!
  (=>
    ($Set.in x a)
    (= ($Set.card ($Set.unionone a x)) ($Set.card a)))
  :pattern (($Set.card ($Set.unionone a x)))
  )))
(assert (forall ((a $Set<$Ref>) (x $Ref)) (!
  (=>
    (not ($Set.in x a))
    (= ($Set.card ($Set.unionone a x)) (+ ($Set.card a) 1)))
  :pattern (($Set.card ($Set.unionone a x)))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>) (o $Ref)) (!
  (iff
    ($Set.in o ($Set.union a b))
    (or
      ($Set.in o a)
      ($Set.in o b)))
  :pattern (($Set.in o ($Set.union a b)))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>) (y $Ref)) (!
  (=>
    ($Set.in y a)
    ($Set.in y ($Set.union a b)))
  :pattern (($Set.union a b) ($Set.in y a)) ; Dafny
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>) (y $Ref)) (!
  (=>
    ($Set.in y b)
    ($Set.in y ($Set.union a b)))
  :pattern (($Set.union a b) ($Set.in y b)) ; Dafny
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>) (o $Ref)) (!
  (iff
    ($Set.in o ($Set.intersection a b))
    (and
      ($Set.in o a)
      ($Set.in o b)))
  :pattern (($Set.in o ($Set.intersection a b)))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>)) (!
  (=
    ($Set.union ($Set.union a b) b)
    ($Set.union a b))
  :pattern (($Set.union ($Set.union a b) b))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>)) (!
  (=
    ($Set.union a ($Set.union a b))
    ($Set.union a b))
    :pattern (($Set.union a ($Set.union a b)))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>)) (!
  (=
    ($Set.intersection ($Set.intersection a b) b)
    ($Set.intersection a b))
  :pattern (($Set.intersection ($Set.intersection a b) b))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>)) (!
  (=
    ($Set.intersection a ($Set.intersection a b))
    ($Set.intersection a b))
  :pattern (($Set.intersection a ($Set.intersection a b)))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>)) (!
  (=
    (+
      ($Set.card ($Set.union a b))
      ($Set.card ($Set.intersection a b)))
    (+
      ($Set.card a)
      ($Set.card b)))
  :pattern (($Set.card ($Set.union a b)))
  :pattern (($Set.card ($Set.intersection a b)))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>) (o $Ref)) (!
  (iff
    ($Set.in o ($Set.difference a b))
    (and
      ($Set.in o a)
      (not ($Set.in o b))))
  :pattern (($Set.in o ($Set.difference a b)))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>) (y $Ref)) (!
  (=>
    ($Set.in y b)
    (not ($Set.in y ($Set.difference a b))))
  :pattern (($Set.difference a b) ($Set.in y b)) ; Dafny
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>)) (!
  (iff
    ($Set.subset a b)
    (forall ((o $Ref)) (!
      (=>
        ($Set.in o a)
        ($Set.in o b))
      :pattern (($Set.in o a))
      :pattern (($Set.in o b))
    )))
  :pattern (($Set.subset a b))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>)) (!
  (iff
    ($Set.equal a b)
    (forall ((o $Ref)) (!
      (iff
        ($Set.in o a)
        ($Set.in o b))
      :pattern (($Set.in o a))
      :pattern (($Set.in o b))
      :qid |$Set<$Ref>.ext-inner|
      )))
  :pattern (($Set.equal a b))
  :qid |$Set<$Ref>.ext-outer|
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>)) (!
  (=>
    ($Set.equal a b)
    (= a b))
  :pattern (($Set.equal a b))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>)) (!
  (iff
    ($Set.disjoint a b)
    (forall ((o $Ref)) (!
      (or
        (not ($Set.in o a))
        (not ($Set.in o b)))
      :pattern (($Set.in o a))
      :pattern (($Set.in o b))
      )))
  :pattern (($Set.disjoint a b))
  )))
(assert (forall ((a $Set<$Ref>) (b $Set<$Ref>)) (!
  (and
    (=
      (+
        (+
          ($Set.card ($Set.difference a b))
          ($Set.card ($Set.difference b a)))
        ($Set.card ($Set.intersection a b)))
      ($Set.card ($Set.union a b)))
    (=
      ($Set.card ($Set.difference a b))
      (-
        ($Set.card a)
        ($Set.card ($Set.intersection a b)))))
  :pattern (($Set.card ($Set.difference a b))) ; Dafny
  )))
(assert (forall ((a Array_)) (!
  (>= (len<Array~Int> a) 0)
  :pattern ((len<Array~Int> a))
  :qid |prog.length_nonneg|)))
(assert (forall ((a Array_) (i Int)) (!
  (implies
    (and (<= 0 i) (< i (len<Array~Int> a)))
    (and
      (=
        (first<Pair<Array~_Int>~Array> (inv_loc<Ref~Pair<Array~_Int>> (loc<Array~Int~Ref> a i)))
        a)
      (=
        (second<Pair<Array~_Int>~Int> (inv_loc<Ref~Pair<Array~_Int>> (loc<Array~Int~Ref> a i)))
        i)))
  :pattern ((loc<Array~Int~Ref> a i))
  :qid |prog.loc_injective|)))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.$PermTo$Snap ($Perm) $Snap)
(declare-fun $SortWrappers.$SnapTo$Perm ($Snap) $Perm)
(assert (forall ((x $Perm)) (!
    (= x ($SortWrappers.$SnapTo$Perm($SortWrappers.$PermTo$Snap x)))
    :pattern (($SortWrappers.$PermTo$Snap x))
    :qid |$Snap.$Perm|
    )))
(declare-fun $SortWrappers.$RefTo$Snap ($Ref) $Snap)
(declare-fun $SortWrappers.$SnapTo$Ref ($Snap) $Ref)
(assert (forall ((x $Ref)) (!
    (= x ($SortWrappers.$SnapTo$Ref($SortWrappers.$RefTo$Snap x)))
    :pattern (($SortWrappers.$RefTo$Snap x))
    :qid |$Snap.$Ref|
    )))
(declare-fun $SortWrappers.BoolTo$Snap (Bool) $Snap)
(declare-fun $SortWrappers.$SnapToBool ($Snap) Bool)
(assert (forall ((x Bool)) (!
    (= x ($SortWrappers.$SnapToBool($SortWrappers.BoolTo$Snap x)))
    :pattern (($SortWrappers.BoolTo$Snap x))
    :qid |$Snap.Bool|
    )))
(declare-fun $SortWrappers.IntTo$Snap (Int) $Snap)
(declare-fun $SortWrappers.$SnapToInt ($Snap) Int)
(assert (forall ((x Int)) (!
    (= x ($SortWrappers.$SnapToInt($SortWrappers.IntTo$Snap x)))
    :pattern (($SortWrappers.IntTo$Snap x))
    :qid |$Snap.Int|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.$Seq<Int>To$Snap ($Seq<Int>) $Snap)
(declare-fun $SortWrappers.$SnapTo$Seq<Int> ($Snap) $Seq<Int>)
(assert (forall ((x $Seq<Int>)) (!
    (= x ($SortWrappers.$SnapTo$Seq<Int>($SortWrappers.$Seq<Int>To$Snap x)))
    :pattern (($SortWrappers.$Seq<Int>To$Snap x))
    :qid |$Snap.$Seq<Int>|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.$Set<$Ref>To$Snap ($Set<$Ref>) $Snap)
(declare-fun $SortWrappers.$SnapTo$Set<$Ref> ($Snap) $Set<$Ref>)
(assert (forall ((x $Set<$Ref>)) (!
    (= x ($SortWrappers.$SnapTo$Set<$Ref>($SortWrappers.$Set<$Ref>To$Snap x)))
    :pattern (($SortWrappers.$Set<$Ref>To$Snap x))
    :qid |$Snap.$Set<$Ref>|
    )))
(declare-fun $SortWrappers.$Set<Array_>To$Snap ($Set<Array_>) $Snap)
(declare-fun $SortWrappers.$SnapTo$Set<Array_> ($Snap) $Set<Array_>)
(assert (forall ((x $Set<Array_>)) (!
    (= x ($SortWrappers.$SnapTo$Set<Array_>($SortWrappers.$Set<Array_>To$Snap x)))
    :pattern (($SortWrappers.$Set<Array_>To$Snap x))
    :qid |$Snap.$Set<Array_>|
    )))
(declare-fun $SortWrappers.$Set<Int>To$Snap ($Set<Int>) $Snap)
(declare-fun $SortWrappers.$SnapTo$Set<Int> ($Snap) $Set<Int>)
(assert (forall ((x $Set<Int>)) (!
    (= x ($SortWrappers.$SnapTo$Set<Int>($SortWrappers.$Set<Int>To$Snap x)))
    :pattern (($SortWrappers.$Set<Int>To$Snap x))
    :qid |$Snap.$Set<Int>|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.Array_To$Snap (Array_) $Snap)
(declare-fun $SortWrappers.$SnapToArray_ ($Snap) Array_)
(assert (forall ((x Array_)) (!
    (= x ($SortWrappers.$SnapToArray_($SortWrappers.Array_To$Snap x)))
    :pattern (($SortWrappers.Array_To$Snap x))
    :qid |$Snap.Array_|
    )))
(declare-fun $SortWrappers.Pair<Array~_Int>To$Snap (Pair<Array~_Int>) $Snap)
(declare-fun $SortWrappers.$SnapToPair<Array~_Int> ($Snap) Pair<Array~_Int>)
(assert (forall ((x Pair<Array~_Int>)) (!
    (= x ($SortWrappers.$SnapToPair<Array~_Int>($SortWrappers.Pair<Array~_Int>To$Snap x)))
    :pattern (($SortWrappers.Pair<Array~_Int>To$Snap x))
    :qid |$Snap.Pair<Array~_Int>|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.$FVF<Int>To$Snap ($FVF<Int>) $Snap)
(declare-fun $SortWrappers.$SnapTo$FVF<Int> ($Snap) $FVF<Int>)
(assert (forall ((x $FVF<Int>)) (!
    (= x ($SortWrappers.$SnapTo$FVF<Int>($SortWrappers.$FVF<Int>To$Snap x)))
    :pattern (($SortWrappers.$FVF<Int>To$Snap x))
    :qid |$Snap.$FVF<Int>|
    )))
(declare-fun $SortWrappers.$FVF<$Ref>To$Snap ($FVF<$Ref>) $Snap)
(declare-fun $SortWrappers.$SnapTo$FVF<$Ref> ($Snap) $FVF<$Ref>)
(assert (forall ((x $FVF<$Ref>)) (!
    (= x ($SortWrappers.$SnapTo$FVF<$Ref>($SortWrappers.$FVF<$Ref>To$Snap x)))
    :pattern (($SortWrappers.$FVF<$Ref>To$Snap x))
    :qid |$Snap.$FVF<$Ref>|
    )))
; /field_value_functions_axioms.smt2 [val: Int]
(assert (forall ((vs $FVF<Int>) (ws $FVF<Int>)) (!
    (implies
      (and
        ($Set.equal ($FVF.domain_val vs) ($FVF.domain_val ws))
        (forall ((x $Ref)) (!
          (implies
            ($Set.in x ($FVF.domain_val vs))
            (= ($FVF.lookup_val vs x) ($FVF.lookup_val ws x)))
          :pattern (($FVF.lookup_val vs x) ($FVF.lookup_val ws x))
          :qid |qp.$FVF<Int>-eq-inner|
          )))
      (= vs ws))
    :pattern (($SortWrappers.$FVF<Int>To$Snap vs)
              ($SortWrappers.$FVF<Int>To$Snap ws)
              )
    :qid |qp.$FVF<Int>-eq-outer|
    )))
; Preamble end
; ------------------------------------------------------------
; ---------- FUNCTION length----------
(declare-fun this@0 () $Ref)
(declare-fun result@1 () Int)
; ----- Well-definedness of specifications -----
(assert (forall ((s@$ $Snap) (this@0 $Ref)) (!
  (= (length%limited s@$ this@0) (length s@$ this@0))
  :pattern ((length s@$ this@0))
  )))
(assert (forall ((s@$ $Snap) (this@0 $Ref)) (!
  (length%stateless this@0)
  :pattern ((length%limited s@$ this@0))
  )))
(assert (forall ((s@$ $Snap) (this@0 $Ref)) (!
  (let ((result@1 (length%limited s@$ this@0))) (>= result@1 0))
  :pattern ((length%limited s@$ this@0))
  )))
; ---------- FUNCTION length (verify) ----------
(declare-const i@7 Int)
(declare-fun inv@8 ($Snap $Ref $Ref) Int)
(assert (forall ((s@$ $Snap) (this@0 $Ref)) (!
  (let ((result@1 (length%limited s@$ this@0))) (and
    (=
      (length s@$ this@0)
      ($SortWrappers.$SnapToInt ($Snap.first ($Snap.second s@$))))
    (and
      (forall ((i@7 Int)) (!
        (implies
          (and
            (<= 0 i@7)
            (implies
              (<= 0 i@7)
              (<
                i@7
                (len<Array~Int> ($SortWrappers.$SnapToArray_ ($Snap.first s@$))))))
          (=
            (inv@8 s@$ this@0 (loc<Array~Int~Ref> ($SortWrappers.$SnapToArray_ ($Snap.first s@$)) i@7))
            i@7))
        :pattern ((loc<Array~Int~Ref> ($SortWrappers.$SnapToArray_ ($Snap.first s@$)) i@7))
        :qid |qp.inv@8-exp|))
      (forall ((r $Ref)) (!
        (implies
          (and
            (<= 0 (inv@8 s@$ this@0 r))
            (implies
              (<= 0 (inv@8 s@$ this@0 r))
              (<
                (inv@8 s@$ this@0 r)
                (len<Array~Int> ($SortWrappers.$SnapToArray_ ($Snap.first s@$))))))
          (=
            (loc<Array~Int~Ref> ($SortWrappers.$SnapToArray_ ($Snap.first s@$)) (inv@8 s@$ this@0 r))
            r))
        :pattern ((inv@8 s@$ this@0 r))
        :qid |qp.inv@8-imp|)))))
  :pattern ((length s@$ this@0))
  )))
; ---------- FUNCTION itemAt----------
(declare-fun this@2 () $Ref)
(declare-fun index@3 () Int)
(declare-fun result@4 () Int)
; ----- Well-definedness of specifications -----
(assert (forall ((s@$ $Snap) (this@2 $Ref) (index@3 Int)) (!
  (= (itemAt%limited s@$ this@2 index@3) (itemAt s@$ this@2 index@3))
  :pattern ((itemAt s@$ this@2 index@3))
  )))
(assert (forall ((s@$ $Snap) (this@2 $Ref) (index@3 Int)) (!
  (itemAt%stateless this@2 index@3)
  :pattern ((itemAt%limited s@$ this@2 index@3))
  )))
; ---------- FUNCTION itemAt (verify) ----------
(declare-const i@9 Int)
(declare-fun inv@10 ($Snap $Ref Int $Ref) Int)
(declare-const fvf%tot@11 $FVF<Int>)
(assert (forall ((s@$ $Snap) (this@2 $Ref) (index@3 Int)) (!
  (let ((result@4 (itemAt%limited s@$ this@2 index@3)) (fvf%tot@11 (itemAt_fvfgen_val s@$ this@2 index@3))) (and
    (implies
      (and (<= 0 index@3) (< index@3 (length ($Snap.first s@$) this@2)))
      (=
        (itemAt s@$ this@2 index@3)
        ($FVF.lookup_val fvf%tot@11 (loc<Array~Int~Ref> ($SortWrappers.$SnapToArray_ ($Snap.first ($Snap.first s@$))) index@3))))
    (and
      (forall ((i@9 Int)) (!
        (implies
          (and
            (<= 0 i@9)
            (implies
              (<= 0 i@9)
              (<
                i@9
                (len<Array~Int> ($SortWrappers.$SnapToArray_ ($Snap.first ($Snap.first s@$)))))))
          (=
            (inv@10 s@$ this@2 index@3 (loc<Array~Int~Ref> ($SortWrappers.$SnapToArray_ ($Snap.first ($Snap.first s@$))) i@9))
            i@9))
        :pattern ((loc<Array~Int~Ref> ($SortWrappers.$SnapToArray_ ($Snap.first ($Snap.first s@$))) i@9))
        :qid |qp.inv@10-exp|))
      (forall ((r $Ref)) (!
        (implies
          (and
            (<= 0 (inv@10 s@$ this@2 index@3 r))
            (implies
              (<= 0 (inv@10 s@$ this@2 index@3 r))
              (<
                (inv@10 s@$ this@2 index@3 r)
                (len<Array~Int> ($SortWrappers.$SnapToArray_ ($Snap.first ($Snap.first s@$)))))))
          (=
            (loc<Array~Int~Ref> ($SortWrappers.$SnapToArray_ ($Snap.first ($Snap.first s@$))) (inv@10 s@$ this@2 index@3 r))
            r))
        :pattern ((inv@10 s@$ this@2 index@3 r))
        :qid |qp.inv@10-imp|)))
    (and
      (forall ((r $Ref)) (!
        (implies
          (and
            (<= 0 (inv@10 s@$ this@2 index@3 r))
            (implies
              (<= 0 (inv@10 s@$ this@2 index@3 r))
              (<
                (inv@10 s@$ this@2 index@3 r)
                (len<Array~Int> ($SortWrappers.$SnapToArray_ ($Snap.first ($Snap.first s@$)))))))
          (=
            ($FVF.lookup_val fvf%tot@11 r)
            ($FVF.lookup_val ($SortWrappers.$SnapTo$FVF<Int> ($Snap.second ($Snap.second ($Snap.second ($Snap.second ($Snap.second ($Snap.first s@$))))))) r)))
        :pattern (($FVF.lookup_val fvf%tot@11 r))
        ))
      (forall ((r $Ref)) (!
        (implies
          (and
            (<= 0 (inv@10 s@$ this@2 index@3 r))
            (implies
              (<= 0 (inv@10 s@$ this@2 index@3 r))
              (<
                (inv@10 s@$ this@2 index@3 r)
                (len<Array~Int> ($SortWrappers.$SnapToArray_ ($Snap.first ($Snap.first s@$)))))))
          (=
            ($FVF.lookup_val fvf%tot@11 r)
            ($FVF.lookup_val ($SortWrappers.$SnapTo$FVF<Int> ($Snap.second ($Snap.second ($Snap.second ($Snap.second ($Snap.second ($Snap.first s@$))))))) r)))
        :pattern (($FVF.lookup_val ($SortWrappers.$SnapTo$FVF<Int> ($Snap.second ($Snap.second ($Snap.second ($Snap.second ($Snap.second ($Snap.first s@$))))))) r))
        )))))
  :pattern ((itemAt s@$ this@2 index@3))
  )))
; ---------- FUNCTION content----------
(declare-fun this@5 () $Ref)
(declare-fun result@6 () $Seq<Int>)
; ----- Well-definedness of specifications -----
(declare-const i@12 Int)
(declare-const s@13 $Snap)
(assert (forall ((s@$ $Snap) (this@5 $Ref)) (!
  ($Seq.equal (content%limited s@$ this@5) (content s@$ this@5))
  :pattern ((content s@$ this@5))
  )))
(assert (forall ((s@$ $Snap) (this@5 $Ref)) (!
  (content%stateless this@5)
  :pattern ((content%limited s@$ this@5))
  )))
(assert (forall ((s@$ $Snap) (this@5 $Ref)) (!
  (let ((result@6 (content%limited s@$ this@5))) (and
    (= ($Seq.length result@6) (length s@$ this@5))
    (and
      (forall ((i Int)) (!
        (implies
          (and (<= 0 i) (< i (length s@$ this@5)))
          (=
            ($Seq.index result@6 i)
            (itemAt ($Snap.combine s@$ $Snap.unit) this@5 i)))
        :pattern (($Seq.index result@6 i))
        ))
      (forall ((i Int)) (!
        (implies
          (and (<= 0 i) (< i (length s@$ this@5)))
          (=
            ($Seq.index result@6 i)
            (itemAt ($Snap.combine s@$ $Snap.unit) this@5 i)))
        :pattern ((itemAt%limited ($Snap.combine s@$ $Snap.unit) this@5 i))
        )))))
  :pattern ((content%limited s@$ this@5))
  )))
; ---------- AList ----------
(declare-const this@14 $Ref)
(declare-const $t@15 $Snap)
(declare-const $t@16 Array_)
(declare-const $t@17 $Snap)
(declare-const $t@18 Int)
(declare-const $t@19 $Snap)
(declare-const $t@20 $Snap)
(declare-const $t@21 $Snap)
(declare-const $t@22 $FVF<Int>)
(declare-const i@23 Int)
(declare-fun inv@24 ($Ref) Int)
; ---------- create ----------
(declare-const this@25 $Ref)
(declare-const a@26 Array_)
(declare-const $t@27 $Snap)
(declare-const $t@28 $Snap)
(declare-const this@29 $Ref)
(declare-const elems@30 Array_)
(declare-const size@31 Int)
(declare-const $t@32 $Snap)
(declare-const i@33 Int)
(declare-const $t@34 $FVF<Int>)
(declare-fun inv@35 ($Ref) Int)
(declare-const i@36 Int)
(declare-fun inv@37 ($Ref) Int)
(declare-const fvf%part@38 $FVF<Int>)
; ---------- addAtEnd ----------
(declare-const this@39 $Ref)
(declare-const elem@40 Int)
(declare-const a@41 Array_)
(declare-const $t@42 $Snap)
(declare-const $t@43 $Snap)
(declare-const $t@44 $Snap)
(declare-const $t@45 $Snap)
(declare-const $t@46 Array_)
(declare-const $t@47 $Snap)
(declare-const $t@48 Int)
(declare-const $t@49 $Snap)
(declare-const $t@50 $Snap)
(declare-const $t@51 $Snap)
(declare-const $t@52 $FVF<Int>)
(declare-const i@53 Int)
(declare-fun inv@54 ($Ref) Int)
(declare-const $t@55 $Snap)
(declare-const $t@56 $FVF<Int>)
(declare-const i@57 Int)
(declare-fun inv@58 ($Ref) Int)
(declare-const $t@59 $Snap)
(declare-const i@60 Int)
(declare-const fvf%tot@61 $FVF<Int>)
(declare-const fvf%part@62 $FVF<Int>)
(declare-const fvf%part@63 $FVF<Int>)
(declare-const size@64 Int)
(declare-const i@65 Int)
(declare-fun inv@66 ($Ref) Int)
(declare-const fvf%part@67 $FVF<Int>)
(declare-const fvf%part@68 $FVF<Int>)
(declare-const fvf%part@69 $FVF<Int>)
(declare-const size@70 Int)
(declare-const i@71 Int)
(declare-fun inv@72 ($Ref) Int)
(declare-const fvf%part@73 $FVF<Int>)
; ---------- insert ----------
(declare-const this@74 $Ref)
(declare-const elem@75 Int)
(declare-const j@76 Int)
(declare-const a@77 Array_)
(declare-const t@78 Int)
(declare-const $t@79 $Snap)
(declare-const $t@80 $Snap)
(declare-const $t@81 $Snap)
; [exec]
; j := 0
; loop at arraylist-quantified-permissions_LOOP.sil@104.3
(declare-const j@82 Int)
(declare-const $t@83 $Snap)
(declare-const $t@84 $Snap)
(declare-const k@85 Int)
(declare-const s@86 $Snap)
(declare-const $t@87 $Snap)
(declare-const k@88 Int)
(declare-const s@89 $Snap)
; Loop: Verify loop body
(declare-const $t@90 Array_)
(declare-const $t@91 $Snap)
(declare-const $t@92 Int)
(declare-const $t@93 $Snap)
(declare-const $t@94 $Snap)
(declare-const $t@95 $Snap)
(declare-const $t@96 $FVF<Int>)
(declare-const i@97 Int)
(declare-fun inv@98 ($Ref) Int)
(declare-const j@99 Int)
(declare-const i@100 Int)
(declare-fun inv@101 ($Ref) Int)
(declare-const fvf%part@102 $FVF<Int>)
(declare-const k@103 Int)
(declare-const s@104 $Snap)
; Loop: Continue after loop
(assert (<= 0 (length $t@79 this@74)))
(declare-const $t@105 $Snap)
(declare-const $t@106 $Snap)
(assert (= $t@105 ($Snap.combine $t@106 $Snap.unit)))
; [eval] (0 <= j) && (j <= length(this))
; [eval] 0 <= j
; [eval] (0 <= j) ==> (j <= length(this))
; [eval] 0 <= j
; Joined path conditions
; Joined path conditions
(assert (and (<= 0 j@82) (implies (<= 0 j@82) (<= j@82 (length $t@106 this@74)))))
; [eval] (j > 0) ==> (itemAt(this, j - 1) <= elem)
; [eval] j > 0
; Joined path conditions
(assert (implies
  (> j@82 0)
  (and
    (and
      (<= 0 (- j@82 1))
      (implies (<= 0 (- j@82 1)) (< (- j@82 1) (length $t@106 this@74))))
    (> j@82 0))))
; Joined path conditions
(assert (implies
  (> j@82 0)
  (<= (itemAt ($Snap.combine $t@106 $Snap.unit) this@74 (- j@82 1)) elem@75)))
; [eval] length(this) == old(length(this))
; [eval] length(this)
; Joined path conditions
; [eval] old(length(this))
; [eval] length(this)
; Joined path conditions
(assert (= (length $t@106 this@74) (length $t@79 this@74)))
; [eval] (forall k: Int :: { itemAt(this, k) } (0 <= k) && (k < length(this)) ==> (itemAt(this, k) == old(itemAt(this, k))))
(declare-const k@107 Int)
(declare-const s@108 $Snap)
; Nested auxiliary terms
(assert (forall ((k@107 Int) (s@108 $Snap)) (!
  (implies
    (and (<= 0 k@107) (implies (<= 0 k@107) (< k@107 (length $t@106 this@74))))
    (and
      (and (<= 0 k@107) (implies (<= 0 k@107) (< k@107 (length $t@79 this@74))))
      (and (<= 0 k@107) (implies (<= 0 k@107) (< k@107 (length $t@106 this@74))))))
  :pattern ((itemAt%limited s@108 this@74 k@107))
  :qid |prog.l109-aux|)))
(assert (forall ((k@107 Int)) (!
  (implies
    (and (<= 0 k@107) (implies (<= 0 k@107) (< k@107 (length $t@106 this@74))))
    (=
      (itemAt ($Snap.combine $t@106 $Snap.unit) this@74 k@107)
      (itemAt ($Snap.combine $t@79 $Snap.unit) this@74 k@107)))
  :pattern ((itemAt%limited ($Snap.combine $t@79 $Snap.unit) this@74 k@107))
  :qid |prog.l109|)))
; [eval] !((j < length(this)) && (itemAt(this, j) < elem))
; [eval] (j < length(this)) && (itemAt(this, j) < elem)
; [eval] j < length(this)
; [eval] length(this)
; Joined path conditions
; [eval] (j < length(this)) ==> (itemAt(this, j) < elem)
; [eval] j < length(this)
; [eval] length(this)
; Joined path conditions
; Joined path conditions
(assert (implies
  (< j@82 (length $t@106 this@74))
  (and
    (and (<= 0 j@82) (implies (<= 0 j@82) (< j@82 (length $t@106 this@74))))
    (< j@82 (length $t@106 this@74)))))
; Joined path conditions
(assert (not
  (and
    (< j@82 (length $t@106 this@74))
    (implies
      (< j@82 (length $t@106 this@74))
      (< (itemAt ($Snap.combine $t@106 $Snap.unit) this@74 j@82) elem@75)))))
(set-option :timeout 250)
; (check-sat)
; unknown
; [exec]
; unfold acc(AList(this), write)
(declare-const $t@109 Array_)
(declare-const $t@110 $Snap)
(assert (= $t@106 ($Snap.combine ($SortWrappers.Array_To$Snap $t@109) $t@110)))
(assert (not (= this@74 $Ref.null)))
(declare-const $t@111 Int)
(declare-const $t@112 $Snap)
(assert (= $t@110 ($Snap.combine ($SortWrappers.IntTo$Snap $t@111) $t@112)))
(declare-const $t@113 $Snap)
(assert (= $t@112 ($Snap.combine $Snap.unit $t@113)))
; [eval] 0 <= this.size
(assert (<= 0 $t@111))
(declare-const $t@114 $Snap)
(assert (= $t@113 ($Snap.combine $Snap.unit $t@114)))
; [eval] this.size <= len(this.elems)
; [eval] len(this.elems)
(assert (<= $t@111 (len<Array~Int> $t@109)))
(declare-const $t@115 $FVF<Int>)
(assert (= $t@114 ($Snap.combine $Snap.unit ($SortWrappers.$FVF<Int>To$Snap $t@115))))
; [eval] 0 < len(this.elems)
; [eval] len(this.elems)
(assert (< 0 (len<Array~Int> $t@109)))
(declare-const i@116 Int)
(declare-fun inv@117 ($Ref) Int)
; Nested auxiliary terms
; Definitional axioms for inverse functions
(assert (forall ((r $Ref)) (!
  (implies
    (and
      (<= 0 (inv@117 r))
      (implies (<= 0 (inv@117 r)) (< (inv@117 r) (len<Array~Int> $t@109))))
    (= (loc<Array~Int~Ref> $t@109 (inv@117 r)) r))
  :pattern ((inv@117 r))
  :qid |qp.inv@117-imp|)))
(assert (forall ((i@116 Int)) (!
  (implies
    (and (<= 0 i@116) (implies (<= 0 i@116) (< i@116 (len<Array~Int> $t@109))))
    (= (inv@117 (loc<Array~Int~Ref> $t@109 i@116)) i@116))
  :pattern ((loc<Array~Int~Ref> $t@109 i@116))
  :qid |qp.inv@117-exp|)))
; Receivers are non-null
(assert (forall ((i@116 Int)) (!
  (implies
    (and (<= 0 i@116) (implies (<= 0 i@116) (< i@116 (len<Array~Int> $t@109))))
    (not (= (loc<Array~Int~Ref> $t@109 i@116) $Ref.null)))
  :pattern ((loc<Array~Int~Ref> $t@109 i@116))
  :qid |qp.null11|)))
(assert (AList%trigger $t@106 this@74))
; [eval] this.size == len(this.elems)
; [eval] len(this.elems)
; 0.00s
; (get-info :all-statistics)
; 0.00s
; (get-info :all-statistics)
(declare-const $t@118 $Snap)
(declare-const $t@119 $FVF<Int>)
(declare-const i@120 Int)
(declare-fun inv@121 ($Ref) Int)
(declare-const $t@122 $Snap)
(declare-const i@123 Int)
(declare-const fvf%tot@124 $FVF<Int>)
(declare-const fvf@125 $FVF<Int>)
(declare-const t@126 Int)
(declare-const $t@127 $Snap)
(declare-const $t@128 $Snap)
(declare-const $t@129 $Snap)
(declare-const $t@130 Array_)
(declare-const $t@131 $Snap)
(declare-const $t@132 Int)
(declare-const $t@133 Int)
(declare-const fvf%part@134 $FVF<Int>)
(declare-const $t@135 $FVF<Int>)
(declare-const i@136 Int)
(declare-fun inv@137 ($Ref) Int)
(declare-const i@138 Int)
(declare-const fvf%tot@139 $FVF<Int>)
(declare-const i@140 Int)
(declare-const $t@141 $Snap)
(declare-const fvf%part@142 $FVF<Int>)
(declare-const i@143 Int)
(declare-fun inv@144 ($Ref) Int)
(declare-const fvf%part@145 $FVF<Int>)
(declare-const i@146 Int)
(declare-const i@147 Int)
(declare-const fvf%part@148 $FVF<Int>)
(declare-const fvf%part@149 $FVF<Int>)
(declare-const t@150 Int)
(declare-const fvf%part@151 $FVF<Int>)
(declare-const i@152 Int)
(declare-fun inv@153 ($Ref) Int)
(declare-const fvf%part@154 $FVF<Int>)
(declare-const i@155 Int)
(declare-const fvf%tot@156 $FVF<Int>)
(declare-const i@157 Int)
(declare-const $t@158 $Snap)
(declare-const $t@159 $Snap)
(declare-const $t@160 $Snap)
(declare-const $t@161 Array_)
(declare-const $t@162 $Snap)
(declare-const $t@163 Int)
(declare-const $t@164 Int)
(declare-const fvf%part@165 $FVF<Int>)
(declare-const $t@166 $FVF<Int>)
(declare-const i@167 Int)
(declare-fun inv@168 ($Ref) Int)
(declare-const i@169 Int)
(declare-const fvf%tot@170 $FVF<Int>)
(declare-const i@171 Int)
(declare-const fvf%part@172 $FVF<Int>)
(declare-const fvf%part@173 $FVF<Int>)
(declare-const size@174 Int)
(declare-const i@175 Int)
(declare-fun inv@176 ($Ref) Int)
(declare-const fvf%part@177 $FVF<Int>)
; [eval] !(this.size == len(this.elems))
; [eval] this.size == len(this.elems)
; [eval] len(this.elems)
(set-option :timeout 250)
; 0.00s
; (get-info :all-statistics)
; 0.00s
; (get-info :all-statistics)
; [then-branch 102] $t@111 != len[Array,Int]($t@109)
(assert (not (= $t@111 (len<Array~Int> $t@109))))
; [exec]
; t := this.size
; loop at arraylist-quantified-permissions_LOOP.sil@128.3
(declare-const t@178 Int)
(declare-const $t@179 $Snap)
(declare-const $t@180 $Snap)
(declare-const $t@181 $Snap)
(declare-const $t@182 Array_)
(declare-const $t@183 $Snap)
(declare-const $t@184 Int)
(declare-const $t@185 Int)
(declare-const fvf%part@186 $FVF<Int>)
(declare-const $t@187 $FVF<Int>)
(declare-const i@188 Int)
(declare-fun inv@189 ($Ref) Int)
(declare-const i@190 Int)
(declare-const fvf%tot@191 $FVF<Int>)
(declare-const i@192 Int)
(declare-const $t@193 $Snap)
(declare-const fvf%part@194 $FVF<Int>)
(define-fun pTaken30 ((r $Ref)) $Perm
  (ite
    (= r (loc<Array~Int~Ref> $t@109 j@82))
    ($Perm.min
      (ite
        (and
          (<= 0 (inv@117 r))
          (implies (<= 0 (inv@117 r)) (< (inv@117 r) (len<Array~Int> $t@109))))
        $Perm.Write
        $Perm.No)
      (/ (to_real 1) (to_real 2)))
    $Perm.No))
(declare-const i@195 Int)
(declare-fun inv@196 ($Ref) Int)
(declare-const fvf%part@197 $FVF<Int>)
(define-fun pTaken31 ((r $Ref)) $Perm
  (ite
    (and
      (< j@82 (inv@196 r))
      (implies (< j@82 (inv@196 r)) (<= (inv@196 r) $t@111)))
    ($Perm.min
      (-
        (ite
          (and
            (<= 0 (inv@117 r))
            (implies (<= 0 (inv@117 r)) (< (inv@117 r) (len<Array~Int> $t@109))))
          $Perm.Write
          $Perm.No)
        (pTaken30 r))
      $Perm.Write)
    $Perm.No))
(declare-const i@198 Int)
(declare-const fvf%tot@199 $FVF<Int>)
(declare-const i@200 Int)
; Loop: Verify loop body
(declare-const fvf%part@201 $FVF<Int>)
(declare-const fvf%part@202 $FVF<Int>)
(declare-const t@203 Int)
(declare-const fvf%part@204 $FVF<Int>)
(declare-const i@205 Int)
(declare-fun inv@206 ($Ref) Int)
(declare-const fvf%part@207 $FVF<Int>)
(declare-const i@208 Int)
(declare-const fvf%tot@209 $FVF<Int>)
(declare-const i@210 Int)
; Loop: Continue after loop
(assert (forall ((i@198 Int)) (!
  (implies
    (and
      (and (<= j@82 i@198) (implies (<= j@82 i@198) (<= i@198 $t@111)))
      (< i@198 $t@111))
    (=
      ($FVF.lookup_val fvf%tot@199 (loc<Array~Int~Ref> $t@109 i@198))
      (itemAt ($Snap.combine $t@79 $Snap.unit) this@74 i@198)))
  :pattern ((loc<Array~Int~Ref> $t@109 i@198))
  :qid |prog.l133|)))
(assert (forall ((i@198 Int)) (!
  (implies
    (and (<= j@82 i@198) (implies (<= j@82 i@198) (<= i@198 $t@111)))
    (and
      (implies
        (< i@198 $t@111)
        (and
          (and
            (<= 0 i@198)
            (implies (<= 0 i@198) (< i@198 (length $t@79 this@74))))
          (and
            (forall ((r $Ref)) (!
              (implies
                (and
                  (<= 0 (inv@117 r))
                  (implies
                    (<= 0 (inv@117 r))
                    (< (inv@117 r) (len<Array~Int> $t@109))))
                (= ($FVF.lookup_val fvf%tot@199 r) ($FVF.lookup_val $t@115 r)))
              :pattern (($FVF.lookup_val fvf%tot@199 r))
              ))
            (forall ((r $Ref)) (!
              (implies
                (and
                  (<= 0 (inv@117 r))
                  (implies
                    (<= 0 (inv@117 r))
                    (< (inv@117 r) (len<Array~Int> $t@109))))
                (= ($FVF.lookup_val fvf%tot@199 r) ($FVF.lookup_val $t@115 r)))
              :pattern (($FVF.lookup_val $t@115 r))
              )))
          (< i@198 $t@111)))
      (and (<= j@82 i@198) (implies (<= j@82 i@198) (<= i@198 $t@111)))))
  :pattern ((loc<Array~Int~Ref> $t@109 i@198))
  :qid |prog.l133-aux|)))
(assert (= $t@111 (length $t@79 this@74)))
(assert (<= j@82 $t@111))
(assert (and
  (forall ((r $Ref)) (!
    (implies
      (and
        (<
          $Perm.No
          (-
            (ite
              (and
                (<= 0 (inv@117 r))
                (implies
                  (<= 0 (inv@117 r))
                  (< (inv@117 r) (len<Array~Int> $t@109))))
              $Perm.Write
              $Perm.No)
            (pTaken30 r)))
        ($Set.in r ($FVF.domain_val fvf%part@197)))
      (= ($FVF.lookup_val fvf%part@197 r) ($FVF.lookup_val $t@115 r)))
    :pattern (($FVF.lookup_val fvf%part@197 r) (inv@117 r))
    :qid |qp.fvf#part@197-lookup-0|))
  (forall ((r $Ref)) (!
    (implies
      (and
        (<
          $Perm.No
          (-
            (ite
              (and
                (<= 0 (inv@117 r))
                (implies
                  (<= 0 (inv@117 r))
                  (< (inv@117 r) (len<Array~Int> $t@109))))
              $Perm.Write
              $Perm.No)
            (pTaken30 r)))
        ($Set.in r ($FVF.domain_val fvf%part@197)))
      (= ($FVF.lookup_val fvf%part@197 r) ($FVF.lookup_val $t@115 r)))
    :pattern (($FVF.lookup_val $t@115 r) (inv@117 r))
    :qid |qp.fvf#part@197-lookup-0|))))
(assert (forall ((i@195 Int)) (!
  (implies
    (and (< j@82 i@195) (implies (< j@82 i@195) (<= i@195 $t@111)))
    (= (inv@196 (loc<Array~Int~Ref> $t@109 i@195)) i@195))
  :pattern ((loc<Array~Int~Ref> $t@109 i@195))
  :qid |qp.inv@196-exp|)))
(assert (forall ((r $Ref)) (!
  (implies
    (and
      (< j@82 (inv@196 r))
      (implies (< j@82 (inv@196 r)) (<= (inv@196 r) $t@111)))
    (= (loc<Array~Int~Ref> $t@109 (inv@196 r)) r))
  :pattern ((inv@196 r))
  :qid |qp.inv@196-imp|)))
(assert (implies
  (and
    (<= 0 (inv@117 (loc<Array~Int~Ref> $t@109 j@82)))
    (implies
      (<= 0 (inv@117 (loc<Array~Int~Ref> $t@109 j@82)))
      (< (inv@117 (loc<Array~Int~Ref> $t@109 j@82)) (len<Array~Int> $t@109))))
  (=
    ($FVF.lookup_val fvf%part@194 (loc<Array~Int~Ref> $t@109 j@82))
    ($FVF.lookup_val $t@115 (loc<Array~Int~Ref> $t@109 j@82)))))
(assert (<= (/ (to_real 1) (to_real 2)) $Perm.Write))
(declare-const $t@211 $Snap)
(declare-const $t@212 $Snap)
(declare-const $t@213 $Snap)
(assert (= $t@211 ($Snap.combine $t@212 $t@213)))
(declare-const $t@214 Array_)
(declare-const $t@215 $Snap)
(assert (= $t@212 ($Snap.combine ($SortWrappers.Array_To$Snap $t@214) $t@215)))
; 0.00s
; (get-info :all-statistics)
(assert (implies (< $Perm.No (/ (to_real 1) (to_real 2))) (not (= this@74 $Ref.null))))
(assert (implies
  (< $Perm.No (- $Perm.Write (/ (to_real 1) (to_real 2))))
  (= $t@214 $t@109)))
(declare-const $t@216 Int)
(declare-const $t@217 Int)
(assert (=
  $t@215
  ($Snap.combine
    ($SortWrappers.IntTo$Snap $t@216)
    ($SortWrappers.IntTo$Snap $t@217))))
; 0.00s
; (get-info :all-statistics)
(assert (implies
  (< $Perm.No (- $Perm.Write (/ (to_real 1) (to_real 2))))
  (= $t@216 $t@111)))
; [eval] loc(this.elems, j)
; 0.00s
; (get-info :all-statistics)
(assert (implies
  (< $Perm.No (/ (to_real 1) (to_real 2)))
  (not (= (loc<Array~Int~Ref> $t@214 j@82) $Ref.null))))
(declare-const fvf%part@218 $FVF<Int>)
(assert (= ($FVF.lookup_val fvf%part@218 (loc<Array~Int~Ref> $t@214 j@82)) $t@217))
(declare-const $t@219 $FVF<Int>)
(assert (= $t@213 ($Snap.combine ($SortWrappers.$FVF<Int>To$Snap $t@219) $Snap.unit)))
(declare-const i@220 Int)
(declare-fun inv@221 ($Ref) Int)
; Nested auxiliary terms
; Definitional axioms for inverse functions
(assert (forall ((r $Ref)) (!
  (implies
    (and
      (< j@82 (inv@221 r))
      (implies (< j@82 (inv@221 r)) (<= (inv@221 r) $t@216)))
    (= (loc<Array~Int~Ref> $t@214 (inv@221 r)) r))
  :pattern ((inv@221 r))
  :qid |qp.inv@221-imp|)))
(assert (forall ((i@220 Int)) (!
  (implies
    (and (< j@82 i@220) (implies (< j@82 i@220) (<= i@220 $t@216)))
    (= (inv@221 (loc<Array~Int~Ref> $t@214 i@220)) i@220))
  :pattern ((loc<Array~Int~Ref> $t@214 i@220))
  :qid |qp.inv@221-exp|)))
; Receivers are non-null
(assert (forall ((i@220 Int)) (!
  (implies
    (and (< j@82 i@220) (implies (< j@82 i@220) (<= i@220 $t@216)))
    (not (= (loc<Array~Int~Ref> $t@214 i@220) $Ref.null)))
  :pattern ((loc<Array~Int~Ref> $t@214 i@220))
  :qid |qp.null21|)))
; [eval] (j <= t) && (t <= this.size)
; [eval] j <= t
; [eval] (j <= t) ==> (t <= this.size)
; [eval] j <= t
; Joined path conditions
; Joined path conditions
(assert (and (<= j@82 t@178) (implies (<= j@82 t@178) (<= t@178 $t@216))))
; [eval] this.size == old(length(this))
; [eval] old(length(this))
; [eval] length(this)
; Joined path conditions
(assert (= $t@216 (length $t@79 this@74)))
; [eval] (forall i: Int :: { loc(this.elems, i) } (j <= i) && (i <= this.size) ==> (i < t) ==> (loc(this.elems, i).val == old(itemAt(this, i))))
(declare-const i@222 Int)
(declare-const fvf%tot@223 $FVF<Int>)
; Nested auxiliary terms
(assert (forall ((i@222 Int)) (!
  (implies
    (and (<= j@82 i@222) (implies (<= j@82 i@222) (<= i@222 $t@216)))
    (and
      (implies
        (< i@222 t@178)
        (and
          (and
            (<= 0 i@222)
            (implies (<= 0 i@222) (< i@222 (length $t@79 this@74))))
          (and
            (forall ((r $Ref)) (!
              (implies
                (and
                  (< j@82 (inv@221 r))
                  (implies (< j@82 (inv@221 r)) (<= (inv@221 r) $t@216)))
                (= ($FVF.lookup_val fvf%tot@223 r) ($FVF.lookup_val $t@219 r)))
              :pattern (($FVF.lookup_val fvf%tot@223 r))
              ))
            (forall ((r $Ref)) (!
              (implies
                (and
                  (< j@82 (inv@221 r))
                  (implies (< j@82 (inv@221 r)) (<= (inv@221 r) $t@216)))
                (= ($FVF.lookup_val fvf%tot@223 r) ($FVF.lookup_val $t@219 r)))
              :pattern (($FVF.lookup_val $t@219 r))
              )))
          (and
            (forall ((r $Ref)) (!
              (implies
                (ite
                  (= r (loc<Array~Int~Ref> $t@214 j@82))
                  (< $Perm.No (/ (to_real 1) (to_real 2)))
                  false)
                (=
                  ($FVF.lookup_val fvf%tot@223 r)
                  ($FVF.lookup_val fvf%part@218 r)))
              :pattern (($FVF.lookup_val fvf%tot@223 r))
              ))
            (forall ((r $Ref)) (!
              (implies
                (ite
                  (= r (loc<Array~Int~Ref> $t@214 j@82))
                  (< $Perm.No (/ (to_real 1) (to_real 2)))
                  false)
                (=
                  ($FVF.lookup_val fvf%tot@223 r)
                  ($FVF.lookup_val fvf%part@218 r)))
              :pattern (($FVF.lookup_val fvf%part@218 r))
              )))
          (and
            (forall ((r $Ref)) (!
              (implies
                (<
                  $Perm.No
                  (-
                    (-
                      (ite
                        (and
                          (<= 0 (inv@117 r))
                          (implies
                            (<= 0 (inv@117 r))
                            (< (inv@117 r) (len<Array~Int> $t@109))))
                        $Perm.Write
                        $Perm.No)
                      (pTaken30 r))
                    (pTaken31 r)))
                (= ($FVF.lookup_val fvf%tot@223 r) ($FVF.lookup_val $t@115 r)))
              :pattern (($FVF.lookup_val fvf%tot@223 r))
              ))
            (forall ((r $Ref)) (!
              (implies
                (<
                  $Perm.No
                  (-
                    (-
                      (ite
                        (and
                          (<= 0 (inv@117 r))
                          (implies
                            (<= 0 (inv@117 r))
                            (< (inv@117 r) (len<Array~Int> $t@109))))
                        $Perm.Write
                        $Perm.No)
                      (pTaken30 r))
                    (pTaken31 r)))
                (= ($FVF.lookup_val fvf%tot@223 r) ($FVF.lookup_val $t@115 r)))
              :pattern (($FVF.lookup_val $t@115 r))
              )))
          (< i@222 t@178)))
      (and (<= j@82 i@222) (implies (<= j@82 i@222) (<= i@222 $t@216)))))
  :pattern ((loc<Array~Int~Ref> $t@214 i@222))
  :qid |prog.l133-aux|)))
(assert (forall ((i@222 Int)) (!
  (implies
    (and
      (and (<= j@82 i@222) (implies (<= j@82 i@222) (<= i@222 $t@216)))
      (< i@222 t@178))
    (=
      ($FVF.lookup_val fvf%tot@223 (loc<Array~Int~Ref> $t@214 i@222))
      (itemAt ($Snap.combine $t@79 $Snap.unit) this@74 i@222)))
  :pattern ((loc<Array~Int~Ref> $t@214 i@222))
  :qid |prog.l133|)))
; [eval] (forall i: Int :: { loc(this.elems, i) } (j < i) && (i <= this.size) ==> (i > t) ==> (loc(this.elems, i).val == old(itemAt(this, i - 1))))
(declare-const i@224 Int)
; Nested auxiliary terms
(assert (forall ((i@224 Int)) (!
  (implies
    (and (< j@82 i@224) (implies (< j@82 i@224) (<= i@224 $t@216)))
    (and
      (implies
        (> i@224 t@178)
        (and
          (and
            (<= 0 (- i@224 1))
            (implies (<= 0 (- i@224 1)) (< (- i@224 1) (length $t@79 this@74))))
          (and
            (forall ((r $Ref)) (!
              (implies
                (and
                  (< j@82 (inv@221 r))
                  (implies (< j@82 (inv@221 r)) (<= (inv@221 r) $t@216)))
                (= ($FVF.lookup_val fvf%tot@223 r) ($FVF.lookup_val $t@219 r)))
              :pattern (($FVF.lookup_val fvf%tot@223 r))
              ))
            (forall ((r $Ref)) (!
              (implies
                (and
                  (< j@82 (inv@221 r))
                  (implies (< j@82 (inv@221 r)) (<= (inv@221 r) $t@216)))
                (= ($FVF.lookup_val fvf%tot@223 r) ($FVF.lookup_val $t@219 r)))
              :pattern (($FVF.lookup_val $t@219 r))
              )))
          (and
            (forall ((r $Ref)) (!
              (implies
                (ite
                  (= r (loc<Array~Int~Ref> $t@214 j@82))
                  (< $Perm.No (/ (to_real 1) (to_real 2)))
                  false)
                (=
                  ($FVF.lookup_val fvf%tot@223 r)
                  ($FVF.lookup_val fvf%part@218 r)))
              :pattern (($FVF.lookup_val fvf%tot@223 r))
              ))
            (forall ((r $Ref)) (!
              (implies
                (ite
                  (= r (loc<Array~Int~Ref> $t@214 j@82))
                  (< $Perm.No (/ (to_real 1) (to_real 2)))
                  false)
                (=
                  ($FVF.lookup_val fvf%tot@223 r)
                  ($FVF.lookup_val fvf%part@218 r)))
              :pattern (($FVF.lookup_val fvf%part@218 r))
              )))
          (and
            (forall ((r $Ref)) (!
              (implies
                (<
                  $Perm.No
                  (-
                    (-
                      (ite
                        (and
                          (<= 0 (inv@117 r))
                          (implies
                            (<= 0 (inv@117 r))
                            (< (inv@117 r) (len<Array~Int> $t@109))))
                        $Perm.Write
                        $Perm.No)
                      (pTaken30 r))
                    (pTaken31 r)))
                (= ($FVF.lookup_val fvf%tot@223 r) ($FVF.lookup_val $t@115 r)))
              :pattern (($FVF.lookup_val fvf%tot@223 r))
              ))
            (forall ((r $Ref)) (!
              (implies
                (<
                  $Perm.No
                  (-
                    (-
                      (ite
                        (and
                          (<= 0 (inv@117 r))
                          (implies
                            (<= 0 (inv@117 r))
                            (< (inv@117 r) (len<Array~Int> $t@109))))
                        $Perm.Write
                        $Perm.No)
                      (pTaken30 r))
                    (pTaken31 r)))
                (= ($FVF.lookup_val fvf%tot@223 r) ($FVF.lookup_val $t@115 r)))
              :pattern (($FVF.lookup_val $t@115 r))
              )))
          (> i@224 t@178)))
      (and (< j@82 i@224) (implies (< j@82 i@224) (<= i@224 $t@216)))))
  :pattern ((loc<Array~Int~Ref> $t@214 i@224))
  :qid |prog.l134-aux|)))
(assert (forall ((i@224 Int)) (!
  (implies
    (and
      (and (< j@82 i@224) (implies (< j@82 i@224) (<= i@224 $t@216)))
      (> i@224 t@178))
    (=
      ($FVF.lookup_val fvf%tot@223 (loc<Array~Int~Ref> $t@214 i@224))
      (itemAt ($Snap.combine $t@79 $Snap.unit) this@74 (- i@224 1))))
  :pattern ((loc<Array~Int~Ref> $t@214 i@224))
  :qid |prog.l134|)))
; [eval] !(t > j)
; [eval] t > j
(assert (not (> t@178 j@82)))
(set-option :timeout 250)
; (check-sat)
; unknown
; [exec]
; loc(this.elems, j).val := elem
; [eval] loc(this.elems, j)
(declare-const fvf%part@225 $FVF<Int>)
; Precomputing split data for loc[Array,Int,Ref]($t@214, j@82).val # W
(define-fun pTaken40 ((r $Ref)) $Perm
  (ite
    (= r (loc<Array~Int~Ref> $t@214 j@82))
    ($Perm.min
      (ite
        (and
          (< j@82 (inv@221 r))
          (implies (< j@82 (inv@221 r)) (<= (inv@221 r) $t@216)))
        $Perm.Write
        $Perm.No)
      $Perm.Write)
    $Perm.No))
(define-fun pTaken41 ((r $Ref)) $Perm
  (ite
    (= r (loc<Array~Int~Ref> $t@214 j@82))
    ($Perm.min
      (ite
        (= r (loc<Array~Int~Ref> $t@214 j@82))
        (/ (to_real 1) (to_real 2))
        $Perm.No)
      (- $Perm.Write (pTaken40 r)))
    $Perm.No))
(define-fun pTaken42 ((r $Ref)) $Perm
  (ite
    (= r (loc<Array~Int~Ref> $t@214 j@82))
    ($Perm.min
      (-
        (-
          (ite
            (and
              (<= 0 (inv@117 r))
              (implies
                (<= 0 (inv@117 r))
                (< (inv@117 r) (len<Array~Int> $t@109))))
            $Perm.Write
            $Perm.No)
          (pTaken30 r))
        (pTaken31 r))
      (- (- $Perm.Write (pTaken40 r)) (pTaken41 r)))
    $Perm.No))
; Done precomputing, updating quantified heap chunks
; Chunk depleted?
(set-option :timeout 500)
; 0.03s
; (get-info :all-statistics)
; Enough permissions taken?
; 0.00s
; (get-info :all-statistics)
; Chunk depleted?
; 0.00s
; (get-info :all-statistics)
; Enough permissions taken?
; 0.00s
; (get-info :all-statistics)
; Chunk depleted?
; 0.00s
; (get-info :all-statistics)
; Enough permissions taken?
; 0.00s
; (get-info :all-statistics)
; Final check that enough permissions have been taken
; Done splitting
(declare-const fvf%part@226 $FVF<Int>)
(assert (= ($FVF.lookup_val fvf%part@226 (loc<Array~Int~Ref> $t@214 j@82)) elem@75))
(assert (=
  ($FVF.domain_val fvf%part@226)
  ($Set.singleton  (loc<Array~Int~Ref> $t@214 j@82))))
; [exec]
; this.size := this.size + 1
; [eval] this.size + 1
(declare-const size@227 Int)
(assert (= size@227 (+ $t@216 1)))
; [exec]
; fold acc(AList(this), write)
; [eval] 0 <= this.size
(set-option :timeout 0)
; 0.00s
; (get-info :all-statistics)
(assert (<= 0 (+ $t@216 1)))
; [eval] this.size <= len(this.elems)
; [eval] len(this.elems)
; 0.00s
; (get-info :all-statistics)
(assert (<= (+ $t@216 1) (len<Array~Int> $t@214)))
; [eval] 0 < len(this.elems)
; [eval] len(this.elems)
; 0.00s
; (get-info :all-statistics)
(assert (< 0 (len<Array~Int> $t@214)))
(declare-const i@228 Int)
(declare-fun inv@229 ($Ref) Int)
; Nested auxiliary terms
; Check receiver injectivity
(set-option :timeout 0)
; 0.00s
; (get-info :all-statistics)
; Definitional axioms for inverse functions
(assert (forall ((r $Ref)) (!
  (implies
    (and
      (<= 0 (inv@229 r))
      (implies (<= 0 (inv@229 r)) (< (inv@229 r) (len<Array~Int> $t@214))))
    (= (loc<Array~Int~Ref> $t@214 (inv@229 r)) r))
  :pattern ((inv@229 r))
  :qid |qp.inv@229-imp|)))
(assert (forall ((i@228 Int)) (!
  (implies
    (and (<= 0 i@228) (implies (<= 0 i@228) (< i@228 (len<Array~Int> $t@214))))
    (= (inv@229 (loc<Array~Int~Ref> $t@214 i@228)) i@228))
  :pattern ((loc<Array~Int~Ref> $t@214 i@228))
  :qid |qp.inv@229-exp|)))
(declare-const fvf%part@230 $FVF<Int>)
; Precomputing split data for loc[Array,Int,Ref]($t@214, i@228).val # W
(define-fun pTaken43 ((r $Ref)) $Perm
  (ite
    (and
      (<= 0 (inv@229 r))
      (implies (<= 0 (inv@229 r)) (< (inv@229 r) (len<Array~Int> $t@214))))
    ($Perm.min
      (ite (= r (loc<Array~Int~Ref> $t@214 j@82)) $Perm.Write $Perm.No)
      $Perm.Write)
    $Perm.No))
(define-fun pTaken44 ((r $Ref)) $Perm
  (ite
    (and
      (<= 0 (inv@229 r))
      (implies (<= 0 (inv@229 r)) (< (inv@229 r) (len<Array~Int> $t@214))))
    ($Perm.min
      (-
        (ite
          (and
            (< j@82 (inv@221 r))
            (implies (< j@82 (inv@221 r)) (<= (inv@221 r) $t@216)))
          $Perm.Write
          $Perm.No)
        (pTaken40 r))
      (- $Perm.Write (pTaken43 r)))
    $Perm.No))
(define-fun pTaken45 ((r $Ref)) $Perm
  (ite
    (and
      (<= 0 (inv@229 r))
      (implies (<= 0 (inv@229 r)) (< (inv@229 r) (len<Array~Int> $t@214))))
    ($Perm.min
      (-
        (-
          (-
            (ite
              (and
                (<= 0 (inv@117 r))
                (implies
                  (<= 0 (inv@117 r))
                  (< (inv@117 r) (len<Array~Int> $t@109))))
              $Perm.Write
              $Perm.No)
            (pTaken30 r))
          (pTaken31 r))
        (pTaken42 r))
      (- (- $Perm.Write (pTaken43 r)) (pTaken44 r)))
    $Perm.No))
; Done precomputing, updating quantified heap chunks
; Chunk depleted?
(set-option :timeout 500)
; 0.00s
; (get-info :all-statistics)
; Enough permissions taken?
; 0.00s
; (get-info :all-statistics)
; Chunk depleted?
; 0.02s
; (get-info :all-statistics)
; Enough permissions taken?
; 0.00s
; (get-info :all-statistics)
; Chunk depleted?
; 0.03s
; (get-info :all-statistics)
; Enough permissions taken?
; 0.00s
; (get-info :all-statistics)
; Final check that enough permissions have been taken
; Done splitting
; Definitional axioms for field value function
(assert (and
  (forall ((r $Ref)) (!
    (implies
      (and
        (<
          $Perm.No
          (-
            (-
              (-
                (ite
                  (and
                    (<= 0 (inv@117 r))
                    (implies
                      (<= 0 (inv@117 r))
                      (< (inv@117 r) (len<Array~Int> $t@109))))
                  $Perm.Write
                  $Perm.No)
                (pTaken30 r))
              (pTaken31 r))
            (pTaken42 r)))
        ($Set.in r ($FVF.domain_val fvf%part@230)))
      (= ($FVF.lookup_val fvf%part@230 r) ($FVF.lookup_val $t@115 r)))
    :pattern (($FVF.lookup_val fvf%part@230 r) (inv@117 r))
    :qid |qp.fvf#part@230-lookup-2|))
  (forall ((r $Ref)) (!
    (implies
      (and
        (<
          $Perm.No
          (-
            (-
              (-
                (ite
                  (and
                    (<= 0 (inv@117 r))
                    (implies
                      (<= 0 (inv@117 r))
                      (< (inv@117 r) (len<Array~Int> $t@109))))
                  $Perm.Write
                  $Perm.No)
                (pTaken30 r))
              (pTaken31 r))
            (pTaken42 r)))
        ($Set.in r ($FVF.domain_val fvf%part@230)))
      (= ($FVF.lookup_val fvf%part@230 r) ($FVF.lookup_val $t@115 r)))
    :pattern (($FVF.lookup_val $t@115 r) (inv@117 r))
    :qid |qp.fvf#part@230-lookup-2|))))
(assert (and
  (forall ((r $Ref)) (!
    (implies
      (and
        (<
          $Perm.No
          (-
            (ite
              (and
                (< j@82 (inv@221 r))
                (implies (< j@82 (inv@221 r)) (<= (inv@221 r) $t@216)))
              $Perm.Write
              $Perm.No)
            (pTaken40 r)))
        ($Set.in r ($FVF.domain_val fvf%part@230)))
      (= ($FVF.lookup_val fvf%part@230 r) ($FVF.lookup_val $t@219 r)))
    :pattern (($FVF.lookup_val fvf%part@230 r) (inv@221 r))
    :qid |qp.fvf#part@230-lookup-1|))
  (forall ((r $Ref)) (!
    (implies
      (and
        (<
          $Perm.No
          (-
            (ite
              (and
                (< j@82 (inv@221 r))
                (implies (< j@82 (inv@221 r)) (<= (inv@221 r) $t@216)))
              $Perm.Write
              $Perm.No)
            (pTaken40 r)))
        ($Set.in r ($FVF.domain_val fvf%part@230)))
      (= ($FVF.lookup_val fvf%part@230 r) ($FVF.lookup_val $t@219 r)))
    :pattern (($FVF.lookup_val $t@219 r) (inv@221 r))
    :qid |qp.fvf#part@230-lookup-1|))))
(assert (and
  (forall ((r $Ref)) (!
    (implies
      (and
        (= r (loc<Array~Int~Ref> $t@214 j@82))
        ($Set.in r ($FVF.domain_val fvf%part@230)))
      (= ($FVF.lookup_val fvf%part@230 r) ($FVF.lookup_val fvf%part@226 r)))
    :pattern (($FVF.lookup_val fvf%part@230 r))
    :qid |qp.fvf#part@230-lookup-0|))
  (forall ((r $Ref)) (!
    (implies
      (and
        (= r (loc<Array~Int~Ref> $t@214 j@82))
        ($Set.in r ($FVF.domain_val fvf%part@230)))
      (= ($FVF.lookup_val fvf%part@230 r) ($FVF.lookup_val fvf%part@226 r)))
    :pattern (($FVF.lookup_val fvf%part@226 r))
    :qid |qp.fvf#part@230-lookup-0|))))
(assert (forall ((r $Ref)) (!
  (iff
    ($Set.in r ($FVF.domain_val fvf%part@230))
    (and
      (<= 0 (inv@229 r))
      (implies (<= 0 (inv@229 r)) (< (inv@229 r) (len<Array~Int> $t@214)))))
  :pattern (($Set.in r ($FVF.domain_val fvf%part@230)))
  :qid |qp.fvf#part@230-dom-inv@229|)))
(assert (AList%trigger ($Snap.combine
  ($SortWrappers.Array_To$Snap $t@214)
  ($Snap.combine
    ($SortWrappers.IntTo$Snap (+ $t@216 1))
    ($Snap.combine
      $Snap.unit
      ($Snap.combine
        $Snap.unit
        ($Snap.combine $Snap.unit ($SortWrappers.$FVF<Int>To$Snap fvf%part@230)))))) this@74))
; [eval] (0 <= j) && (j < length(this))
; [eval] 0 <= j
; [eval] (0 <= j) ==> (j < length(this))
; [eval] 0 <= j
; Joined path conditions
(set-option :timeout 0)
; 0.00s
; (get-info :all-statistics)
(assert (and
  (<= 0 j@82)
  (implies
    (<= 0 j@82)
    (<
      j@82
      (length ($Snap.combine
        ($SortWrappers.Array_To$Snap $t@214)
        ($Snap.combine
          ($SortWrappers.IntTo$Snap (+ $t@216 1))
          ($Snap.combine
            $Snap.unit
            ($Snap.combine
              $Snap.unit
              ($Snap.combine
                $Snap.unit
                ($SortWrappers.$FVF<Int>To$Snap fvf%part@230)))))) this@74)))))
; [eval] |content(this)| == |old(content(this))| + 1
; [eval] |content(this)|
; [eval] content(this)
; Joined path conditions
; [eval] |old(content(this))| + 1
; [eval] |old(content(this))|
; [eval] old(content(this))
; [eval] content(this)
; Joined path conditions
; 0.00s
; (get-info :all-statistics)
(assert (=
  ($Seq.length
    (content ($Snap.combine
      ($SortWrappers.Array_To$Snap $t@214)
      ($Snap.combine
        ($SortWrappers.IntTo$Snap (+ $t@216 1))
        ($Snap.combine
          $Snap.unit
          ($Snap.combine
            $Snap.unit
            ($Snap.combine
              $Snap.unit
              ($SortWrappers.$FVF<Int>To$Snap fvf%part@230)))))) this@74))
  (+ ($Seq.length (content $t@79 this@74)) 1)))
; [eval] content(this) == old(content(this))[0..j] ++ Seq(elem) ++ old(content(this))[j..]
; [eval] content(this)
; Joined path conditions
; [eval] old(content(this))[0..j] ++ Seq(elem) ++ old(content(this))[j..]
; [eval] old(content(this))[0..j] ++ Seq(elem)
; [eval] old(content(this))[0..j]
; [eval] old(content(this))[..j]
; [eval] old(content(this))
; [eval] content(this)
; Joined path conditions
; [eval] Seq(elem)
(assert (= ($Seq.length ($Seq.singleton elem@75)) 1))
; [eval] old(content(this))[j..]
; [eval] old(content(this))
; [eval] content(this)
; Joined path conditions
(check-sat) ;; [XXXXX] Remove and Z3 terminates immediately
(push) ; 6
; (set-option :smt.qi.profile true)
(set-option :timeout 15000) ;; 15s
(assert (not ($Seq.equal
  (content ($Snap.combine
    ($SortWrappers.Array_To$Snap $t@214)
    ($Snap.combine
      ($SortWrappers.IntTo$Snap (+ $t@216 1))
      ($Snap.combine
        $Snap.unit
        ($Snap.combine
          $Snap.unit
          ($Snap.combine
            $Snap.unit
            ($SortWrappers.$FVF<Int>To$Snap fvf%part@230)))))) this@74)
  ($Seq.append
    ($Seq.append
      ($Seq.drop ($Seq.take (content $t@79 this@74) j@82) 0)
      ($Seq.singleton elem@75))
    ($Seq.drop (content $t@79 this@74) j@82)))))
(check-sat)
; (get-info :all-statistics)
(pop) ; 6