(set-option :print-success true) ; Boogie: false
(set-option :global-decls true) ; Boogie: default
(set-option :AUTO_CONFIG false) ; Usually a good idea
(set-option :SMT.MBQI false)
(set-option :MODEL.V2 true)
(set-option :SMT.PHASE_SELECTION 0)
(set-option :SMT.RESTART_STRATEGY 0)
(set-option :SMT.RESTART_FACTOR |1.5|)
(set-option :SMT.ARITH.RANDOM_INITIAL_VALUE true)
(set-option :SMT.DELAY_UNITS true)
(set-option :SMT.DELAY_UNITS_THRESHOLD 16)
(set-option :NNF.SK_HACK true)
(set-option :SMT.QI.EAGER_THRESHOLD 100)
(set-option :TYPE_CHECK true)
(set-option :SMT.BV.REFLECT true)

(declare-datatypes () ((Natural zero (successor (predecessor Natural)))))

(declare-fun maximum (Natural Natural) Natural)


(assert (forall ((x Natural)) (= (maximum x zero) x)))
(assert (forall ((y Natural)) (= (maximum zero y) y)))
(assert (forall ((x Natural) (y Natural)) (= (maximum (successor x) (successor y)) (successor (maximum x y)))))

(assert (not
	(forall ((a Natural))
		(implies
			(forall ((n Natural))
				(=
					(maximum a n)
					(maximum n a)))
			(forall ((b Natural))
				(=
					(maximum (successor a) b)
					(maximum b (successor a))))))))
(check-sat)