(get-info :version)
; (:version "4.8.0")
; Started: 2019-07-27 13:15:44
; Silicon.version: 1.1-SNAPSHOT (0f51f8ff637f)
; Input file: null
; Verifier id: 00
; ------------------------------------------------------------
; Begin preamble
; ////////// Static preamble
; 
; ; /z3config.smt2
(set-option :print-success true) ; Boogie: false
(set-option :global-decls true) ; Boogie: default
(set-option :auto_config false) ; Usually a good idea
(set-option :smt.mbqi false)
(set-option :model.v2 true)
(set-option :smt.phase_selection 0)
(set-option :smt.restart_strategy 0)
(set-option :smt.restart_factor |1.5|)
(set-option :smt.arith.random_initial_value true)
(set-option :smt.case_split 3)
(set-option :smt.delay_units true)
(set-option :smt.delay_units_threshold 16)
(set-option :nnf.sk_hack true)
(set-option :smt.qi.eager_threshold 100)
(set-option :smt.qi.cost "(+ weight generation)")
(set-option :type_check true)
(set-option :smt.bv.reflect true)
; 
; ; /preamble.smt2
(declare-datatypes () ((
    $Snap ($Snap.unit)
    ($Snap.combine ($Snap.first $Snap) ($Snap.second $Snap)))))
(declare-sort $Ref 0)
(declare-const $Ref.null $Ref)
(declare-sort $FPM)
(declare-sort $PPM)
(define-sort $Perm () Real)
(define-const $Perm.Write $Perm 1.0)
(define-const $Perm.No $Perm 0.0)
(define-fun $Perm.isValidVar ((p $Perm)) Bool
	(<= $Perm.No p))
(define-fun $Perm.isReadVar ((p $Perm) (ub $Perm)) Bool
    (and ($Perm.isValidVar p)
         (not (= p $Perm.No))
         (< p $Perm.Write)))
(define-fun $Perm.min ((p1 $Perm) (p2 $Perm)) Real
    (ite (<= p1 p2) p1 p2))
(define-fun $Math.min ((a Int) (b Int)) Int
    (ite (<= a b) a b))
(define-fun $Math.clip ((a Int)) Int
    (ite (< a 0) 0 a))
; ////////// Sorts
(declare-sort Set<$Ref>)
(declare-sort $FVF<$Ref>)
(declare-sort $PSF<$Snap>)
(declare-sort Set<$Snap>)
; ////////// Sort wrappers
; Declaring additional sort wrappers
(declare-fun $SortWrappers.IntTo$Snap (Int) $Snap)
(declare-fun $SortWrappers.$SnapToInt ($Snap) Int)
(assert (forall ((x Int)) (!
    (= x ($SortWrappers.$SnapToInt($SortWrappers.IntTo$Snap x)))
    :pattern (($SortWrappers.IntTo$Snap x))
    :qid |$Snap.Int|
    )))
(declare-fun $SortWrappers.BoolTo$Snap (Bool) $Snap)
(declare-fun $SortWrappers.$SnapToBool ($Snap) Bool)
(assert (forall ((x Bool)) (!
    (= x ($SortWrappers.$SnapToBool($SortWrappers.BoolTo$Snap x)))
    :pattern (($SortWrappers.BoolTo$Snap x))
    :qid |$Snap.Bool|
    )))
(declare-fun $SortWrappers.$RefTo$Snap ($Ref) $Snap)
(declare-fun $SortWrappers.$SnapTo$Ref ($Snap) $Ref)
(assert (forall ((x $Ref)) (!
    (= x ($SortWrappers.$SnapTo$Ref($SortWrappers.$RefTo$Snap x)))
    :pattern (($SortWrappers.$RefTo$Snap x))
    :qid |$Snap.$Ref|
    )))
(declare-fun $SortWrappers.$PermTo$Snap ($Perm) $Snap)
(declare-fun $SortWrappers.$SnapTo$Perm ($Snap) $Perm)
(assert (forall ((x $Perm)) (!
    (= x ($SortWrappers.$SnapTo$Perm($SortWrappers.$PermTo$Snap x)))
    :pattern (($SortWrappers.$PermTo$Snap x))
    :qid |$Snap.$Perm|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.Set<$Ref>To$Snap (Set<$Ref>) $Snap)
(declare-fun $SortWrappers.$SnapToSet<$Ref> ($Snap) Set<$Ref>)
(assert (forall ((x Set<$Ref>)) (!
    (= x ($SortWrappers.$SnapToSet<$Ref>($SortWrappers.Set<$Ref>To$Snap x)))
    :pattern (($SortWrappers.Set<$Ref>To$Snap x))
    :qid |$Snap.Set<$Ref>|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.$FVF<$Ref>To$Snap ($FVF<$Ref>) $Snap)
(declare-fun $SortWrappers.$SnapTo$FVF<$Ref> ($Snap) $FVF<$Ref>)
(assert (forall ((x $FVF<$Ref>)) (!
    (= x ($SortWrappers.$SnapTo$FVF<$Ref>($SortWrappers.$FVF<$Ref>To$Snap x)))
    :pattern (($SortWrappers.$FVF<$Ref>To$Snap x))
    :qid |$Snap.$FVF<$Ref>|
    )))
; Declaring additional sort wrappers
(declare-fun $SortWrappers.$PSF<$Snap>To$Snap ($PSF<$Snap>) $Snap)
(declare-fun $SortWrappers.$SnapTo$PSF<$Snap> ($Snap) $PSF<$Snap>)
(assert (forall ((x $PSF<$Snap>)) (!
    (= x ($SortWrappers.$SnapTo$PSF<$Snap>($SortWrappers.$PSF<$Snap>To$Snap x)))
    :pattern (($SortWrappers.$PSF<$Snap>To$Snap x))
    :qid |$Snap.$PSF<$Snap>|
    )))
(declare-fun $SortWrappers.Set<$Snap>To$Snap (Set<$Snap>) $Snap)
(declare-fun $SortWrappers.$SnapToSet<$Snap> ($Snap) Set<$Snap>)
(assert (forall ((x Set<$Snap>)) (!
    (= x ($SortWrappers.$SnapToSet<$Snap>($SortWrappers.Set<$Snap>To$Snap x)))
    :pattern (($SortWrappers.Set<$Snap>To$Snap x))
    :qid |$Snap.Set<$Snap>|
    )))
; ////////// Symbols
(declare-fun Set_in ($Ref Set<$Ref>) Bool)
(declare-fun Set_card (Set<$Ref>) Int)
(declare-const Set_empty Set<$Ref>)
(declare-fun Set_singleton ($Ref) Set<$Ref>)
(declare-fun Set_unionone (Set<$Ref> $Ref) Set<$Ref>)
(declare-fun Set_union (Set<$Ref> Set<$Ref>) Set<$Ref>)
(declare-fun Set_disjoint (Set<$Ref> Set<$Ref>) Bool)
(declare-fun Set_difference (Set<$Ref> Set<$Ref>) Set<$Ref>)
(declare-fun Set_intersection (Set<$Ref> Set<$Ref>) Set<$Ref>)
(declare-fun Set_subset (Set<$Ref> Set<$Ref>) Bool)
(declare-fun Set_equal (Set<$Ref> Set<$Ref>) Bool)
; /dafny_axioms/qpp_sets_declarations_dafny.smt2 [Snap]
(declare-fun Set_equal (Set<$Snap> Set<$Snap>) Bool)
(declare-fun Set_in ($Snap Set<$Snap>) Bool)
(declare-fun Set_singleton ($Snap) Set<$Snap>)
; /predicate_snap_functions_declarations.smt2 [AWTwo: Snap]
(declare-fun $PSF.domain_AWTwo ($PSF<$Snap>) Set<$Snap>)
(declare-fun $PSF.lookup_AWTwo ($PSF<$Snap> $Snap) $Snap)
(declare-fun $PSF.after_AWTwo ($PSF<$Snap> $PSF<$Snap>) Bool)
(declare-fun $PSF.loc_AWTwo ($Snap $Snap) Bool)
(declare-fun $PSF.perm_AWTwo ($PPM $Snap) $Perm)
(declare-const $psfTOP_AWTwo $PSF<$Snap>)
; Declaring symbols related to program functions (from program analysis)
(declare-fun isInt ($Snap Int) Bool)
(declare-fun isInt%limited ($Snap Int) Bool)
(declare-fun isInt%stateless (Int) Bool)
; Snapshot variable to be used during function verification
(declare-fun s@$ () $Snap)
; Declaring predicate trigger functions
(declare-fun AWTwo%trigger ($Snap Int Int) Bool)
; ////////// Uniqueness assumptions from domains
; ////////// Axioms
(assert (forall ((s Set<$Ref>)) (!
  (<= 0 (Set_card s))
  :pattern ((Set_card s))
  )))
(assert (forall ((e $Ref)) (!
  (not (Set_in e (as Set_empty  Set<$Ref>)))
  :pattern ((Set_in e (as Set_empty  Set<$Ref>)))
  )))
(assert (forall ((s Set<$Ref>)) (!
  (and
    (= (= (Set_card s) 0) (= s (as Set_empty  Set<$Ref>)))
    (implies (not (= (Set_card s) 0)) (exists ((e $Ref)) (! (Set_in e s)  ))))
  :pattern ((Set_card s))
  )))
(assert (forall ((e $Ref)) (!
  (Set_in e (Set_singleton e))
  :pattern ((Set_singleton e))
  )))
(assert (forall ((e1 $Ref) (e2 $Ref)) (!
  (= (Set_in e1 (Set_singleton e2)) (= e1 e2))
  :pattern ((Set_in e1 (Set_singleton e2)))
  )))
(assert (forall ((e $Ref)) (!
  (= (Set_card (Set_singleton e)) 1)
  :pattern ((Set_card (Set_singleton e)))
  )))
(assert (forall ((s Set<$Ref>) (e $Ref)) (!
  (Set_in e (Set_unionone s e))
  :pattern ((Set_unionone s e))
  )))
(assert (forall ((s Set<$Ref>) (e1 $Ref) (e2 $Ref)) (!
  (= (Set_in e1 (Set_unionone s e2)) (or (= e1 e2) (Set_in e1 s)))
  :pattern ((Set_in e1 (Set_unionone s e2)))
  )))
(assert (forall ((s Set<$Ref>) (e1 $Ref) (e2 $Ref)) (!
  (implies (Set_in e1 s) (Set_in e1 (Set_unionone s e2)))
  :pattern ((Set_in e1 s) (Set_unionone s e2))
  )))
(assert (forall ((s Set<$Ref>) (e $Ref)) (!
  (implies (Set_in e s) (= (Set_card (Set_unionone s e)) (Set_card s)))
  :pattern ((Set_card (Set_unionone s e)))
  )))
(assert (forall ((s Set<$Ref>) (e $Ref)) (!
  (implies
    (not (Set_in e s))
    (= (Set_card (Set_unionone s e)) (+ (Set_card s) 1)))
  :pattern ((Set_card (Set_unionone s e)))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>) (e $Ref)) (!
  (= (Set_in e (Set_union s1 s2)) (or (Set_in e s1) (Set_in e s2)))
  :pattern ((Set_in e (Set_union s1 s2)))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>) (e $Ref)) (!
  (implies (Set_in e s1) (Set_in e (Set_union s1 s2)))
  :pattern ((Set_in e s1) (Set_union s1 s2))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>) (e $Ref)) (!
  (implies (Set_in e s2) (Set_in e (Set_union s1 s2)))
  :pattern ((Set_in e s2) (Set_union s1 s2))
  )))
(assert (and
  (forall ((s1 Set<$Ref>) (s2 Set<$Ref>) (e $Ref)) (!
    (= (Set_in e (Set_intersection s1 s2)) (and (Set_in e s1) (Set_in e s2)))
    :pattern ((Set_in e (Set_intersection s1 s2)))
    ))
  (forall ((s1 Set<$Ref>) (s2 Set<$Ref>) (e $Ref)) (!
    (= (Set_in e (Set_intersection s1 s2)) (and (Set_in e s1) (Set_in e s2)))
    :pattern ((Set_intersection s1 s2) (Set_in e s1))
    ))
  (forall ((s1 Set<$Ref>) (s2 Set<$Ref>) (e $Ref)) (!
    (= (Set_in e (Set_intersection s1 s2)) (and (Set_in e s1) (Set_in e s2)))
    :pattern ((Set_intersection s1 s2) (Set_in e s2))
    ))))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
  (= (Set_union s1 (Set_union s1 s2)) (Set_union s1 s2))
  :pattern ((Set_union s1 (Set_union s1 s2)))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
  (= (Set_union (Set_union s1 s2) s2) (Set_union s1 s2))
  :pattern ((Set_union (Set_union s1 s2) s2))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
  (= (Set_intersection s1 (Set_intersection s1 s2)) (Set_intersection s1 s2))
  :pattern ((Set_intersection s1 (Set_intersection s1 s2)))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
  (= (Set_intersection (Set_intersection s1 s2) s2) (Set_intersection s1 s2))
  :pattern ((Set_intersection (Set_intersection s1 s2) s2))
  )))
(assert (and
  (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
    (=
      (+ (Set_card (Set_union s1 s2)) (Set_card (Set_intersection s1 s2)))
      (+ (Set_card s1) (Set_card s2)))
    :pattern ((Set_card (Set_union s1 s2)))
    ))
  (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
    (=
      (+ (Set_card (Set_union s1 s2)) (Set_card (Set_intersection s1 s2)))
      (+ (Set_card s1) (Set_card s2)))
    :pattern ((Set_card (Set_intersection s1 s2)))
    ))))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>) (e $Ref)) (!
  (= (Set_in e (Set_difference s1 s2)) (and (Set_in e s1) (not (Set_in e s2))))
  :pattern ((Set_in e (Set_difference s1 s2)))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>) (e $Ref)) (!
  (implies (Set_in e s2) (not (Set_in e (Set_difference s1 s2))))
  :pattern ((Set_difference s1 s2) (Set_in e s2))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
  (=
    (Set_subset s1 s2)
    (and
      (forall ((e $Ref)) (!
        (implies (Set_in e s1) (Set_in e s2))
        :pattern ((Set_in e s1))
        ))
      (forall ((e $Ref)) (!
        (implies (Set_in e s1) (Set_in e s2))
        :pattern ((Set_in e s2))
        ))))
  :pattern ((Set_subset s1 s2))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
  (=
    (Set_equal s1 s2)
    (and
      (forall ((e $Ref)) (!
        (= (Set_in e s1) (Set_in e s2))
        :pattern ((Set_in e s1))
        ))
      (forall ((e $Ref)) (!
        (= (Set_in e s1) (Set_in e s2))
        :pattern ((Set_in e s2))
        ))))
  :pattern ((Set_equal s1 s2))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
  (implies (Set_equal s1 s2) (= s1 s2))
  :pattern ((Set_equal s1 s2))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
  (=
    (Set_disjoint s1 s2)
    (and
      (forall ((e $Ref)) (!
        (or (not (Set_in e s1)) (not (Set_in e s2)))
        :pattern ((Set_in e s1))
        ))
      (forall ((e $Ref)) (!
        (or (not (Set_in e s1)) (not (Set_in e s2)))
        :pattern ((Set_in e s2))
        ))))
  :pattern ((Set_disjoint s1 s2))
  )))
(assert (forall ((s1 Set<$Ref>) (s2 Set<$Ref>)) (!
  (and
    (=
      (+
        (+ (Set_card (Set_difference s1 s2)) (Set_card (Set_difference s2 s1)))
        (Set_card (Set_intersection s1 s2)))
      (Set_card (Set_union s1 s2)))
    (=
      (Set_card (Set_difference s1 s2))
      (- (Set_card s1) (Set_card (Set_intersection s1 s2)))))
  :pattern ((Set_card (Set_difference s1 s2)))
  )))
; /predicate_snap_functions_axioms.smt2 [AWTwo: Snap]
(assert (forall ((vs $PSF<$Snap>) (ws $PSF<$Snap>)) (!
    (implies
      (and
        (Set_equal ($PSF.domain_AWTwo vs) ($PSF.domain_AWTwo ws))
        (forall ((x $Snap)) (!
          (implies
            (Set_in x ($PSF.domain_AWTwo vs))
            (= ($PSF.lookup_AWTwo vs x) ($PSF.lookup_AWTwo ws x)))
          :pattern (($PSF.lookup_AWTwo vs x) ($PSF.lookup_AWTwo ws x))
          :qid |qp.$PSF<$Snap>-eq-inner|
          )))
      (= vs ws))
    :pattern (($SortWrappers.$PSF<$Snap>To$Snap vs)
              ($SortWrappers.$PSF<$Snap>To$Snap ws)
              )
    :qid |qp.$PSF<$Snap>-eq-outer|
    )))
(assert (forall ((s $Snap) (pm $PPM)) (!
    ($Perm.isValidVar ($PSF.perm_AWTwo pm s))
    :pattern ($PSF.perm_AWTwo pm s))))
(assert (forall ((s $Snap) (f $Snap)) (!
    (= ($PSF.loc_AWTwo f s) true)
    :pattern ($PSF.loc_AWTwo f s))))
; End preamble
; ------------------------------------------------------------
; State saturation: after preamble
(set-option :timeout 100)
(check-sat)
; unknown
; ------------------------------------------------------------
; Begin function- and predicate-related preamble
; Declaring symbols related to program functions (from verification)
(assert (forall ((s@$ $Snap) (i@0@00 Int)) (!
  (= (isInt%limited s@$ i@0@00) (isInt s@$ i@0@00))
  :pattern ((isInt s@$ i@0@00))
  )))
(assert (forall ((s@$ $Snap) (i@0@00 Int)) (!
  (isInt%stateless i@0@00)
  :pattern ((isInt%limited s@$ i@0@00))
  )))
(assert (forall ((s@$ $Snap) (i@0@00 Int)) (!
  (let ((result@1@00 (isInt%limited s@$ i@0@00))) (= (isInt s@$ i@0@00) true))
  :pattern ((isInt s@$ i@0@00))
  )))
; End function- and predicate-related preamble
; ------------------------------------------------------------
; ---------- test_AWTwo ----------
(push) ; 1
; State saturation: after contract
(set-option :timeout 50)
(check-sat)
; unknown
(push) ; 2
(pop) ; 2
(push) ; 2
; [exec]
; var last: Int
(declare-const last@0@01 Int)
; [exec]
; inhale (forall s: Int, a: Int :: { AWTwo(s, a) } s <= last && isInt(a) ==> acc(AWTwo(s, a), write))
(declare-const s@1@01 Int)
(declare-const a@2@01 Int)
(push) ; 3
; [eval] s <= last && isInt(a)
; [eval] s <= last
(push) ; 4
; [then-branch: 0 | s@1@01 <= last@0@01 | live]
; [else-branch: 0 | !(s@1@01 <= last@0@01) | live]
(push) ; 5
; [then-branch: 0 | s@1@01 <= last@0@01]
(assert (<= s@1@01 last@0@01))
; [eval] isInt(a)
(push) ; 6
(pop) ; 6
; Joined path conditions
(push) ; 6
; [then-branch: 1 | isInt(_, a@2@01) | live]
; [else-branch: 1 | !(isInt(_, a@2@01)) | live]
(push) ; 7
; [then-branch: 1 | isInt(_, a@2@01)]
(assert (isInt $Snap.unit a@2@01))
(pop) ; 7
(push) ; 7
; [else-branch: 1 | !(isInt(_, a@2@01))]
(assert (not (isInt $Snap.unit a@2@01)))
(pop) ; 7
(pop) ; 6
; Joined path conditions
; Joined path conditions
(pop) ; 5
(push) ; 5
; [else-branch: 0 | !(s@1@01 <= last@0@01)]
(assert (not (<= s@1@01 last@0@01)))
(pop) ; 5
(pop) ; 4
; Joined path conditions
; Joined path conditions
(assert (and (isInt $Snap.unit a@2@01) (<= s@1@01 last@0@01)))
(declare-const sm@3@01 $PSF<$Snap>)
; Definitional axioms for snapshot map values
(pop) ; 3
(declare-const $t@4@01 $PSF<$Snap>)
(declare-fun inv@5@01 (Int Int) Int)
(declare-fun inv@6@01 (Int Int) Int)
; Nested auxiliary terms: globals
; Nested auxiliary terms: non-globals
; Definitional axioms for inverse functions
(assert (forall ((s@1@01 Int) (a@2@01 Int)) (!
  (implies
    (and (isInt $Snap.unit a@2@01) (<= s@1@01 last@0@01))
    (and (= (inv@5@01 s@1@01 a@2@01) s@1@01) (= (inv@6@01 s@1@01 a@2@01) a@2@01)))
  :pattern (($PSF.loc_AWTwo ($PSF.lookup_AWTwo $t@4@01 ($Snap.combine
    ($SortWrappers.IntTo$Snap s@1@01)
    ($SortWrappers.IntTo$Snap a@2@01))) ($Snap.combine
    ($SortWrappers.IntTo$Snap s@1@01)
    ($SortWrappers.IntTo$Snap a@2@01))))
  )))
(assert (forall ((sender Int) (amount Int)) (!
  (implies
    (and
      (isInt $Snap.unit (inv@6@01 sender amount))
      (<= (inv@5@01 sender amount) last@0@01))
    (and (= (inv@5@01 sender amount) sender) (= (inv@6@01 sender amount) amount)))
  :pattern ((inv@5@01 sender amount) (inv@6@01 sender amount))
  :qid |AWTwo-fctOfInv|)))
; Permissions are non-negative
(declare-const sm@7@01 $PSF<$Snap>)
; Definitional axioms for snapshot map values
(assert (and
  (forall ((sender Int) (amount Int)) (!
    (implies
      (and
        (isInt $Snap.unit (inv@6@01 sender amount))
        (<= (inv@5@01 sender amount) last@0@01))
      (=
        ($PSF.lookup_AWTwo (as sm@7@01  $PSF<$Snap>) ($Snap.combine
          ($SortWrappers.IntTo$Snap sender)
          ($SortWrappers.IntTo$Snap amount)))
        ($PSF.lookup_AWTwo $t@4@01 ($Snap.combine
          ($SortWrappers.IntTo$Snap sender)
          ($SortWrappers.IntTo$Snap amount)))))
    :pattern (($PSF.lookup_AWTwo (as sm@7@01  $PSF<$Snap>) ($Snap.combine
      ($SortWrappers.IntTo$Snap sender)
      ($SortWrappers.IntTo$Snap amount))))
    :qid |qp.fvfValDef0|))
  (forall ((sender Int) (amount Int)) (!
    (implies
      (and
        (isInt $Snap.unit (inv@6@01 sender amount))
        (<= (inv@5@01 sender amount) last@0@01))
      (=
        ($PSF.lookup_AWTwo (as sm@7@01  $PSF<$Snap>) ($Snap.combine
          ($SortWrappers.IntTo$Snap sender)
          ($SortWrappers.IntTo$Snap amount)))
        ($PSF.lookup_AWTwo $t@4@01 ($Snap.combine
          ($SortWrappers.IntTo$Snap sender)
          ($SortWrappers.IntTo$Snap amount)))))
    :pattern (($PSF.lookup_AWTwo $t@4@01 ($Snap.combine
      ($SortWrappers.IntTo$Snap sender)
      ($SortWrappers.IntTo$Snap amount))))
    :qid |qp.fvfValDef0|))))
(assert (forall ((sender Int) (amount Int)) (!
  ($PSF.loc_AWTwo ($PSF.lookup_AWTwo $t@4@01 ($Snap.combine
    ($SortWrappers.IntTo$Snap sender)
    ($SortWrappers.IntTo$Snap amount))) ($Snap.combine
    ($SortWrappers.IntTo$Snap sender)
    ($SortWrappers.IntTo$Snap amount)))
  :pattern (($PSF.lookup_AWTwo (as sm@7@01  $PSF<$Snap>) ($Snap.combine
    ($SortWrappers.IntTo$Snap sender)
    ($SortWrappers.IntTo$Snap amount))))
  )))
(assert (forall ((sender Int) (amount Int)) (!
  (implies
    (and
      (isInt $Snap.unit (inv@6@01 sender amount))
      (<= (inv@5@01 sender amount) last@0@01))
    ($PSF.loc_AWTwo ($PSF.lookup_AWTwo (as sm@7@01  $PSF<$Snap>) ($Snap.combine
      ($SortWrappers.IntTo$Snap sender)
      ($SortWrappers.IntTo$Snap amount))) ($Snap.combine
      ($SortWrappers.IntTo$Snap sender)
      ($SortWrappers.IntTo$Snap amount))))
  :pattern ((inv@5@01 sender amount) (inv@6@01 sender amount))
  )))
; State saturation: after inhale
(set-option :timeout 20)
(check-sat)
; unknown
; [exec]
; assert perm(AWTwo(last + 1, 0)) == none
; [eval] perm(AWTwo(last + 1, 0)) == none
; [eval] perm(AWTwo(last + 1, 0))
; [eval] last + 1
; Definitional axioms for snapshot map values
(assert ($PSF.loc_AWTwo ($PSF.lookup_AWTwo (as sm@7@01  $PSF<$Snap>) ($Snap.combine
  ($SortWrappers.IntTo$Snap (+ last@0@01 1))
  ($SortWrappers.IntTo$Snap 0))) ($Snap.combine
  ($SortWrappers.IntTo$Snap (+ last@0@01 1))
  ($SortWrappers.IntTo$Snap 0))))
(declare-const pm@8@01 $PPM)
(assert (forall ((sender Int) (amount Int)) (!
  (=
    ($PSF.perm_AWTwo (as pm@8@01  $PPM) ($Snap.combine
      ($SortWrappers.IntTo$Snap sender)
      ($SortWrappers.IntTo$Snap amount)))
    (ite
      (and
        (isInt $Snap.unit (inv@6@01 sender amount))
        (<= (inv@5@01 sender amount) last@0@01))
      $Perm.Write
      $Perm.No))
  :pattern (($PSF.perm_AWTwo (as pm@8@01  $PPM) ($Snap.combine
    ($SortWrappers.IntTo$Snap sender)
    ($SortWrappers.IntTo$Snap amount))))
  )))
(assert (forall ((sender Int) (amount Int)) (!
  (and
    ($PSF.loc_AWTwo ($PSF.lookup_AWTwo (as sm@7@01  $PSF<$Snap>) ($Snap.combine
      ($SortWrappers.IntTo$Snap sender)
      ($SortWrappers.IntTo$Snap amount))) ($Snap.combine
      ($SortWrappers.IntTo$Snap sender)
      ($SortWrappers.IntTo$Snap amount)))
    ($PSF.loc_AWTwo ($PSF.lookup_AWTwo $t@4@01 ($Snap.combine
      ($SortWrappers.IntTo$Snap sender)
      ($SortWrappers.IntTo$Snap amount))) ($Snap.combine
      ($SortWrappers.IntTo$Snap sender)
      ($SortWrappers.IntTo$Snap amount))))
  :pattern (($PSF.perm_AWTwo (as pm@8@01  $PPM) ($Snap.combine
    ($SortWrappers.IntTo$Snap sender)
    ($SortWrappers.IntTo$Snap amount))))
  )))
(set-option :timeout 0)
(push) ; 3
(assert (not (=
  ($PSF.perm_AWTwo (as pm@8@01  $PPM) ($Snap.combine
    ($SortWrappers.IntTo$Snap (+ last@0@01 1))
    ($SortWrappers.IntTo$Snap 0)))
  $Perm.No)))
(check-sat)
; unsat
(pop) ; 3
; 0.00s
; (get-info :all-statistics)
(assert (=
  ($PSF.perm_AWTwo (as pm@8@01  $PPM) ($Snap.combine
    ($SortWrappers.IntTo$Snap (+ last@0@01 1))
    ($SortWrappers.IntTo$Snap 0)))
  $Perm.No))
(pop) ; 2
(pop) ; 1
